/* czas.h
 * Funkcje zwizane z czasem
 *
 * Zaoenia:
 * 1 tura = 1 sekunda (tura upywa kiedy posta o prdkoci 100 przejdzie
 *                        1 pole (mniej-wicej))
 *
 * Czyli mamy tabelk:
 * 1 sekunda = 1      tura
 * 1 minuta  = 60     tur
 * 1 godzina = 3600   tur
 * 1 dzie   = 86400  tur
 *  (...)
 *
 * W turach trzymamy tylko i wycznie czas, ktry upyn od pnocy (bo tak
 *  jest wygodniej).
 */

#ifndef CZAS_H
#define CZAS_H
#include "config.h"


struct _czas {
    long int rok;		/* A co! ;) */
    int miesiac;
    int dzien_miesiaca;
    long int tura;
} czas;

short int dzien;		/* Czy jest jasno */

/* Inicjalizuje funkcje zwizane z czasem */
void init_czasu();

/* Zwraca aktualn godzin */
int godzina();

/* Zwraca aktualn minut */
int minuta();

/* Zwraca aktualn sekund */
int sekunda();

/* Zwraca 1, jeli podany czas jest przeszy, 0, jeli teraniejszy i -1 jeli przyszy */
int bylo(struct _czas *czas);

/* Zwiksza tur */
void tick();

#include "ekran.h"
#include "poziom.h"
#endif
