/* ekran.c */
#include "ekran.h"

/* Przesuwa kursor na fizyczne wsprzdne ekranu */
void przesun_kursor(int x, int y)
{
    wmove(wEkran, y, x);
}

void postaw_kropke()
{
    wprintw(wEkran, ".");
    wrefresh(wEkran);
}

int zapytaj_o_zapis()
{
    struct stat st;
    char nazwa_pliku[1000];
    strcpy(nazwa_pliku, sciezka_do_domowego);
    strcat(nazwa_pliku, "/zapis");
    if (!stat(nazwa_pliku, &st)) {
	dodaj_napis(_("Znalazem zapisany stan gry. Wczyta? (T/N)"));
	if (tolower(pobierz_klawisz()) == _("t - potwierdzenie")[0])
	    return 1;
    }
    return 0;
}

void wyswietl_tekst(char *tekst)
{
    if (tekst[strlen(tekst)] != '\n') {
	strcat(tekst, "\n");
    }
    wypisz_bufor(tekst, 1);
}

void wypisz_klawisze()
{
    char buforzysko[50000];
    char tab[5000];
    sprintf(tab, _("^5%c^4   -   Koniec\n"), k_koniec);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: w lewo do gry\n"), k_lewogora);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: do gry\n"), k_gora);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: w prawo do gry\n"),
	    k_prawogora);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: do gry\n"), k_lewo);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: tam gdzie stoisz\n"),
	    k_centrum);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: w prawo\n"), k_prawo);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: w lewo do dou\n"), k_lewodol);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: do dou\n"), k_dol);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Kierunek: w prawo do dou\n"),
	    k_prawodol);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Zmiana pozycji\n"), k_pozycja);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Twj ekwipunek\n"), k_ekwipunek);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Twoja posta\n"), k_status);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Zamknicie drzwi\n"), k_zamknij);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Otwieranie drzwi\n"), k_otworz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Picie\n"), k_pij);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Podnoszenie przedmiotw\n"), k_podnies);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Odkadanie przedmiotw\n"), k_poloz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Czytanie\n"), k_czytaj);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Zawarto twojego plecaka\n"), k_plecak);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Jedzenie\n"), k_jedz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Schodzenie po schodach\n"), k_zejdz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Wchodzenie po schodach\n"), k_wejdz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Badanie otoczenia\n"), k_patrz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Pacenie\n"), k_plac);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Rozmowa\n"), k_rozmawiaj);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Klawiszologia\n"), k_keymap);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Umiejtnoci\n"), k_umiejetnosci);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c^4   -   Zapis stanu gry\n"), k_zapisz);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c%c^4  -   Wywietlanie bufora komunikatw\n"),
	    k_prefiks, k_bufor);
    strcat(buforzysko, tab);
    sprintf(tab, _("^5%c%c^4  -   Wywietlanie aktualnego czasu\n"),
	    k_prefiks, k_czas);
    strcat(buforzysko, tab);
    wyswietl_tekst(buforzysko);
}

char *pobierz_ciag(char *wynik)
{
    int ile_znakow = 0, koniec = 0, x, y;
    while (!koniec) {
	wynik[ile_znakow] = pobierz_klawisz();
	getyx(wGora, y, x);
	switch (wynik[ile_znakow]) {
	case '\r':
	    koniec = 1;
	    break;
	case '\a':
	    if (ile_znakow > 0) {
		wmove(wGora, y, x - 1);
		waddch(wGora, ' ');
		wmove(wGora, y, x - 1);
		wrefresh(wGora);
		ile_znakow--;
	    }
	    break;
	default:
	    waddch(wGora, wynik[ile_znakow]);
	    wrefresh(wGora);
	    ile_znakow++;
	}
    }
    wynik[ile_znakow] = '\0';
    strcat(gora_stara, wynik);
    strcat(bufor, wynik);
    if (ile_znakow) {
	waddch(wGora, ' ');
	strcat(gora_stara, " ");
	strcat(bufor, " ");
	wrefresh(wGora);
    }
    return wynik;
}

int pobierz_liczbe()
{
    char wynik[10];
    int ile_znakow = 0, koniec = 0, x, y;
    while (!koniec) {
	wynik[ile_znakow] = pobierz_klawisz();
	getyx(wGora, y, x);
	switch (wynik[ile_znakow]) {
	case '\r':
	    koniec = 1;
	    break;
	case '\a':
	    if (ile_znakow > 0) {
		wmove(wGora, y, x - 1);
		waddch(wGora, ' ');
		wmove(wGora, y, x - 1);
		wrefresh(wGora);
		ile_znakow--;
	    }
	    break;
	default:
	    if ((isdigit(wynik[ile_znakow]) && (ile_znakow < 10))) {
		waddch(wGora, wynik[ile_znakow]);
		wrefresh(wGora);
		ile_znakow++;
	    } else
		beep();
	}
    }
    wynik[ile_znakow] = '\0';
    strcat(gora_stara, wynik);
    strcat(bufor, wynik);
    if (ile_znakow) {
	waddch(wGora, ' ');
	strcat(gora_stara, " ");
	strcat(bufor, " ");
	wrefresh(wGora);
    }
    return atoi(wynik);
}

/* dzieli tablic n na linie */
void podziel_na_linijki(char *n, int delta, int linie)
{
    int i = maxx - delta, iold = 0, pomocnicza = maxx - delta, ipom =
	0, z = 0, b, dupa, pierwszy = 1, max2 = maxx + 1;
    char poma[max2];
    poma[0] = '\0';
    b = strlen(n);
    while (i <= b) {
	dupa = 1;
	iold = i - iold;
	if (pomocnicza <= iold) {
	    if (pomocnicza < 2)
		pomocnicza = 2;
	    strncpy(poma, &n[i - iold], pomocnicza - 2);
	    poma[pomocnicza - 1] = '\0';
	    ipom = strlen(poma);
	    while (n[i - iold + dupa] != '\n' && dupa <= ipom)
		dupa++;
	    if (dupa - 1 == ipom) {
		while (n[i - iold + ipom] != ' ' && ipom > 0)
		    ipom--;
		if (!ipom && n[i - iold] != ' ') {
		    char tmp[1001];
		    tmp[0] = '\0';
		    strncpy(tmp, n, i - iold);
		    tmp[i - iold] = '\0';
		    strcat(tmp, " ");
		    strcat(tmp, &n[i - iold]);
		    strncpy(n, tmp, 1000);
		    b++;
		}
		n[i - iold + ipom] = '\n';
	    } else
		ipom = dupa;
	    i = i - iold + ipom;
	    if (z % 3 + linie == 2 && b + linie * maxx + delta > 3 * maxx
		&& pierwszy) {
		z = 0;
		pierwszy = 0;
	    } else if (z % 3 == 2 && b > 3 * maxx && !pierwszy)
		z = 0;
	    else
		z++;
	} else {
	    z++;
	}
	iold = i;
	pomocnicza = maxx;
	i += pomocnicza;
    }
}

/* Sprawdza czy po dodaniu _napis bufor nie jest przepeniony ... */
void czy_bufor_przepelniony(char *_napis)
{
    if (strlen(bufor) + strlen(_napis) >= 50000) {
	char bufor_zap[25000];
	bufor_zap[0] = '\0';
	strncat(bufor_zap, &bufor[25000], 25000);
	bufor[0] = '\0';
	strncat(bufor, bufor_zap, 25000);
    }
}

/* Dodaje adnie dugie komunikaty */
void dodaj_ladnie_komunikat(int delta, int linie)
{
    int i = 0, z = linie, tab[300], a = linie;
    char temp[1000];
    tab[z] = 0;
    while (gora[i] != '\0') {
	if (gora[i] == '\n') {
	    z++;
	    tab[z] = i;
	}
	i++;
    }
    tab[z + 1] = strlen(gora);
    if (z >= 3) {
	while (a <= z) {
	    if (a % 3 == 0 && a != 0) {
		strncpy(temp, &gora[tab[a] + 1], tab[a + 1] - tab[a] - 1);
		temp[tab[a + 1] - tab[a] - 1] = '\0';
	    } else {
		strncpy(temp, &gora[tab[a]], tab[a + 1] - tab[a]);
		temp[tab[a + 1] - tab[a]] = '\0';
	    }
	    wypisz_z_tagami(temp, wGora);
	    temp[0] = '\0';
	    a++;
	    if (a % 3 == 0) {
		if (a <= z) {
		    zmien_kolor(K_ZIELONY, wGora);
		    wmove(wGora, 3, maxx - 20);
		    wprintw(wGora, _("---  Dalej  ---"));
		    zmien_kolor(K_BIALY, wGora);
		}

		wrefresh(wGora);
		while (pobierz_klawisz() != ' ');
		strncpy(temp, &gora[tab[a] + 1], tab[z + 1] - tab[a] - 1);
		temp[tab[z + 1] - tab[a] - 1] = '\0';
		wyczysc_gore();
		strcpy(gora, temp);
		tab[z] = 0;
		while (gora[i] != '\0') {
		    if (gora[i] == '\n') {
			z++;
			tab[z] = i;
		    }
		    i++;
		}
		tab[z + 1] = strlen(gora);
		if (z >= 3) {
		    dodaj_ladnie_komunikat(0, 0);
		} else {
		    wypisz_z_tagami(gora, wGora);
		}
		return;
	    }
	}
    } else
	wypisz_z_tagami(gora, wGora);
    wrefresh(wGora);
}

/* Sprawdza czy dany komunikat si powtarza */
void czy_sie_powtarza_komunikat(char *_napis)
{
    char napis[1000];
    strncpy(napis, _napis, 1000);
    if (!strcmp(napis, _gora)) {
	int ile_cofnac = strlen(kom), ile_jest = strlen(bufor);
	ile_razy_powtorzony++;
	kom[0] = '\0';
	sprintf(kom, "(x%d)\n", ile_razy_powtorzony + 1);
	czy_bufor_przepelniony(kom);
	if ((bufor[ile_jest - 1] == '\n') && (bufor[ile_jest - 2] != ')'))
	    strcpy(&bufor[ile_jest - ile_cofnac - 1], kom);
	else
	    strcpy(&bufor[ile_jest - ile_cofnac], kom);
    } else {
	kom[0] = '\0';
	czy_bufor_przepelniony(_napis);
	if (ile_razy_powtorzony) {
	    int ile_jest = strlen(bufor);
	    if (!strcmp(&bufor[ile_jest - 2], "\n\n"))
		strcpy(&bufor[ile_jest - 1], _napis);
	    else
		strcpy(&bufor[ile_jest], _napis);
	} else {
	    strcat(bufor, _napis);
	}
	ile_razy_powtorzony = 0;
    }
    _gora[0] = '\0';
    strcpy(_gora, napis);
}

/* Wywietla komunikaty w wGora */
void dodaj_napis(char *_napis)
{
    char napis[1000], temp[1000];
    int poczatek = 0, i = 0, linie = 0;
    temp[0] = '\0';
    strncpy(napis, _napis, 1000);
    if (strcmp(napis, "\n"))
	czy_sie_powtarza_komunikat(_napis);
    else {
	czy_bufor_przepelniony(_napis);
	strcat(bufor, _napis);
    }
    if (strcmp(napis, "\n")) {
	strcat(gora, napis);
	while (gora_stara[i] != '\0') {
	    if (gora_stara[i] == '\n') {
		poczatek = i;
		linie++;
	    }
	    i++;
	}
	poczatek = strlen(gora_stara) - poczatek;
	podziel_na_linijki(gora, poczatek, linie % 3);
	dodaj_ladnie_komunikat(poczatek, linie % 3);
    } else {
	wprintw(wGora, napis);
	gora_stara[0] = '\0';
    }
    strcat(gora_stara, gora);
    gora[0] = '\0';
    wrefresh(wGora);
}

/* Inicjalizacja ekranu */
void init()
{
#ifdef CYGWIN
    setenv("TERM", "linux", 1);
#endif
/* Inicjalizacja ncurses */
    initscr();
    maxx = COLS;
    maxy = LINES;
/* Grny pasek (komunikatw) */
    wGora = newwin(4, maxx, 0, 0);
/* Gwne okienko */
    wPoziom = newwin(maxy - 6, maxx, 4, 0);
    poz_maxy = maxy - 6;
    poz_maxx = maxx;
/* Dolny pasek */
    wOpis = newwin(2, maxx, maxy - 2, 0);
    wEnter = newwin(1, 4, maxy - 1, maxx - 10);
/* Cao */
    wEkran = newwin(maxy, maxx, 0, 0);
/* Ncursesowskie parametry okienek i nie tylko */
    scrollok(wGora, 0);
    scrollok(wPoziom, 0);
    scrollok(wOpis, 0);
    scrollok(wEnter, 0);
    scrollok(wEkran, 0);
    notimeout(wEnter, TRUE);
#ifndef _DJGPP
    cbreak();
    noecho();
    intrflush(stdscr, FALSE);
    nonl();
    keypad(stdscr, TRUE);
    keypad(wEnter, TRUE);
#endif
    if (has_colors()) {
	ma_kolory = 1;
	init_kol();
    } else {
	ma_kolory = 0;
    }
/* Do obsugi komunikatw */
    gora[0] = '\0';
    _gora[0] = '\0';
    gora_stara[0] = '\0';
    ile_razy_powtorzony = 0;
    kom[0] = '\0';
}

void zakoncz()
{
    clear();
    refresh();
    endwin();
}

void komunikat(char *kom)
{
    wprintw(wEkran, kom);
    wrefresh(wEkran);
    return;
}

/* Ustawia widoczn w wPoziom cz poziomu */
void ustaw_okienko(struct poziom *Poziom, int x, int y)
{
    if (x + (poz_maxx / 2) - 1 >= Poziom->maxx) {
	Poziom->sx = Poziom->maxx - (poz_maxx - 1);
	Poziom->kx = Poziom->maxx - 1;
    } else {
	if (x - (poz_maxx / 2) < 0) {
	    Poziom->sx = 1;
	    Poziom->kx = poz_maxx - 1;
	} else {
	    Poziom->sx = x - (poz_maxx / 2) + 1;
	    Poziom->kx = x + (poz_maxx / 2) - 1;
	}
    }
    if (y + (poz_maxy / 2) - 1 >= Poziom->maxy) {
	Poziom->sy = Poziom->maxy - (poz_maxy - 1);
	Poziom->ky = Poziom->maxy;
    } else {
	if (y - (poz_maxy / 2) < 0) {
	    Poziom->sy = 1;
	    Poziom->ky = poz_maxy;
	} else {
	    Poziom->sy = y - (poz_maxy / 2) + 1;
	    Poziom->ky = y + (poz_maxy / 2);
	}
    }
    Poziom->sy--;
    Poziom->sx--;
    if (Poziom->sx < 0)
	Poziom->sx = 0;
    if (Poziom->sy < 0)
	Poziom->sy = 0;
    if (Poziom->kx > Poziom->maxx)
	Poziom->kx = Poziom->maxx;
    if (Poziom->ky > Poziom->maxy)
	Poziom->ky = Poziom->maxy;
    Poziom->ky--;
    przerysuj = TRUE;
}

/* Ustawienie kolorw */
void init_kol()
{
    start_color();
    init_pair(K_ZIELONY, COLOR_GREEN, COLOR_BLACK);
    init_pair(K_NIEBIESKI, COLOR_BLUE, COLOR_BLACK);
    init_pair(K_BRAZOWY, COLOR_YELLOW, COLOR_BLACK);
    init_pair(K_BIALY, COLOR_WHITE, COLOR_BLACK);
    init_pair(K_CZERWONY, COLOR_RED, COLOR_BLACK);
    init_pair(K_FIOLETOWY, COLOR_MAGENTA, COLOR_BLACK);
    init_pair(K_CJAN, COLOR_CYAN, COLOR_BLACK);
}

/* Czyszczenie grnego paska */
void wyczysc_gore()
{
    int i;
    wmove(wGora, 0, 0);
    for (i = 1; i <= 4 * maxx; i++)
	waddch(wGora, ' ');
    wrefresh(wGora);
    wmove(wGora, 0, 0);
    gora_stara[0] = '\0';
    gora[0] = '\0';
}

/* Przesuwa widoczn w wPoziom cz poziomu */
void przesun_okienko(struct istota *Postac, struct poziom *Poziom)
{
    if ((Poziom->sx > 0)
	&& ((Postac->x - Poziom->sx) < (Postac->zasieg_widzenia + 4))) {
	Poziom->sx = Poziom->sx - 1;
	Poziom->kx = Poziom->kx - 1;
	przerysuj = TRUE;
    }
    if ((Poziom->kx < Poziom->maxx - 1)
	&& ((Poziom->kx - Postac->x) < (Postac->zasieg_widzenia + 4))) {
	Poziom->sx = Poziom->sx + 1;
	Poziom->kx = Poziom->kx + 1;
	przerysuj = TRUE;
    }
    if ((Poziom->sy > 0)
	&& ((Postac->y - Poziom->sy) < (Postac->zasieg_widzenia + 4))) {
	Poziom->sy = Poziom->sy - 1;
	Poziom->ky = Poziom->ky - 1;
	przerysuj = TRUE;

    }
    if ((Poziom->ky < Poziom->maxy - 1)
	&& ((Poziom->ky - Postac->y) < (Postac->zasieg_widzenia + 4))) {
	Poziom->sy = Poziom->sy + 1;
	Poziom->ky = Poziom->ky + 1;
	przerysuj = TRUE;
    }

}

void rysuj_przedmioty(struct poziom *Poziom, struct przedmioty *Przedmioty)
{
    int licznik, x, y, xold, yold;
    xold = -90;
    yold = 9000;
    Przedmioty->aktualny = Przedmioty->poczatek;
    for (licznik = 1; licznik <= Przedmioty->ile; licznik++) {
	Przedmioty->aktualny = Przedmioty->aktualny->nast;
	x = Przedmioty->aktualny->x;
	y = Przedmioty->aktualny->y;
	if (((x != xold) || (y != yold)) && (x >= Poziom->sx)
	    && (x <= Poziom->kx) && (y >= Poziom->sy) && (y <= Poziom->ky)
	    && /*(Postac->widoczne[x][y]) */ Poziom->widoczne_gracz[x][y]) {	/* czy si mieci (bo jak nie, to po co rysowa) */
	    wmove(wPoziom, y - Poziom->sy, x - Poziom->sx);
	    zmien_kolor(Przedmioty->aktualny->kolor, wPoziom);
	    waddch(wPoziom, przedmiotyID.ID[Przedmioty->aktualny->ID].typ);
	}
	xold = x;
	yold = y;
    }
}

void wyswietl_status(struct istota *Postac)
{
    int i;
    wclear(wEkran);
    zmien_kolor(K_BRAZOWY, wEkran);
    wmove(wEkran, 0, 0);
    wprintw(wEkran, _("                      STATUS\n\n"));
    wprintw(wEkran, _(" Punkty ycia: "));
    zmien_kolor(K_ZOLTY, wEkran);
    wprintw(wEkran, "%d(%d)\n\n", Postac->hp, Postac->hp_max);
    zmien_kolor(K_BRAZOWY, wEkran);
    wprintw(wEkran, _(" Przytomno : "));
    zmien_kolor(K_ZOLTY, wEkran);
    wprintw(wEkran, "%d(%d)\n\n", Postac->przyt, Postac->przyt_max);
    zmien_kolor(K_BRAZOWY, wEkran);
    wprintw(wEkran, _(" Psychika : "));
    zmien_kolor(K_ZOLTY, wEkran);
    wprintw(wEkran, "%d(%d)\n\n", Postac->psych, Postac->psych_max);
    zmien_kolor(K_BRAZOWY, wEkran);
    wprintw(wEkran, _(" Pozycja  : "));
    zmien_kolor(K_ZOLTY, wEkran);
    switch (Postac->pozycja) {
    case POZ_STOI:
	wprintw(wEkran, _("stoi\n\n"));
	break;
    case POZ_KUCA:
	wprintw(wEkran, _("kuca\n\n"));
	break;
    case POZ_LECI:
	wprintw(wEkran, _("leci\n\n"));
	break;
    case POZ_LEZY:
	wprintw(wEkran, _("ley\n\n"));
	break;
    }
    for (i = 0; i < MAXMEKW; i++)
	if (Postac->anatomia.miejsce[i]) {
	    zmien_kolor(K_BRAZOWY, wEkran);
	    switch (i) {
	    case GLOWAS...GLOWAK:
		wprintw(wEkran, _("Gowa: "));
		break;
	    case SZYJAS...SZYJAK:
		wprintw(wEkran, _("Szyja: "));
		break;
	    case KORPUSS...KORPUSK:
		wprintw(wEkran, _("Tuw: "));
		break;
	    case REKAS...REKAK:
		wprintw(wEkran, _("Rka : "));
		break;
	    case NOGAS...NOGAK:
		wprintw(wEkran, _("Noga : "));
		break;
	    default:
		wprintw(wEkran, _("Tajemnicza cz ciaa: "));
		break;
	    }
	    zmien_kolor(K_ZOLTY, wEkran);
	    wprintw(wEkran, "%d (%d)\n",
		    Postac->anatomia.wytrzymalosc[i][0],
		    Postac->anatomia.wytrzymalosc[i][1]);
	}
    wprintw(wEkran, "\n");
    wrefresh(wEkran);
    pobierz_klawisz();
    wclear(wEkran);
    wrefresh(wEkran);
    wyswietl_opis_gracza(&Poziom);
}

int wyswietl_ekwipunek(struct istota *Postac)
{
    int wynik = 0, i, j, /* XXX */ m[25];
    char bufor2[50], key;
    do {
	j = 0;
	wclear(wEkran);
	wmove(wEkran, 0, 0);
	zmien_kolor(K_ZOLTY, wEkran);
	wprintw(wEkran, _("               EKWIPUNEK:\n\n"));
	for (i = 0; i < MAXMEKW; i++)
	    if (Postac->anatomia.miejsce[i]) {
		zmien_kolor(K_ZOLTY, wEkran);
		wprintw(wEkran, "[%c%c] ", tolower(literki[j]),
			toupper(literki[j]));
		m[j] = i;
		j++;
		zmien_kolor(K_BRAZOWY, wEkran);
		switch (i) {
		case GLOWAS...GLOWAK:
		    wprintw(wEkran, _("Gowa: "));
		    break;
		case SZYJAS...SZYJAK:
		    wprintw(wEkran, _("Szyja: "));
		    break;
		case KORPUSS...KORPUSK:
		    wprintw(wEkran, _("Tuw: "));
		    break;
		case REKAS...REKAK:
		    wprintw(wEkran, _("Rka : "));
		    break;
		case NOGAS...NOGAK:
		    wprintw(wEkran, _("Noga : "));
		    break;
		default:
		    wprintw(wEkran, _("Tajemnicza cz ciaa: "));
		    break;
		}
		zmien_kolor(K_BIALY, wEkran);
		if (Postac->ekw.miejsce[i].ile) {
		    for (Postac->ekw.miejsce[i].aktualny =
			 Postac->ekw.miejsce[i].poczatek->nast;
			 Postac->ekw.miejsce[i].aktualny !=
			 Postac->ekw.miejsce[i].koniec;
			 Postac->ekw.miejsce[i].aktualny =
			 Postac->ekw.miejsce[i].aktualny->nast)
			if (!
			    (Postac->ekw.miejsce[i].aktualny->
			     flagi & CZESC))
			    wprintw(wEkran, "%s, ",
				    nazwa_przedmiotu(Postac->ekw.
						     miejsce[i].aktualny,
						     bufor2,
						     PRZYP_MIANOWNIK));
		    wprintw(wEkran, "\b\b");
		}
		wprintw(wEkran, "\n");
	    }
	zmien_kolor(K_BRAZOWY, wEkran);
	wmove(wEkran, maxy - 2, 4);
	zmien_kolor(K_BRAZOWY, wEkran);
	wprintw(wEkran, _("     z - zakocz"));
	zmien_kolor(K_BIALY, wEkran);
	wrefresh(wEkran);
	key = pobierz_klawisz();
	switch (key) {
	case 'a'...'y':
	    if (key - 'a' < j)
		dodaj_do_ekwipunku(Postac, m[key - 'a']);
	    break;
	case 'A'...'Y':
	    if (key - 'A' < j)
		wyjmij_z_ekwipunku(Postac, m[key - 'A']);
	    break;
	}
    }
    while (key != 'z');
    wclear(wEkran);
    wrefresh(wEkran);
    wyswietl_opis_gracza(&Poziom);
    return wynik;
}

void wyswietl_liste_przedmiotow(struct przedmioty *Przedm)
{
    int ile_mamy;
    char buf[100];
    ile_mamy = 0;
    wclear(wEkran);
    wmove(wEkran, 0, 0);
    if (Przedm->ile) {
	for (Przedm->aktualny = Przedm->poczatek->nast;
	     Przedm->aktualny != Przedm->koniec;
	     Przedm->aktualny = Przedm->aktualny->nast) {
	    wprintw(wEkran, " %c) %s", Przedm->aktualny->literka,
		    nazwa_przedmiotu(Przedm->aktualny, buf,
				     PRZYP_MIANOWNIK));
	    if (Przedm->aktualny->flagi & KUPIONE)
		wprintw(wEkran, _(" (do zapaty)"));
	    wprintw(wEkran, "\n");
	    ile_mamy++;
	}
	Przedm->aktualny = Przedm->koniec->poprz;
    }
    wprintw(wEkran, "\nMasz %d przedmiotw(%d).\n", ile_mamy, Przedm->ile);
    wrefresh(wEkran);
    pobierz_klawisz();
    wclear(wEkran);
    wrefresh(wEkran);
    wyswietl_opis_gracza(&Poziom);
}

short int
wybierz_przedmiot(struct przedmioty *Przedm, short int czy_pytac_o_skrot,
		  int flagi, long int klasy)
{
    int koniec = 0, maxl, key;
    int wynik = 0;
    wskaznik_przedmiot tab[26];
    wskaznik_przedmiot pocz;
    char klawisz;
    flagi = ~flagi;
    klasy = ~klasy;
    if (czy_pytac_o_skrot) {
	klawisz = pobierz_klawisz();
	if (klawisz != '\r') {	/* Wybieramy na pami */
	    wynik =
		(szukaj_po_literce(toupper(klawisz), Przedm) == ZNALAZL);
	    if (!wynik) {
		dodaj_napis(_("Nie masz takiego przedmiotu. "));
	    }
	    if ((Przedm->aktualny->flagi & flagi)
		|| (przedmiotyID.
		    ID[Przedm->aktualny->ID].klasa_przedmiotu & klasy)) {
		dodaj_napis(_("Nie moesz uy tego przedmiotu. "));
		wynik = 0;
	    }
	    if (toupper(klawisz) == klawisz && wynik) {	/* Dua litera, zapytajmy si */
		char tmp[100], buf[100], odp;
		sprintf(tmp, _("%s T/N? "),
			nazwa_przedmiotu(Przedm->aktualny, buf,
					 PRZYP_MIANOWNIK));
		dodaj_napis(tmp);
		odp = pobierz_klawisz();
		if (tolower(odp) != _("t - potwierdzenie")[0]) {
		    wynik = 1;
		}
	    }
	    return wynik;
	}
    }
    if (maxy > 26) {
	maxl = 26;
    } else {
	maxl = maxy;
    }
    if (!Przedm->ile) {
	Przedm->aktualny = NULL;
	return 0;
    }
    pocz = Przedm->poczatek->nast;
    while (!koniec) {
	int i = 0, ID;
	char bufor[50];
	wclear(wEkran);
	for (Przedm->aktualny = pocz;
	     (i < maxl) && (Przedm->aktualny != Przedm->koniec);
	     Przedm->aktualny = Przedm->aktualny->nast) {
	    if (!(Przedm->aktualny->flagi & flagi)
		&& !(przedmiotyID.
		     ID[Przedm->aktualny->ID].klasa_przedmiotu & klasy)) {
		tab[i] = Przedm->aktualny;
		if (Przedm->aktualny->literka != ' ') {
		    zmien_kolor(K_BRAZOWY, wEkran);
		    wprintw(wEkran, "[%c] ", Przedm->aktualny->literka);
		    zmien_kolor(K_BIALY, wEkran);
		} else {
		    wprintw(wEkran, "    ");
		}
		ID = Przedm->aktualny->ID;
		zmien_kolor(K_ZOLTY, wEkran);
		wprintw(wEkran, "%c) ", (char) i + 97);
		zmien_kolor(K_BIALY, wEkran);
		wprintw(wEkran, "%s",
			nazwa_przedmiotu(Przedm->aktualny, bufor,
					 PRZYP_MIANOWNIK));
		if (Przedm->aktualny->flagi & KUPIONE)
		    wprintw(wEkran, _(" (do zapaty)"));
		wprintw(wEkran, "\n");
		i++;
	    }
	}
	wrefresh(wEkran);
	key = pobierz_klawisz();
	if (key >= 'a' && key < 'z') {
	    if (key - 'a' <= i) {
		koniec = 1;
		wynik = 1;
		Przedm->aktualny = tab[key - 'a'];
	    }
	} else {
	    if (key >= 'A' && key < 'Z') {
		if (szukaj_po_literce(key, Przedm) == ZNALAZL) {
		    koniec = 1;
		    wynik = 1;
		}
	    }
	    if (key == k_gora || key == KEY_UP) {
		if (pocz->poprz != Przedm->poczatek)
		    pocz = pocz->poprz;
	    }
	    if (key == k_dol || key == KEY_DOWN) {
		if (pocz->nast != Przedm->koniec)
		    pocz = pocz->nast;
	    }
	    if (key == 'z') {
		Przedm->aktualny = NULL;
		koniec = 1;
	    }
	}
    }
    wyczysc_gore();
    refresh_opisu = 1;

    return wynik;
}

void zmien_kolor(int kolor, WINDOW * okno)
{
    int atryb;
    wattroff(okno, WA_DIM | WA_BOLD | WA_BLINK);
    if (ma_kolory) {
	switch (kolor) {
	case K_ZIELONY:
	    atryb = (COLOR_PAIR(K_ZIELONY) | WA_NORMAL);
	    break;
	case K_J_ZIELONY:
	    atryb = (COLOR_PAIR(K_ZIELONY) | WA_BOLD);
	    break;
	case K_C_NIEBIESKI:
	    atryb = (COLOR_PAIR(K_NIEBIESKI) | WA_NORMAL);
	    break;
	case K_NIEBIESKI:
	    atryb = (COLOR_PAIR(K_NIEBIESKI) | WA_BOLD);
	    break;
	case K_BRAZOWY:
	    atryb = (COLOR_PAIR(K_BRAZOWY) | WA_NORMAL);
	    break;
	case K_ZOLTY:
	    atryb = (COLOR_PAIR(K_BRAZOWY) | WA_BOLD);
	    break;
	case K_BIALY:
	    atryb = (COLOR_PAIR(K_BIALY) | WA_NORMAL);
	    break;
	case K_B_BIALY:
	    atryb = (COLOR_PAIR(K_BIALY) | WA_BOLD);
	    break;
	case K_SZARY:
	    atryb = (COLOR_PAIR(K_BIALY) | WA_DIM);
	    break;
	case K_CZERWONY:
	    atryb = (COLOR_PAIR(K_CZERWONY) | WA_NORMAL);
	    break;
	case K_J_CZERWONY:
	    atryb = (COLOR_PAIR(K_CZERWONY) | WA_BOLD);
	    break;
	case K_FIOLETOWY:
	    atryb = (COLOR_PAIR(K_FIOLETOWY) | WA_NORMAL);
	    break;
	case K_ROZOWY:
	    atryb = (COLOR_PAIR(K_FIOLETOWY) | WA_BOLD);
	    break;
	case K_CJAN:
	    atryb = (COLOR_PAIR(K_CJAN) | WA_NORMAL);
	    break;
	case K_J_CJAN:
	    atryb = (COLOR_PAIR(K_CJAN) | WA_BOLD);
	    break;
	default:
	    atryb = 0;
	    break;
	}
    } else {
	switch (kolor) {
	case K_B_BIALY:
	case K_ZOLTY:
	case K_NIEBIESKI:
	    atryb = WA_BOLD;
	    break;
	default:
	    atryb = 0;
	    break;
	}
    }
    wattron(okno, atryb);
}

int szukaj_ostatniego_koloru(char *gdzie, int kolor)
{
    int wynik = kolor, i;
    char tmp[maxx];
    if (strrchr(gdzie, '^')) {
	strncpy(tmp, strrchr(gdzie, '^'), 2);
	i = tmp[1] - 48;
    }
    return wynik;
}

int ile_tagow(char *gdzie)
{
    int wynik = 0, tmp = 0, tmp2, dl = strlen(gdzie);
    while (tmp < dl) {
	tmp2 = strcspn(&gdzie[tmp], "^");
	tmp += tmp2 + 2;
	if (tmp < dl)
	    wynik++;
    }
    return wynik;
}

/* Dzieli bufor na linie */
void podziel_bufor_na_linijki(struct bufor *b, char *bufor)
{
    int i = 0,			/* numer znaku w buforze */
     iold = 0,			/* ilo znakw jak si aktualnie zajmujemy (?) */
     ipom = 0,			/* siaka taka pomocnicza ilo znakw */
     kolor;			/* aktualny kolor */
    char pom[maxx * maxy];	/* !!! Co to jest i czemu takie due? */
    pom[0] = '\0';
    b->tab[b->z = 0] = 0;
    b->kolor[0] = kolor = K_BIALY;
    while (bufor[i] != '\0') {
	if (bufor[i] == '\n') {
	    int tagow;
	    iold = i - iold;
	    strncpy(pom, &bufor[i - iold],
		    strcspn(&bufor[i - iold], "\n"));
	    tagow = ile_tagow(pom);
/* #ifdef DEBUG
	  fprintf(stderr,"tagi: |%s| - %d (iold = %d)\n", pom, tagow, iold);
#endif */
	    if (iold - (tagow * 2) > maxx) {
		strncpy(pom, &bufor[i - iold], maxx + tagow * 2 - 1);	/* Czyli conajwyej nastpnych maxx - 1 znakw */
		pom[maxx + tagow * 2] = '\0';
		tagow = ile_tagow(pom);
		strncpy(pom, &bufor[i - iold], maxx + tagow * 2 - 1);
		pom[maxx + tagow * 2] = '\0';
		ipom = strlen(pom);
		while (bufor[i - iold + ipom] != ' ')	/* Znajdujemy ostatni mieszczc si w tej linijce spacj */
		    ipom--;
		bufor[i - iold + ipom /*+ (tagow*2) */ ] = '\n';
		i = i - iold + ipom + (tagow * 2);
		kolor = szukaj_ostatniego_koloru(pom, kolor);
		b->z++;
		b->tab[b->z] = i;
		b->kolor[b->z] = kolor;
	    } else {
		strncpy(pom, &bufor[i - iold],
			strcspn(&bufor[i - iold], "\n"));
		kolor = szukaj_ostatniego_koloru(pom, kolor);
		b->z++;
		b->tab[b->z] = i;
		b->kolor[b->z] = kolor;
	    }
	    iold = i;
	}
	i++;
    }
}

void wypisz_z_tagami(char *co, WINDOW * okno)
{
    char pom[maxx * maxy * 2];
    int wypisanych = 0, tmp, ile = strlen(co), kolor;
    while (wypisanych < ile) {
	strncpy(pom, &co[wypisanych],
		(tmp = strcspn(&co[wypisanych], "^")));
	pom[tmp] = '\0';
	wypisanych += tmp;
	if (wypisanych < ile)
	    kolor = co[wypisanych + 1] - 48;
	wprintw(okno, pom);
	if (wypisanych < ile)
	    zmien_kolor(kolor, okno);
	wypisanych += 2;
    }
}

/* Wypisuje bufor */
void wypisz_bufor(char *bufor, int kierunek)
{
    char pom[maxx * maxy];
    struct bufor buf;
    int zost, key, x, zmien = 1;
    pom[0] = '\0';
    wclear(wEkran);
    podziel_bufor_na_linijki(&buf, bufor);
    zost = buf.z;
    if (bufor[0] != '\0') {
	if (buf.z - (maxy - 2) < 0) {
	    x = buf.z;
	    buf.z = 0;
	} else {
	    x = (maxy - 2);
	    buf.z -= (maxy - 2);
	}
	if (kierunek) {
	    buf.z = 0;
	}
	do {
	    wmove(wEkran, 0, 0);
	    if (bufor[buf.tab[buf.z]] != '\n' && zmien == 1) {
		strncpy(pom, &bufor[buf.tab[buf.z]],
			buf.tab[buf.z + x] - buf.tab[buf.z]);
		pom[buf.tab[buf.z + x] - buf.tab[buf.z]] = '\0';
		zmien_kolor(buf.kolor[buf.z], wEkran);
		wypisz_z_tagami(pom, wEkran);
	    }
	    if (bufor[buf.tab[buf.z]] == '\n' && zmien == 1) {
		strncpy(pom, &bufor[buf.tab[buf.z] + 1],
			buf.tab[buf.z + x] - buf.tab[buf.z] + 1);
		pom[buf.tab[buf.z + x] - buf.tab[buf.z]] = '\0';
		zmien_kolor(buf.kolor[buf.z], wEkran);
		wypisz_z_tagami(pom, wEkran);
	    }
	    wmove(wEkran, (maxy - 1), 0);
	    zmien_kolor(K_BRAZOWY, wEkran);
	    wprintw(wEkran,
		    _
		    ("z zakocz  + Poprz. strona  - Nast. strona  * Nast. linia  / Poprz. linia"));
	    wrefresh(wEkran);
	    key = pobierz_klawisz();
	    switch (key) {
	    case '+':
		wclear(wEkran);
		if (buf.z + (maxy - 2) + (maxy - 2) < zost)
		    buf.z += (maxy - 2);
		else if (zost - (maxy - 2) >= 0)
		    buf.z = zost - (maxy - 2);
		zmien = 1;

		break;
	    case '-':
		wclear(wEkran);
		if (buf.z - (maxy - 2) >= 0) {
		    buf.z -= (maxy - 2);
		} else
		    buf.z = 0;
		zmien = 1;
		break;
	    case '*':
		if (buf.z + (maxy - 2) < zost)
		    buf.z++;
		zmien = 1;
		wclear(wEkran);
		break;
	    case '/':
		if (buf.z - 1 >= 0)
		    buf.z--;
		zmien = 1;
		wclear(wEkran);
	    case 'z':
		break;
	    default:
		zmien = 0;
		break;
	    }
	}
	while (key != 'z');
	refresh_opisu = 1;
	wclear(wEkran);
	wrefresh(wEkran);
    }
}

/* Wyswietla doln cz ekranu */
void wyswietl_opis(struct istota *Postac)
{
    char najedzony[20];
    char obciazony[20];
    int wsp, i;
    if (!Postac->energia_max) {
	return;
    }
    wsp = (Postac->energia) * 100 / Postac->energia_max;
    if (wsp <= GLODUJACY) {
	strcpy(najedzony, _("GODUJCY"));
    } else {
	if (wsp <= B_GLODNY) {
	    strcpy(najedzony, _("Bardzo godny"));
	} else {
	    if (wsp <= GLODNY) {
		strcpy(najedzony, _("Godny"));
	    } else {
		if (wsp <= SREDNIO_NAJEDZONY) {
		    strcpy(najedzony, "");
		} else {
		    if (wsp <= NAJEDZONY) {
			strcpy(najedzony, _("Najedzony"));
		    } else
			strcpy(najedzony, _("Obarty"));
		}
	    }
	}
    }
    wsp = (Postac->obciazenie * 100) / Postac->obciazenie_max;
    if (wsp < OBCIAZONY) {
	strcpy(obciazony, "");
    } else {
	if (wsp < B_OBCIAZONY) {
	    strcpy(obciazony, _("Obciony"));
	} else {
	    if (wsp < PRZECIAZONY) {
		strcpy(obciazony, _("OBCIONY"));
	    } else {
		strcpy(obciazony, _("PRZECIONY"));
	    }
	}
    }
    wmove(wOpis, 0, 0);
    for (i = 1; i <= 250; i++)
	waddch(wOpis, ' ');
    wrefresh(wOpis);
    wmove(wOpis, 0, 0);
    wprintw(wOpis,
	    _("Si:%d  Zr:%d  Int:%d  Mdr:%d  SW:%d  Wgl:%d %s %s\n"),
	    Postac->wspolczynniki[SILA], Postac->wspolczynniki[ZRECZNOSC],
	    Postac->wspolczynniki[INTELIGENCJA],
	    Postac->wspolczynniki[MADROSC],
	    Postac->wspolczynniki[SILA_WOLI],
	    Postac->wspolczynniki[WYGLAD], najedzony, obciazony);

    wprintw(wOpis,
	    _
	    ("  %s   HP: %d(%d)  PP: %d(%d) Przyt: %d(%d) Au: %d Szb: %d  "),
	    Postac->nazwa, Postac->hp, Postac->hp_max, Postac->pp,
	    Postac->pp_max, Postac->przyt, Postac->przyt_max, Postac->au, Postac->szybkosc, Postac->exp,
	    Postac->poziom);
}
