
#ifndef io_h
#define io_h
#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "keymap.h"
#include "config.h"
#include "ekran_dod.h"
#include "ekran_loc.h"
#include "rozne.h"
#define NIE_KIERUNEK -255
#define MAX_TABLIC_W_PLIKU 1000

/* Proponuj nastpujce rozwizanie nazywania tablic:
   picioliterowa nazwa (w miar dowolna),
   w tym ewentualnie
   cyfra oznaczajca poziom (czyli gboko albo wysoko),
   oraz znak oznaczajcy:
   0 - opis swiata
   1 - poziom
   2 - przedmioty
   3 - potwory (dugo, ze wszystkim)
   4 - tablica ID potworw
   5 - tablica ID przedmiotw
   6 - tablica schematw ekwipunku
   7 - potwory (krtko, tylko pooenie i ID)
   8 - tablica zdarze
   9 - tablica widocznoci
   A - tablica stref
   B - tablica tekstw ksiek
   C - tablica miejsc charakterystycznych
   D - tablica tras
   E - tablica puapek
   F - tablica waciwoci terenu
   G - tablica waciwoci materiaw
   H - przedmioty (krtko)
   I - tablica schematw anatomii
   J - tablica niezidentyfikowanych przedmiotw
   K - tablica wykorzystanych slotw preID (i kolorw tych przedmiotw)
   L - tablica znanych przedmiotw
   ...
 */

/* Pliki...  */
#ifndef NOCOMP
FILE *data;
#endif
FILE *pidfile;
char sciezka_do_tmpliku[1000];
char sciezka_do_domowego[1000];

/* Taka zmienna, dziki ktrej dodaj_do_pliku() nie musi si bawi w co nie powinna */
long int wielkosc_ostatniej_tablicy;

#ifdef LINUX
pid_t pid;
#endif

/* Zmiana pooenia */
struct delta {
    int x;
    int y;
};

/* Nagwek tablicy */
struct __tablica {
    z_off_t offset;
    char ID[6];
    long wielkosc_comp;		/* skompresowana */
    long wielkosc;
};

/* Plik zawierajcy tablice oraz ich nagwki */
struct _plik {
    FILE *strumyk;		/* do odczytu */
    FILE *strumykz;		/* do zapisu */

    /* Bufor do odkompresowanych danych */
    char buforek[MAXTAB];
    long int offset;
    long int wielkosc;

    char nazwa[25];
    int ile_tablic;
    struct __tablica tablica[MAX_TABLIC_W_PLIKU];
} Plik, Pliktmp;


void postaw_kropke();

void init_io();

void zakoncz_io();

void pobierz_kierunek(int klawisz, struct delta *Delta);

int pobierz_klawisz();

short int przerysuj;

void otworz_plik(char nazwa[25], FILE * strumyk, struct _plik *Plik);

/* Ustawia strumie pliku na wskazan przez ID tablic 
 * UWAGA! Ustawia na _ostatni_ tablic pasujc do wzorca. 
 * Zwraca 1 w razie powodzenia */
int ustaw_plik(struct _plik *Plik, char ID[6]);

/* Numer w tablicy ostatnio ustawionego segmentu */
int ustawiony;

/* Dodaje plik "nazwa_pliku" do pliku plik z sygnaturk sygnaturka */
void dodaj_do_pliku(void *co, char *sygnaturka, struct _plik *plik);

/* Przenosi tablic z pliku do pliku */
void dodaj_tablice_do_pliku(char *sygnaturka, struct _plik *wejscie,
			    struct _plik *wyjscie);

/* To s takie mieszne odpowiedniki plikowych funkcji dla cigw */
void sread(struct _plik *skad, void *buf, size_t ile);

int sgetc(struct _plik *skad);
#endif
