/* ksiazki.c */
#include "ksiazki.h"

void przeczytaj_ksiazke(struct istota *Postac, struct przedmiot *Przed)
{
    int numerek;
    /* UM_CZYTANIE > 60 zapewnia przeczytanie ksiki */
    if (losowa(60) < uzyj_umiejetnosci(Postac, UM_CZYTANIE)) {
	switch (Przed->ID) {
	case PRZ_STR_F_KSIAZKA:
	    dodaj_napis(_("Strasznie dziwna ta ksika... "));
	    pobierz_klawisz();
	    numerek = 1;
	    break;
	case PRZ_PODRECZNIK:
	    numerek = 0;
	    break;
	case PRZ_KSIAZKA_KUCHARSKA:
	    numerek = 2;
	default:
	    dodaj_napis(_("No dobra, czytasz sobie ksik. "));
	}
	if (ksiazki.ks[numerek].flagi & MA_TEKST) {
	    wyswietl_tekst(ksiazki.ks[numerek].tekst);
	}
    } else {
	dodaj_napis(_("Nie udao ci si nic zrozumie. "));
    }
    return;
}

void przeczytaj_zwoj(struct istota *Postac, struct przedmiot *Przed)
{
    /* UM_CZYTANIE > 10 zapewnia przeczytanie zwoju */
    if (losowa(10) < uzyj_umiejetnosci(Postac, UM_CZYTANIE)) {
	switch (Przed->ID) {
	case PRZ_ZWOJ_MAGICZNY:
	    dodaj_napis(_("Ten zwj jest strasznie magiczny. "));
	    break;
	}
    } else {
	dodaj_napis(_("Nie udao ci si przeczyta tego zwoju. "));
    }
    return;
}

void init_ksiazek()
{
    ustaw_plik(&Plik, "KSIA0B");
    wczytaj_tablice_ksiazek(&Plik);
}

void wczytaj_tablice_ksiazek(struct _plik *plik)
{
    sread(plik, &ksiazki, sizeof(struct _ksiazki));
}
