/* parser.c */

#include "parser.h"

int init_parser(char *nazwa_pliku)
{
    if ((in = fopen(nazwa_pliku, "rb")) == NULL) {
	return 0;
    }
    strcpy(__nazwa_parsowanego_pliku, nazwa_pliku);
    offset_pocz_kawalka = offset_konca_kawalka = ftell(in);
#ifdef DEBUG_PARSER
    aktualna_linia = 1;
#endif
    return 1;
}

void end_parser()
{
    fclose(in);
}

char *zamien(char *gdzie, char *co, char *na_co)
{
    char buf[1000];
    int l1, l2, l3, l4;
    strcpy(buf, "");
    if (strstr(gdzie, co)) {
	strcpy(buf, strstr(gdzie, co));
    }
    l1 = strlen(gdzie);
    l2 = strlen(buf);
    l3 = strlen(co);
    l4 = strlen(na_co);
    if (!l2) {
	return gdzie;
    }
    strcpy(&gdzie[l1 - l2], na_co);
    strcpy(&gdzie[l1 - l2 + l4], &buf[l3]);
    zamien(gdzie, co, na_co);
    return gdzie;
}

char *liczba_do_ciagu(int liczba, char *buf)
{
    sprintf(buf, "%d", liczba);
    return buf;
}

char *wstaw_define(char *gdzie, int spodziewana_liczba)
{
    char buf[1000];
    switch (spodziewana_liczba) {
    case SP_KOLOR:
	{
	    zamien(gdzie, "K_ZIELONY", liczba_do_ciagu(K_ZIELONY, buf));
	    zamien(gdzie, "K_NIEBIESKI",
		   liczba_do_ciagu(K_NIEBIESKI, buf));
	    zamien(gdzie, "K_BRAZOWY", liczba_do_ciagu(K_BRAZOWY, buf));
	    zamien(gdzie, "K_BIALY", liczba_do_ciagu(K_BIALY, buf));
	    zamien(gdzie, "K_ZOLTY", liczba_do_ciagu(K_ZOLTY, buf));
	    zamien(gdzie, "K_SZARY", liczba_do_ciagu(K_SZARY, buf));
	    zamien(gdzie, "K_CZERWONY", liczba_do_ciagu(K_CZERWONY, buf));
	    zamien(gdzie, "K_FIOLETOWY",
		   liczba_do_ciagu(K_FIOLETOWY, buf));
	    zamien(gdzie, "K_B_BIALY", liczba_do_ciagu(K_B_BIALY, buf));
	    zamien(gdzie, "K_CJAN", liczba_do_ciagu(K_CJAN, buf));
	    zamien(gdzie, "K_C_NIEBIESKI",
		   liczba_do_ciagu(K_C_NIEBIESKI, buf));
	    zamien(gdzie, "K_J_ZIELONY",
		   liczba_do_ciagu(K_J_ZIELONY, buf));
	    zamien(gdzie, "K_J_CZERWONY",
		   liczba_do_ciagu(K_J_CZERWONY, buf));
	    zamien(gdzie, "K_ROZOWY", liczba_do_ciagu(K_ROZOWY, buf));
	    zamien(gdzie, "K_J_CJAN", liczba_do_ciagu(K_J_CJAN, buf));
	};
	break;
    case SP_POZYCJA:
	{
	    zamien(gdzie, "POZ_STOI", liczba_do_ciagu(POZ_STOI, buf));
	    zamien(gdzie, "POZ_LEZY", liczba_do_ciagu(POZ_LEZY, buf));
	    zamien(gdzie, "POZ_KUCA", liczba_do_ciagu(POZ_KUCA, buf));
	    zamien(gdzie, "POZ_LECI", liczba_do_ciagu(POZ_LECI, buf));
	};
	break;
    case SP_FL_POST:
	{
	    zamien(gdzie, "FLAGA_GRACZA",
		   liczba_do_ciagu(FLAGA_GRACZA, buf));
	    zamien(gdzie, "FLAGA_SMIERCI",
		   liczba_do_ciagu(FLAGA_SMIERCI, buf));
	    zamien(gdzie, "FLAGA_WROGOSCI",
		   liczba_do_ciagu(FLAGA_WROGOSCI, buf));
	    zamien(gdzie, "FLAGA_NIERUCHAWOSCI",
		   liczba_do_ciagu(FLAGA_NIERUCHAWOSCI, buf));
	    zamien(gdzie, "FLAGA_POKOJOWOSCI",
		   liczba_do_ciagu(FLAGA_POKOJOWOSCI, buf));
	    zamien(gdzie, "OBSLUGA_DRZWI",
		   liczba_do_ciagu(OBSLUGA_DRZWI, buf));
	    zamien(gdzie, "SKLEPIKARZ", liczba_do_ciagu(SKLEPIKARZ, buf));
	};
	break;
    case SP_AKCJA:
	{
	    zamien(gdzie, "NIC_NIE_ROBI",
		   liczba_do_ciagu(NIC_NIE_ROBI, buf));
	    zamien(gdzie, "SPRZEDAJE", liczba_do_ciagu(SPRZEDAJE, buf));
	    zamien(gdzie, "IDZIE_PO_TOWAR",
		   liczba_do_ciagu(IDZIE_PO_TOWAR, buf));
	    zamien(gdzie, "WRACA_Z_TOWAREM",
		   liczba_do_ciagu(WRACA_Z_TOWAREM, buf));
	    zamien(gdzie, "CZEKA_NA_SKLEPIKARZA",
		   liczba_do_ciagu(CZEKA_NA_SKLEPIKARZA, buf));
	    zamien(gdzie, "SPI", liczba_do_ciagu(SPI, buf));
	    zamien(gdzie, "STOI", liczba_do_ciagu(STOI, buf));
	    zamien(gdzie, "PILNUJE", liczba_do_ciagu(PILNUJE, buf));
	    zamien(gdzie, "PATROLUJE", liczba_do_ciagu(PATROLUJE, buf));
	};
	break;
    case SP_RASA:
	{
	    zamien(gdzie, "CZLOWIEK", liczba_do_ciagu(CZLOWIEK, buf));
	    zamien(gdzie, "KRASNOLUD", liczba_do_ciagu(KRASNOLUD, buf));
	    zamien(gdzie, "WYSOKI_ELF", liczba_do_ciagu(WYSOKI_ELF, buf));
	    zamien(gdzie, "CZARNY_ELF", liczba_do_ciagu(CZARNY_ELF, buf));
	    zamien(gdzie, "ORK", liczba_do_ciagu(ORK, buf));
	    zamien(gdzie, "KOBOLD", liczba_do_ciagu(KOBOLD, buf));
	    zamien(gdzie, "TROLL", liczba_do_ciagu(TROLL, buf));
	    zamien(gdzie, "ZWIERZATKO", liczba_do_ciagu(ZWIERZATKO, buf));
	};
	break;
    case SP_KLASA:
	{
	    zamien(gdzie, "WOJOWNIK", liczba_do_ciagu(WOJOWNIK, buf));
	    zamien(gdzie, "CZARODZIEJ", liczba_do_ciagu(CZARODZIEJ, buf));
	    zamien(gdzie, "BARBARZYNCA",
		   liczba_do_ciagu(BARBARZYNCA, buf));
	    zamien(gdzie, "KLASA_SKLEPIKARZ",
		   liczba_do_ciagu(KLASA_SKLEPIKARZ, buf));
	    zamien(gdzie, "MIESZKANIEC_MIASTA",
		   liczba_do_ciagu(MIESZKANIEC_MIASTA, buf));
	};
	break;
    case SP_PLEC:
	{
	    zamien(gdzie, "KOBIETA", liczba_do_ciagu(KOBIETA, buf));
	    zamien(gdzie, "MEZCZYZNA", liczba_do_ciagu(MEZCZYZNA, buf));
	    zamien(gdzie, "OBOJNAK", liczba_do_ciagu(OBOJNAK, buf));
	    zamien(gdzie, "PLEC_LOSOWA",
		   liczba_do_ciagu(PLEC_LOSOWA, buf));
	    zamien(gdzie, "NIE_DOTYCZY",
		   liczba_do_ciagu(NIE_DOTYCZY, buf));
	};
	break;
    case SP_POTW:
	{
	    zamien(gdzie, "PST_GRACZ", liczba_do_ciagu(PST_GRACZ, buf));
	    zamien(gdzie, "PST_KIBELNIK",
		   liczba_do_ciagu(PST_KIBELNIK, buf));
	    zamien(gdzie, "PST_HIGHLASZ",
		   liczba_do_ciagu(PST_HIGHLASZ, buf));
	    zamien(gdzie, "PST_ZOLNIERZ",
		   liczba_do_ciagu(PST_ZOLNIERZ, buf));
	    zamien(gdzie, "PST_DCA_ZOLNIERZY",
		   liczba_do_ciagu(PST_DCA_ZOLNIERZY, buf));
	    zamien(gdzie, "PST_NIEDZWIEDZ",
		   liczba_do_ciagu(PST_NIEDZWIEDZ, buf));
	    zamien(gdzie, "PST_SKLEPIKARZ",
		   liczba_do_ciagu(PST_SKLEPIKARZ, buf));
	    zamien(gdzie, "PST_GODEL", liczba_do_ciagu(PST_GODEL, buf));
	    zamien(gdzie, "PST_KOBOLD", liczba_do_ciagu(PST_KOBOLD, buf));
	    zamien(gdzie, "PST_ORK", liczba_do_ciagu(PST_ORK, buf));
	    zamien(gdzie, "PST_MN_ORK", liczba_do_ciagu(PST_MN_ORK, buf));
	    zamien(gdzie, "PST_MN_KROLIK",
		   liczba_do_ciagu(PST_MN_KROLIK, buf));
/*	    zamien(gdzie, "PST_DAWACZ", liczba_do_ciagu(PST_DAWACZ, buf));
	    zamien(gdzie, "PST_WIDL", liczba_do_ciagu(PST_WIDL, buf));
	    zamien(gdzie, "PST_DZAMBL", liczba_do_ciagu(PST_DZAMBL, buf));
	    zamien(gdzie, "PST_DONG", liczba_do_ciagu(PST_DONG, buf));
	    zamien(gdzie, "PST_JONGI", liczba_do_ciagu(PST_JONGI, buf));
	    zamien(gdzie, "PST_PISKWACZ",
		   liczba_do_ciagu(PST_PISKWACZ, buf));
	    zamien(gdzie, "PST_KWANGIEL",
		   liczba_do_ciagu(PST_KWANGIEL, buf));
	    zamien(gdzie, "PST_DZIABERLAK",
		   liczba_do_ciagu(PST_DZIABERLAK, buf));
	    zamien(gdzie, "PST_BANDROCHLAP",
		   liczba_do_ciagu(PST_BANDROCHLAP, buf));
	    zamien(gdzie, "PST_STARA_OSTRYGA",
		   liczba_do_ciagu(PST_STARA_OSTRYGA, buf));
	    zamien(gdzie, "PST_ZMIRLACZ",
		   liczba_do_ciagu(PST_ZMIRLACZ, buf));
	    zamien(gdzie, "PST_BUBOLAK",
		   liczba_do_ciagu(PST_BUBOLAK, buf));
	    zamien(gdzie, "PST_DZIUBDZIUB",
		   liczba_do_ciagu(PST_DZIUBDZIUB, buf));
	    zamien(gdzie, "PST_JEDNOROZEC",
		   liczba_do_ciagu(PST_JEDNOROZEC, buf));
	    zamien(gdzie, "PST_GOBLINA",
		   liczba_do_ciagu(PST_GOBLINA, buf));
	    zamien(gdzie, "PST_GREMLIN",
		   liczba_do_ciagu(PST_GREMLIN, buf));
	    zamien(gdzie, "PST_GHUL", liczba_do_ciagu(PST_GHUL, buf));
	    zamien(gdzie, "PST_ZMIJ", liczba_do_ciagu(PST_ZMIJ, buf)); */
	    zamien(gdzie, "PST_MIESZKANIEC_M",
		   liczba_do_ciagu(PST_MIESZKANIEC_M, buf));
	    zamien(gdzie, "PST_MIESZKANIEC_F",
		   liczba_do_ciagu(PST_MIESZKANIEC_F, buf));
	    zamien(gdzie, "PST_STRAZNIK",
		   liczba_do_ciagu(PST_STRAZNIK, buf));
	};
	break;
    case SP_POLE:
	{
	    zamien(gdzie, "DRZWI_ZAMKNIETE",
		   liczba_do_ciagu(DRZWI_ZAMKNIETE, buf));
	    zamien(gdzie, "DRZWI_OTWARTE",
		   liczba_do_ciagu(DRZWI_OTWARTE, buf));
	    zamien(gdzie, "DRZWI_ZAMKNIETE_NA_KLUCZ",
		   liczba_do_ciagu(DRZWI_ZAMKNIETE_NA_KLUCZ, buf));
	    zamien(gdzie, "TRAWA", liczba_do_ciagu(TRAWA, buf));
	    zamien(gdzie, "MUR", liczba_do_ciagu(MUR, buf));
	    zamien(gdzie, "WODA", liczba_do_ciagu(WODA, buf));
	    zamien(gdzie, "DROGA", liczba_do_ciagu(DROGA, buf));
	    zamien(gdzie, "PODLOGA", liczba_do_ciagu(PODLOGA, buf));
	    zamien(gdzie, "ZEJSCIE", liczba_do_ciagu(ZEJSCIE, buf));
	    zamien(gdzie, "WEJSCIE", liczba_do_ciagu(WEJSCIE, buf));
	    zamien(gdzie, "KIBEL", liczba_do_ciagu(KIBEL, buf));
	    zamien(gdzie, "OLTARZ", liczba_do_ciagu(OLTARZ, buf));
	    zamien(gdzie, "NIC", liczba_do_ciagu(NIC, buf));
	    zamien(gdzie, "DRZEWO", liczba_do_ciagu(DRZEWO, buf));
	};
	break;
    case SP_TYP_GEN:
	{
	    zamien(gdzie, "P_LAS", liczba_do_ciagu(P_LAS, buf));
	    zamien(gdzie, "P_POLA", liczba_do_ciagu(P_POLA, buf));
	    zamien(gdzie, "P_SKALA", liczba_do_ciagu(P_SKALA, buf));
	    zamien(gdzie, "P_WODA", liczba_do_ciagu(P_WODA, buf));
	    zamien(gdzie, "P_JASKINIA", liczba_do_ciagu(P_JASKINIA, buf));
	    zamien(gdzie, "P_OST_JASKINIA",
		   liczba_do_ciagu(P_OST_JASKINIA, buf));
	};
	break;
    case SP_FL_POZ:
	{
	    zamien(gdzie, "PRZYBYWAJA_POTWORY",
		   liczba_do_ciagu(PRZYBYWAJA_POTWORY, buf));
	    zamien(gdzie, "GENEROWANE_POTWORY",
		   liczba_do_ciagu(GENEROWANE_POTWORY, buf));
	    zamien(gdzie, "GENEROWANE_PRZEDMIOTY",
		   liczba_do_ciagu(GENEROWANE_PRZEDMIOTY, buf));
	};
	break;
    case SP_FL_TER:
	{
	    zamien(gdzie, "TER_MOZNA_WEJSC",
		   liczba_do_ciagu(TER_MOZNA_WEJSC, buf));
	    zamien(gdzie, "TER_WIDAC_W_CIEMNOSCI",
		   liczba_do_ciagu(TER_WIDAC_W_CIEMNOSCI, buf));
	    zamien(gdzie, "TER_TRAWA", liczba_do_ciagu(TER_TRAWA, buf));
	    zamien(gdzie, "TER_WODA", liczba_do_ciagu(TER_WODA, buf));
	    zamien(gdzie, "TER_MOZNA_OTWORZYC",
		   liczba_do_ciagu(TER_MOZNA_OTWORZYC, buf));
	};
	break;
    case SP_PRZEDM:
	{
	    zamien(gdzie, "PRZ_STR_F_KSIAZKA",
		   liczba_do_ciagu(PRZ_STR_F_KSIAZKA, buf));
	    zamien(gdzie, "PRZ_ZLOTO", liczba_do_ciagu(PRZ_ZLOTO, buf));
	    zamien(gdzie, "PRZ_PAPIER_TOALETOWY",
		   liczba_do_ciagu(PRZ_PAPIER_TOALETOWY, buf));
	    zamien(gdzie, "PRZ_BOSKI_MIECZ",
		   liczba_do_ciagu(PRZ_BOSKI_MIECZ, buf));
	    zamien(gdzie, "PRZ_MIECZ_DWURECZNY",
		   liczba_do_ciagu(PRZ_MIECZ_DWURECZNY, buf));
	    zamien(gdzie, "PRZ_CHLEB", liczba_do_ciagu(PRZ_CHLEB, buf));
	    zamien(gdzie, "PRZ_RACJA", liczba_do_ciagu(PRZ_RACJA, buf));
	    zamien(gdzie, "PRZ_MALY_MIECZ",
		   liczba_do_ciagu(PRZ_MALY_MIECZ, buf));
	    zamien(gdzie, "PRZ_HELM", liczba_do_ciagu(PRZ_HELM, buf));
	    zamien(gdzie, "PRZ_ZBROJA", liczba_do_ciagu(PRZ_ZBROJA, buf));
	    zamien(gdzie, "PRZ_NOZ", liczba_do_ciagu(PRZ_NOZ, buf));
	    zamien(gdzie, "PRZ_MIECZ", liczba_do_ciagu(PRZ_MIECZ, buf));
	    zamien(gdzie, "PRZ_TOPOR", liczba_do_ciagu(PRZ_TOPOR, buf));
	    zamien(gdzie, "PRZ_DZIDA", liczba_do_ciagu(PRZ_DZIDA, buf));
	    zamien(gdzie, "PRZ_DL_NOZ", liczba_do_ciagu(PRZ_DL_NOZ, buf));
	    zamien(gdzie, "PRZ_MLOT", liczba_do_ciagu(PRZ_MLOT, buf));
	    zamien(gdzie, "PRZ_CZAPKA_Z_DASZKIEM",
		   liczba_do_ciagu(PRZ_CZAPKA_Z_DASZKIEM, buf));
	    zamien(gdzie, "PRZ_CIEPLA_CZAPKA",
		   liczba_do_ciagu(PRZ_CIEPLA_CZAPKA, buf));
	    zamien(gdzie, "PRZ_HELM_Z_PIOROPUSZEM",
		   liczba_do_ciagu(PRZ_HELM_Z_PIOROPUSZEM, buf));
/*	    zamien(gdzie, "PRZ_SKORZANA_ZBROJA",
		   liczba_do_ciagu(PRZ_SKORZANA_ZBROJA, buf)); */
	    zamien(gdzie, "PRZ_KOLCZUGA",
		   liczba_do_ciagu(PRZ_KOLCZUGA, buf));
	    zamien(gdzie, "PRZ_BUT_SKORZANY",
		   liczba_do_ciagu(PRZ_BUT_SKORZANY, buf));
	    zamien(gdzie, "PRZ_SANDAL", liczba_do_ciagu(PRZ_SANDAL, buf));
	    zamien(gdzie, "PRZ_CIEZKI_BUT",
		   liczba_do_ciagu(PRZ_CIEZKI_BUT, buf));
	    zamien(gdzie, "PRZ_OKRAGLA_TARCZA",
		   liczba_do_ciagu(PRZ_OKRAGLA_TARCZA, buf));
	    zamien(gdzie, "PRZ_PODRECZNIK",
		   liczba_do_ciagu(PRZ_PODRECZNIK, buf));
	    zamien(gdzie, "PRZ_KSIAZKA_KUCHARSKA",
		   liczba_do_ciagu(PRZ_KSIAZKA_KUCHARSKA, buf));
	};
	break;
    case SP_FL_PRZEDM:
	{
	    zamien(gdzie, "JEDZENIE", liczba_do_ciagu(JEDZENIE, buf));
	    zamien(gdzie, "KUPIONE", liczba_do_ciagu(KUPIONE, buf));
	    zamien(gdzie, "NIE_POKAZUJ_MATERIALU",
		   liczba_do_ciagu(NIE_POKAZUJ_MATERIALU, buf));
	    zamien(gdzie, "KOPIOWANY", liczba_do_ciagu(KOPIOWANY, buf));
	};
	break;
    case SP_KL_PRZEDM:
	{
	    zamien(gdzie, "KL_BR_JEDN", liczba_do_ciagu(KL_BR_JEDN, buf));
	    zamien(gdzie, "KL_BR_DWUR", liczba_do_ciagu(KL_BR_DWUR, buf));
	    zamien(gdzie, "KL_LUK", liczba_do_ciagu(KL_LUK, buf));
	    zamien(gdzie, "KL_KUSZA", liczba_do_ciagu(KL_KUSZA, buf));
	    zamien(gdzie, "KL_JEDZENIE",
		   liczba_do_ciagu(KL_JEDZENIE, buf));
	    zamien(gdzie, "KL_NAKR_GLOWY",
		   liczba_do_ciagu(KL_NAKR_GLOWY, buf));
	    zamien(gdzie, "KL_PANCERZ", liczba_do_ciagu(KL_PANCERZ, buf));
	    zamien(gdzie, "KL_KSIAZKA", liczba_do_ciagu(KL_KSIAZKA, buf));
	    zamien(gdzie, "KL_ZLOTO", liczba_do_ciagu(KL_ZLOTO, buf));
	    zamien(gdzie, "KL_ROZNE", liczba_do_ciagu(KL_ROZNE, buf));
	    zamien(gdzie, "KL_BUTY", liczba_do_ciagu(KL_BUTY, buf));
	    zamien(gdzie, "KL_TARCZE", liczba_do_ciagu(KL_TARCZE, buf));
	    zamien(gdzie, "KL_ZWOJ", liczba_do_ciagu(KL_ZWOJ, buf));
	    zamien(gdzie, "KL_NAPOJ", liczba_do_ciagu(KL_NAPOJ, buf));
	    zamien(gdzie, "KL_AMUNICJA",
		   liczba_do_ciagu(KL_AMUNICJA, buf));
	};
	break;
    case SP_PODKL_PRZEDM:
	{
	    zamien(gdzie, "PODKL_MIECZ",
		   liczba_do_ciagu(PODKL_MIECZ, buf));
	    zamien(gdzie, "PODKL_NOZ", liczba_do_ciagu(PODKL_NOZ, buf));
	    zamien(gdzie, "PODKL_DZIDA",
		   liczba_do_ciagu(PODKL_DZIDA, buf));
	    zamien(gdzie, "PODKL_MLOT", liczba_do_ciagu(PODKL_MLOT, buf));
	    zamien(gdzie, "PODKL_TOPOR",
		   liczba_do_ciagu(PODKL_TOPOR, buf));
	    zamien(gdzie, "PODKL_KIJ", liczba_do_ciagu(PODKL_KIJ, buf));
	    zamien(gdzie, "PODKL_MIECZ_DWUR",
		   liczba_do_ciagu(PODKL_MIECZ_DWUR, buf));
	    zamien(gdzie, "PODKL_KIJ_DWUR",
		   liczba_do_ciagu(PODKL_KIJ_DWUR, buf));
	    zamien(gdzie, "PODKL_BIELIZNA",
		   liczba_do_ciagu(PODKL_BIELIZNA, buf));
	    zamien(gdzie, "PODKL_KOLCZUGA",
		   liczba_do_ciagu(PODKL_KOLCZUGA, buf));
	    zamien(gdzie, "PODKL_PANCERZ",
		   liczba_do_ciagu(PODKL_PANCERZ, buf));
	    zamien(gdzie, "PODKL_SZATA",
		   liczba_do_ciagu(PODKL_SZATA, buf));
	    zamien(gdzie, "PODKL_STRZALY",
		   liczba_do_ciagu(PODKL_STRZALY, buf));
	    zamien(gdzie, "PODKL_BELTY",
		   liczba_do_ciagu(PODKL_BELTY, buf));
	    zamien(gdzie, "PODKL_KAMIENIE",
		   liczba_do_ciagu(PODKL_KAMIENIE, buf));
	}
    case SP_MAT:
	{
	    zamien(gdzie, "MAT_PLOTNO", liczba_do_ciagu(MAT_PLOTNO, buf));
	    zamien(gdzie, "MAT_SKORA", liczba_do_ciagu(MAT_SKORA, buf));
	    zamien(gdzie, "MAT_UTWARDZONA_SKORA",
		   liczba_do_ciagu(MAT_UTWARDZONA_SKORA, buf));
	    zamien(gdzie, "MAT_DREWNO", liczba_do_ciagu(MAT_DREWNO, buf));
	    zamien(gdzie, "MAT_JEDWAB", liczba_do_ciagu(MAT_JEDWAB, buf));
	    zamien(gdzie, "MAT_SZKLO", liczba_do_ciagu(MAT_SZKLO, buf));
	    zamien(gdzie, "MAT_KRYSZTAL",
		   liczba_do_ciagu(MAT_KRYSZTAL, buf));
	    zamien(gdzie, "MAT_URAN", liczba_do_ciagu(MAT_URAN, buf));
	    zamien(gdzie, "MAT_PAPIER", liczba_do_ciagu(MAT_PAPIER, buf));
	    zamien(gdzie, "MAT_BRAZ", liczba_do_ciagu(MAT_BRAZ, buf));
	    zamien(gdzie, "MAT_ZELAZO", liczba_do_ciagu(MAT_ZELAZO, buf));
	    zamien(gdzie, "MAT_STAL", liczba_do_ciagu(MAT_STAL, buf));
	    zamien(gdzie, "MAT_SREBRO", liczba_do_ciagu(MAT_SREBRO, buf));
	    zamien(gdzie, "MAT_ZLOTO", liczba_do_ciagu(MAT_ZLOTO, buf));
	    zamien(gdzie, "MAT_CYNA", liczba_do_ciagu(MAT_CYNA, buf));
	    zamien(gdzie, "MAT_OLOW", liczba_do_ciagu(MAT_OLOW, buf));
	    zamien(gdzie, "MAT_ZELIWO", liczba_do_ciagu(MAT_ZELIWO, buf));
	    zamien(gdzie, "MAT_MIEDZ", liczba_do_ciagu(MAT_MIEDZ, buf));
	    zamien(gdzie, "MAT_CYNK", liczba_do_ciagu(MAT_CYNK, buf));
	    zamien(gdzie, "MAT_MOSIADZ",
		   liczba_do_ciagu(MAT_MOSIADZ, buf));
	    zamien(gdzie, "MAT_TYTAN", liczba_do_ciagu(MAT_TYTAN, buf));
	    zamien(gdzie, "MAT_IRYD", liczba_do_ciagu(MAT_IRYD, buf));
	    zamien(gdzie, "MAT_KEVLAR", liczba_do_ciagu(MAT_KEVLAR, buf));
	    zamien(gdzie, "MAT_KRYPTONIT",
		   liczba_do_ciagu(MAT_KRYPTONIT, buf));
	    zamien(gdzie, "MAT_ADAMANIT",
		   liczba_do_ciagu(MAT_ADAMANIT, buf));
	    zamien(gdzie, "MAT_JEDZENIE",
		   liczba_do_ciagu(MAT_JEDZENIE, buf));
	};
    case SP_PUL:
	{
	    zamien(gdzie, "PUL_BRAK", liczba_do_ciagu(PUL_BRAK, buf));
	    zamien(gdzie, "PUL_DOL", liczba_do_ciagu(PUL_DOL, buf));
	};
	break;
    case SP_STR:
	{
	    zamien(gdzie, "BRAK", liczba_do_ciagu(BRAK, buf));
	    zamien(gdzie, "SKLEP", liczba_do_ciagu(SKLEP, buf));
	};
	break;
    case SP_SKLEP:
	{
	    zamien(gdzie, "SPOZYWCZY", liczba_do_ciagu(SPOZYWCZY, buf));
	    zamien(gdzie, "Z_BRONIA", liczba_do_ciagu(Z_BRONIA, buf));
	    zamien(gdzie, "Z_PANCERZAMI",
		   liczba_do_ciagu(Z_PANCERZAMI, buf));
	};
	break;
    case SP_UMIEJ:
	{
/*	    zamien(gdzie, "PLYWANIE", liczba_do_ciagu(PLYWANIE, buf));
	    zamien(gdzie, "STOLARSTWO", liczba_do_ciagu(STOLARSTWO, buf));
	    zamien(gdzie, "KOWALSTWO", liczba_do_ciagu(KOWALSTWO, buf));
	    zamien(gdzie, "CZYTANIE", liczba_do_ciagu(CZYTANIE, buf)); */
	};
	break;
    case SP_WSP:
	{
	    zamien(gdzie, "SILA", liczba_do_ciagu(SILA, buf));
	    zamien(gdzie, "ZRECZNOSC", liczba_do_ciagu(ZRECZNOSC, buf));
	    zamien(gdzie, "INTELIGENCJA",
		   liczba_do_ciagu(INTELIGENCJA, buf));
	    zamien(gdzie, "MADROSC", liczba_do_ciagu(MADROSC, buf));
	    zamien(gdzie, "SILA_WOLI", liczba_do_ciagu(SILA_WOLI, buf));
	    zamien(gdzie, "CHARYZMA", liczba_do_ciagu(CHARYZMA, buf));
	    zamien(gdzie, "WYGLAD", liczba_do_ciagu(WYGLAD, buf));
	};
	break;
    case SP_FL_KS:
	{
	    zamien(gdzie, "MA_TEKST", liczba_do_ciagu(MA_TEKST, buf));
	};
	break;
    case SP_RODZAJ:
	{
	    zamien(gdzie, "RDZ_MESKI", liczba_do_ciagu(RDZ_MESKI, buf));
	    zamien(gdzie, "RDZ_ZENSKI", liczba_do_ciagu(RDZ_ZENSKI, buf));
	    zamien(gdzie, "RDZ_NIJAKI", liczba_do_ciagu(RDZ_NIJAKI, buf));
	}
    case SP_M_ANAT:
	{
	    zamien(gdzie, "GLOWAS", liczba_do_ciagu(GLOWAS, buf));
	    zamien(gdzie, "GLOWAK", liczba_do_ciagu(GLOWAK, buf));
	    zamien(gdzie, "NOGAS", liczba_do_ciagu(NOGAS, buf));
	    zamien(gdzie, "NOGAK", liczba_do_ciagu(NOGAS, buf));
	    zamien(gdzie, "KORPUSS", liczba_do_ciagu(KORPUSS, buf));
	    zamien(gdzie, "KORPUSK", liczba_do_ciagu(KORPUSS, buf));
	    zamien(gdzie, "SZYJAS", liczba_do_ciagu(SZYJAS, buf));
	    zamien(gdzie, "SZYJAK", liczba_do_ciagu(SZYJAS, buf));
	    zamien(gdzie, "REKAS", liczba_do_ciagu(REKAS, buf));
	    zamien(gdzie, "REKAK", liczba_do_ciagu(REKAS, buf));
	}
    }
    return gdzie;
}

char *wytnij_komentarze(char *z_czego)
{
    char wynik[100000];
    int cudzysl = 0, pojedyn = 0, eskejp = 0, l = 0, koniec = 0;
    while (!koniec) {
	if (!eskejp) {
	    if (!pojedyn) {
		if (z_czego[0] == '"') {
		    cudzysl = !cudzysl;
		}
	    }
	    if (!cudzysl) {
		if (z_czego[0] == '\'') {
		    pojedyn = !pojedyn;
		}

	    }
	    if (z_czego[0] == '\\') {
		eskejp = 1;
	    }
	    if (!cudzysl && !pojedyn) {
		if (z_czego[0] != KOMENTARZ) {
		    wynik[l] = z_czego[0];
		} else {
		    koniec = 1;
		}
	    } else {
		wynik[l] = z_czego[0];
	    }
	} else {
	    wynik[l] = z_czego[0];
	    eskejp = 0;
	}
	z_czego++;
	l++;
	koniec += !strlen(z_czego);
    }
    wynik[l - 1] = '\0';
    strcpy(z_czego, wynik);
    return z_czego;
}

int ustaw_kawalek(char *poczatek, char *koniec)
{
    char buforek[100001];
    int ok = 0;
#ifdef DEBUG_PARSER
    aktualna_linia += linia_konca_kawalka;
#endif
    /* Znajdujemy pocztek */
    while (!ok) {
	if (feof(in)) {
	    return 1;
	}
	offset_pocz_kawalka = ftell(in);
	fgets(buforek, 100000, in);
	strcpy(buforek, wytnij_komentarze(buforek));
	if (strstr(buforek, poczatek) != NULL) {
#ifdef DEBUG_PARSER
	    linia_w_kawalku = 0;
#endif
	    ok = 1;
	}
#ifdef DEBUG_PARSER
	aktualna_linia++;
#endif
    }
    /* ... i koniec */
    ok = 0;
#ifdef DEBUG_PARSER
    linia_konca_kawalka = 0;
#endif
    fseek(in, offset_pocz_kawalka, SEEK_SET);
    while (!ok) {
	offset_konca_kawalka = ftell(in);
	fgets(buforek, 100000, in);
	strcpy(buforek, wytnij_komentarze(buforek));
	if (strstr(buforek, koniec) != NULL) {
	    ok = 1;
	}
	if (feof(in)) {
	    ok = 1;		/* niech bdzie... znaczy, e niedokoczony kawaek na kocu pliku bdzie sparsowany tak jakby mia zakoczenie */
	}
#ifdef DEBUG_PARSER
	if (!ok)
	    linia_konca_kawalka++;
#endif
    }
    return 0;
}

int wybierz_liczbe(char *buf)
{
    int wynik = 0, i = 0, j, l;
    char buf2[100];
    zamien(buf, " ", "");
    l = strlen(buf);
    while (i < l) {
	j = strcspn(&buf[i], "|+");
	strncpy(buf2, &buf[i], j);
	buf2[j + 1] = '\0';
	wynik += atoi(buf2);
	i += j + 1;
    }
    return wynik;
}

int parser_liczba(char *nazwa_pola, int numer_pola, int domyslna, int typ)
{
    char buforek[100001];
    int wynik = domyslna;
#ifdef DEBUG_PARSER
    int udalo_sie = 0;
#endif
/*  if (!(buforek = (char *) my_malloc (100001)))
  {
	  fprintf(stderr, "Zabrako pamici, parser_liczba()... ");
	  exit(1);
  };*/
    fseek(in, offset_pocz_kawalka, SEEK_SET);
#ifdef DEBUG_PARSER
    linia_w_kawalku = 0;
#endif
    while (offset_konca_kawalka >= ftell(in)) {
	fgets(buforek, 100000, in);
	strcpy(buforek, wytnij_komentarze(buforek));
	strcpy(buforek, wstaw_define(buforek, typ));
	if (strstr(buforek, nazwa_pola) != NULL) {
	    int tmp = 1;
#ifdef DEBUG_PARSER
	    udalo_sie = 1;
#endif
	    strcpy(buforek, strstr(buforek, nazwa_pola));
	    strcpy(buforek, buforek + strlen(nazwa_pola));
	    while (tmp < numer_pola) {
		if (strchr(buforek, ',') == NULL) {
#ifdef DEBUG_PARSER
		    fprintf(stderr,
			    "Ostrzeenie: pole: %s %s(%ld)[%d - %d], nie ma parametru %d, przyjmuj warto domyln (%d)...\n",
			    nazwa_pola, __nazwa_parsowanego_pliku,
			    aktualna_linia + linia_w_kawalku - 1,
			    (int) offset_pocz_kawalka,
			    (int) offset_konca_kawalka, numer_pola, wynik);
#endif
		    return wynik;
		}
		strcpy(buforek, strchr(buforek, ','));
		strcpy(buforek, buforek + 1);
		tmp++;
	    }
	    wynik = wybierz_liczbe(buforek);
	}
#ifdef DEBUG_PARSER
	linia_w_kawalku++;
#endif
    }
#ifdef DEBUG_PARSER
    if (!udalo_sie) {
	fprintf(stderr,
		"Ostrzeenie: Nie mog znale pola: %s %s(%ld - %ld)[%d - %d], przyjmuj warto domyln (%d)...\n",
		nazwa_pola, __nazwa_parsowanego_pliku,
		aktualna_linia - 1,
		aktualna_linia + linia_konca_kawalka - 1,
		(int) offset_pocz_kawalka, (int) offset_konca_kawalka,
		wynik);
    }
#endif
    return wynik;
}

char parser_znak(char *nazwa_pola, int numer_pola, char domyslna)
{
    char buforek[100001];
    char wynik = domyslna;
#ifdef DEBUG_PARSER
    int udalo_sie = 0;
#endif
/*  if (!(buforek = (char *) my_malloc (100001)))
  {
	  fprintf(stderr, "Zabrako pamici, parser_znak()... ");
	  exit(1);
  }; */
    fseek(in, offset_pocz_kawalka, SEEK_SET);
#ifdef DEBUG_PARSER
    linia_w_kawalku = 0;
#endif
    while (offset_konca_kawalka >= ftell(in)) {
	fgets(buforek, 100000, in);
	strcpy(buforek, wytnij_komentarze(buforek));
	if (strstr(buforek, nazwa_pola) != NULL) {
	    int tmp = 1;
#ifdef DEBUG_PARSER
	    udalo_sie = 1;
#endif
	    strcpy(buforek, strstr(buforek, nazwa_pola));
	    strcpy(buforek, buforek + strlen(nazwa_pola));
	    while (tmp < numer_pola) {
		if (strcpy(buforek, strchr(buforek, ',')) == NULL) {
#ifdef DEBUG_PARSER
		    fprintf(stderr,
			    "Ostrzeenie: pole: %s %s(%ld)[%d - %d], nie ma parametru %d, przyjmuj warto domyln ('%c')...\n",
			    nazwa_pola, __nazwa_parsowanego_pliku,
			    aktualna_linia + linia_w_kawalku - 1,
			    (int) offset_pocz_kawalka,
			    (int) offset_konca_kawalka, numer_pola, wynik);
#endif
		    return wynik;
		}
		strcpy(buforek, strchr(buforek, ','));
		strcpy(buforek, buforek + 1);
		tmp++;
	    }
	    strcpy(buforek, buforek + strcspn(buforek, "\"\'") + 1);
	    {
		int tmp3 = strlen(buforek), knc = 0;
		while (tmp3 > 0 && !knc) {
		    knc = (buforek[tmp3] == '\'' || buforek[tmp3] == '\"');
		    buforek[tmp3] = '\0';
		    tmp3--;
		}
	    }
	    wynik = buforek[0];
	}
#ifdef DEBUG_PARSER
	linia_w_kawalku++;
#endif
    }
#ifdef DEBUG_PARSER
    if (!udalo_sie) {
	fprintf(stderr,
		"Ostrzeenie: Nie mog znale pola: %s %s(%ld - %ld)[%d - %d], przyjmuj warto domyln ('%c')...\n",
		nazwa_pola, __nazwa_parsowanego_pliku,
		aktualna_linia - 1,
		aktualna_linia + linia_konca_kawalka - 1,
		(int) offset_pocz_kawalka, (int) offset_konca_kawalka,
		wynik);
    }
#endif
    return wynik;
}

char *parser_string(char *buf, char *nazwa_pola, int numer_pola,
		    char *domyslna)
{
    char buforek[100001];
    char wynik[100000];
#ifdef DEBUG_PARSER
    int udalo_sie = 0;
#endif
    strcpy(wynik, domyslna);
/*  if (!(buforek = (char *) my_malloc (100001)))
  {
	  fprintf(stderr, "Zabrako pamici, parser_string()... ");
	  exit(1);
  }; */
    fseek(in, offset_pocz_kawalka, SEEK_SET);
#ifdef DEBUG_PARSER
    linia_w_kawalku = 0;
#endif
    while (offset_konca_kawalka >= ftell(in)) {
	fgets(buforek, 100000, in);
	strcpy(buforek, wytnij_komentarze(buforek));
	if (strstr(buforek, nazwa_pola) != NULL) {
	    int tmp = 1;
#ifdef DEBUG_PARSER
	    udalo_sie = 1;
#endif
	    strcpy(buforek, strstr(buforek, nazwa_pola));
	    strcpy(buforek, buforek + strlen(nazwa_pola));
	    while (tmp < numer_pola) {
		if (strchr(buforek, ',') == NULL) {
#ifdef DEBUG_PARSER
		    fprintf(stderr,
			    "Ostrzeenie: pole: %s %s(%ld)[%d - %d], nie ma parametru %d, przyjmuj warto domyln (\"%s\")...\n",
			    nazwa_pola, __nazwa_parsowanego_pliku,
			    aktualna_linia + linia_w_kawalku - 1,
			    (int) offset_pocz_kawalka,
			    (int) offset_konca_kawalka, numer_pola, wynik);
#endif
		    return domyslna;
		}
		strcpy(buforek, strchr(buforek, ','));
		strcpy(buforek, buforek + 1);
		tmp++;
	    }
	    strcpy(buforek, buforek + strcspn(buforek, "\"\'"));
	    {
		int typ_ciapka = buforek[0] == '\'', i = 0, eskejp = 0;
		strcpy(buforek, buforek + 1);
		strcpy(wynik, "");
		if (typ_ciapka) {
		    while (buforek[0] != '\'' || eskejp) {
			if ((buforek[0] == '\\') && !eskejp) {
			    eskejp = 1;
			    i--;
			} else {
			    wynik[i] = buforek[0];
			    if (eskejp && buforek[0] == 'n')
				wynik[i] = '\n';
			    eskejp = 0;
			}
			strcpy(buforek, buforek + 1);
			i++;
		    }
		} else {
		    while (buforek[0] != '\"' || eskejp) {
			if ((buforek[0] == '\\') && !eskejp) {
			    eskejp = 1;
			    i--;
			} else {
			    wynik[i] = buforek[0];
			    if (eskejp && buforek[0] == 'n')
				wynik[i] = '\n';
			    eskejp = 0;
			}
			strcpy(buforek, buforek + 1);
			i++;
		    }
		}
		wynik[i] = '\0';
	    }
	}
#ifdef DEBUG_PARSER
	linia_w_kawalku++;
#endif
    }
    strcpy(buf, wynik);
#ifdef DEBUG_PARSER
    if (!udalo_sie) {
	fprintf(stderr,
		"Ostrzeenie: Nie mog znale pola: %s %s(%ld - %ld)[%d - %d], przyjmuj warto domyln (\"%s\")...\n",
		nazwa_pola, __nazwa_parsowanego_pliku,
		aktualna_linia - 1,
		aktualna_linia + linia_konca_kawalka - 1,
		(int) offset_pocz_kawalka, (int) offset_konca_kawalka,
		wynik);
    }
#endif
    return buf;
}
