/* parser.h */
#ifndef PARSER_H
#define PARSER_H
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "config.h"
#include "rozne.h"
#include "kolory.h"
#include "postacconst.h"
#include "potworconst.h"
#include "poziomconst.h"
#include "przedmiotyconst.h"
#include "pulapkiconst.h"
#include "strefyconst.h"
#include "umiejetnosciconst.h"
#include "ksiazkiconst.h"
#include "wspolczynniki.h"

/* To ja moe mae wypracowanie...
 *   Jest tak: kady plik dzieli si na jakie kawaki 
 *   (bdce np. opisem jednego przedmiotu), w obrbie ktrych 
 *   pola si nie powtarzaj)
 *   Pole zaczynamy jakim wpisem (typu: "ilokilometrowe to s buty:")
 *   Potem po przecinkach (patrz BDY) podajemy kolejne dane.
 *   Funkcja ustaw_kawalek() ustawia nas w takim kawaku.
 *   Moemy adnie prosi o liczb, znak albo stringa.
 *   
 *   Liczby:
 *     - cakowite ze znakiem
 *
 *   Znaki:
 *     - w '' albo w ""
 *
 *   Cigi:
 *    - w '' albo w ""
 *    - obsuga \n
 *    - obsuga escape: \" \'
 * 
 *   Komentarze:
 *    Jeeli nie w ciapkach, znak '#' powoduje ignorowanie dalszej czci linijki.
 *
 *    BDY:
 *     1) Problemy z przecinkami umieszczonymi w ciapkach (nie dziaa, jeeli nie jest to _ostatni_ element w danym polu)
 *     2...999) O tych jeszcze nic nie wiem. ;)
 */

#define KOMENTARZ '#'
#define KONIEC_LINII '\r'
#define PRZECINEK ","


/* Spodziewane liczby: */
#define SP_KOLOR	0
#define SP_FL_POST	1
#define SP_AKCJA	2
#define SP_RASA		3
#define SP_KLASA	4
#define SP_PLEC		5
#define SP_POTW		6
#define SP_POLE		7
#define SP_TYP_GEN	8
#define SP_FL_POZ	9
#define SP_FL_TER	10
#define SP_PRZEDM	11
#define SP_FL_PRZEDM	12
#define SP_KL_PRZEDM	13
#define SP_MAT		14
#define SP_PUL		15
#define SP_STR		16
#define SP_SKLEP	17
#define SP_UMIEJ	18
#define SP_WSP		19
#define SP_FL_KS	20
#define SP_LICZBA	21
#define SP_RODZAJ	22
#define SP_M_ANAT	23
#define SP_PODKL_PRZEDM	24
#define SP_POZYCJA	25

FILE *in;
long offset_pocz_kawalka;
long offset_konca_kawalka;
char __nazwa_parsowanego_pliku[1000];

#ifdef DEBUG
long int aktualna_linia;
long int linia_w_kawalku;
long int linia_konca_kawalka;
#endif

/* Zwraca 1, jeli si udao i 0, jeeli stao si co strasznego */
int init_parser(char *nazwa_pliku);
void end_parser();
/* Zwraca 0, jeli si udao, 1, jeli nastpi koniec pliku i 2, jeli stao si co strasznego */
int ustaw_kawalek(char *poczatek, char *koniec);

void ustaw_caly_plik();
/* Zapytania */
int parser_liczba(char *nazwa_pola, int numer_pola, int domyslna, int typ);
char parser_znak(char *nazwa_pola, int numer_pola, char domyslna);
char *parser_string(char *buf, char *nazwa_pola, int numer_pola,
		    char *domyslna);

#endif
