/* postac.h */

#ifndef postac_h
#define postac_h

#include <string.h>
#include <limits.h>
#include <math.h>

#include "config.h"
#include "rozne.h"
#include "ekran.h"
#include "czas.h"
#include "umiejetnosci.h"
#include "postacconst.h"
#include "structpotwor.h"
#include "structpostac.h"
#include "structpoziom.h"
#include "structprzedmiotyID.h"
#include "przedmioty_dod.h"
#include "poziom.h"
#include "walka.h"
#include "io.h"
#include "umiejetnosci.h"
#include "potwor.h"
#include "ksiazki.h"
#include "schematekwipunku.h"
#include "strefy.h"
#include "przedm.h"

#ifdef DEBUG
#include <malloc.h>
int god_mode;			/* iddqd */
int clipping;			/* idspispaspopd */
int widzenie_wszystkiego;
#endif

#define ZYJE 1

int czytaj_konfiguracje_postaci;

int koniec;

/* Tu trzymamy powd mierci */
char powod_smierci[500];

/* Rusza posta, jeeli, przy jej prdkoci, powinna si ruszy
 * w tej rundzie */
void ruch_postaci(struct istota *Postac, struct poziom *Poziom);

/* Uznaje wszystkie pola za niewidoczne */
void wyczysc_cala_widocznosc(struct istota *Postac);

/* Szybka, niedokladna wersja */
void wyczysc_widocznosc(struct istota *Postac);

void rysuj_postac(struct istota *Istota, struct poziom *Poziom);

void
przesun_postac(struct istota *Postac, struct poziom *Poziom, int dx,
	       int dy);

#ifdef MAGIC_TAXIS
void przejedz_magiczna_taksowka(struct istota *Postac, struct poziom *Poziom);
#endif

void ruch_gracza(struct istota *Postac, struct poziom *Poziom);

/* zmien_* zwracaj ZYJE albo !ZYJE w odpowiednich okolicznociach */
int zmien_hp(struct istota *Postac, int ile);

int zmien_en(struct istota *Postac, int ile);
int zmien_przyt(struct istota *Postac, int ile);
int zmien_psych(struct istota *Postac, int ile);

void dodaj_exp(struct istota *Postac, int ile);

/* Usuwa posta z listy */
void usun_postac(struct istoty *Istoty);

int dodaj_postac(int x, int y, int ID, int flagi, int poziom,
		 struct istoty *Istoty);

void zrob_postac(struct istota *Postac);

/* Zadaje pytania potrzebne do stworzenia postaci gracza */
void tworz_postac(struct istota *Postac);

/* Zwraca ZNALAZL, jeli na polu(x,y) znajduje si jaka istota 
 * (jest wtedy take ustawiony na ni wskanik Istoty->aktualny)
 */
short int szukaj_postaci(int x, int y, struct istoty *Istoty);
/* To samo, tylko nie sprawdza pooenia, a tylko widoczno przez Patrzac */
short int szukaj_postaci_widocznej(struct istoty *Istoty,
				   struct istota *Patrzaca,
				   int pierwsze_szukanie);

short int jedz(struct istota *Istota);

void pij(struct istota *Istota);

void pij_z(int x, int y, struct poziom *Poziom, struct istota *Istota);

/* Uiszcza naleno (zwraca, czy si udao) */
int plac(struct istota *Placaca);

/* Automat otwierajcy drzwi (do AI i ew. automatycznego otwierania drzwi) */
int otworz(struct istota *Postac);

/* Automat zamykajcy drzwi (do AI i ew. automatycznego zamykania drzwi) */
int zamknij(struct istota *Postac);

void sprzedaj(struct istota *Kupujaca, struct istota *Sprzedawca,
	      struct przedmiot *towar);

/* Wywietla zawarto dolnej czci ekranu */
void wyswietl_opis_gracza(struct poziom *Poziom);

/* Czyci widoczno i poznaje */
void widocznosc(struct poziom *Poziom, struct istota *Postac);

/* Kursor acy po ekranie */
void patrz(struct istota *Pst, struct poziom *Pz);

void rozmawiaj(struct istota *Pst, struct poziom *Pz);

void kup(struct istota *Kupiec, struct istota *Sprzedawca);

/* Zwraca ilo punktw dowiadczenia potrzebnych by osign poziom poziom */
long int poziom_dosw(struct istota *Pst, int poziom);

void nastepny_poziom(struct istota *Pst);

void zapisz();

void laduj();
#endif
