/* potwor.c */

#include "potwor.h"

#define odl(x,y) x*x+y*y	/* Fajne, prawda? :) (to tylko do porwna) */

/* Wczytuje tablic opisujc potwory i tworzy tablic wystpowania 
 * potworw na rnych poziomach */
void wczytaj_tablice_potw_ID(struct _plik *in, struct PotworyID *tablica)
{
    int i, j;
    for (j = 0; j < MAXPOZ; j++) {
	poziom_d[j] = 0;
    }
    sread(in, &tablica->ile, sizeof(tablica->ile));
    i = 0;
    while (i < tablica->ile) {
	sread(in, &tablica->ID[i], sizeof(struct potworID));
	for (j = tablica->ID[i].poziom; j < MAXPOZ; j++) {
	    poziom_d[j] += tablica->ID[i].czestosc;
	}
	i++;
    }
}

/* Zapisuje tablic opisujc potwory */
void
zapisz_tablice_potw_ID(char *out, long int *dl, struct PotworyID *tablica)
{
    int i;
    *dl = 0;
    i = 0;
    memcpy(&out[*dl], &tablica->ile, sizeof(tablica->ile));
    (*dl) += sizeof(tablica->ile);
    while (i < tablica->ile) {
	memcpy(&out[*dl], &tablica->ID[i], sizeof(struct potworID));
	(*dl) += sizeof(struct potworID);
	i++;
    }
}

int szukaj_w_tablicy_wsk_pot(wsk_istota * tablica, wsk_istota Wsk)
{
    int wynik = -1, i;
    for (i = 0; (i < MAXPOTW) && (wynik == -1); i++) {
	if (Wsk == tablica[i])
	    wynik = i;
    }
    return wynik;
}

wsk_istota szukaj_w_tablicy_pot(wsk_istota * tablica, int indeks)
{
    wsk_istota wynik = 0;
    if (indeks == -1)
	return wynik;
    return tablica[indeks];
}

/* Dugie opisy ...  */
/*-----------------------------------*/
/* Tworzy list potworw w/g tego co w pliku 
   (zakadamy, e gracz ju jest dodany) */
void wczytaj_potwory(struct _plik *in, struct istoty *Istoty)
{
    int i, j, indeks = 1, l = 0, tmp;
    struct istota_IO rekord;
    wsk_istota tablica[MAXPOTW];
    int tablica_ind[MAXPOTW];
    tablica[0] = Istoty->poczatek->nast;
    for (i = 1; i < MAXPOTW; i++)
	tablica[i] = 0;
    sread(in, &i, sizeof(int));
    while (Istoty->ile < i + 1) {
	sread(in, &rekord, sizeof(struct istota_IO));
	dodaj_postac(rekord.x, rekord.y, rekord.ID, rekord.flagi,
		     Poziom.poziom, Istoty);
	tablica[indeks] = Istoty->aktualny;

	/* ewentualne przypisanie do strefy */
	if (str_ist[l] != -1) {
	    strefa[str_ist[l]].Istota = Istoty->aktualny;
	}
	l++;

	tablica_ind[indeks] = rekord.cel_ataku;
/* XXX Trzeba jeszcze zrobi rekord.przedmiot i rekord.istota */
	indeks++;
	strcpy(Istoty->aktualny->nazwa, rekord.nazwa);
	strcpy(Istoty->aktualny->nazwa_dop, rekord.nazwa_dop);
	Istoty->aktualny->x = rekord.x;
	Istoty->aktualny->y = rekord.y;
	Istoty->aktualny->kolor = rekord.kolor;
	Istoty->aktualny->ID = rekord.ID;
	Istoty->aktualny->flagi = rekord.flagi;
	Istoty->aktualny->typ = rekord.typ;
	Istoty->aktualny->trasa = rekord.trasa;
	Istoty->aktualny->akcja = rekord.akcja;
	Istoty->aktualny->anatomia = rekord.anatomia;
	Istoty->aktualny->pozycja = rekord.pozycja;
	Istoty->aktualny->szybkosc = rekord.szybkosc;
	Istoty->aktualny->hp = rekord.hp;
	Istoty->aktualny->pp = rekord.pp;
	Istoty->aktualny->hp_max = rekord.hp_max;
	Istoty->aktualny->pp_max = rekord.pp_max;
	Istoty->aktualny->hp_tur = rekord.hp_tur;
	Istoty->aktualny->pp_tur = rekord.pp_tur;
	Istoty->aktualny->hp_l = rekord.hp_l;
	Istoty->aktualny->pp_l = rekord.pp_l;
	Istoty->aktualny->psych = rekord.psych;
	Istoty->aktualny->przyt = rekord.przyt;
	Istoty->aktualny->psych_max = rekord.psych_max;
	Istoty->aktualny->przyt_max = rekord.przyt_max;
	Istoty->aktualny->psych_tur = rekord.psych_tur;
	Istoty->aktualny->przyt_tur = rekord.przyt_tur;
	Istoty->aktualny->psych_l = rekord.psych_l;
	Istoty->aktualny->przyt_l = rekord.przyt_l;
	Istoty->aktualny->pancerz_nat = rekord.pancerz_nat;
	Istoty->aktualny->au = rekord.au;
	Istoty->aktualny->plec = rekord.plec;
	for (j = 0; j < ILOSC_UMIEJETNOSCI; j++) {
	    Istoty->aktualny->umiejetnosci[j] = rekord.umiejetnosci[j];
	    Istoty->aktualny->umiejetnosci_male[j] =
		rekord.umiejetnosci_male[j];
	    Istoty->aktualny->umiejetnosci_teor[j] =
		rekord.umiejetnosci_teor[j];
	    Istoty->aktualny->umiejetnosci_teor_male[j] =
		rekord.umiejetnosci_teor_male[j];
	}
	for (j = 0; j < ILOSC_WSPOLCZYNNIKOW; j++)
	    Istoty->aktualny->wspolczynniki[j] = rekord.wspolczynniki[j];
	Istoty->aktualny->plecak.ile = 0;
	wczytaj_przedmioty(in, &Istoty->aktualny->plecak);
	/* Ekwipunek */
	for (tmp = 0; tmp < MAXMEKW; tmp++) {
	    Istoty->aktualny->ekw.miejsce[tmp].ile = 0;
	    if (Istoty->aktualny->anatomia.miejsce[tmp])
		wczytaj_przedmioty(in,
				   &Istoty->aktualny->ekw.miejsce[tmp]);
	}


    }
    if (i < 1)
	return;
    Istoty->aktualny = Istoty->poczatek->nast;
    for (indeks = 1; indeks < Istoty->ile; indeks++) {
	Istoty->aktualny = Istoty->aktualny->nast;
	Istoty->aktualny->cel_ataku =
	    szukaj_w_tablicy_pot(tablica, tablica_ind[indeks]);
    }
}

/* Zapisuje do pliku liste potworw (bez gracza) */
void zapisz_potwory(char *out, long int *ile, struct istoty *Istoty)
{
    int i, j, tmp = Istoty->ile - 1;
    long int dl_tmp;
    struct istota_IO rekord;
    wsk_istota tablica[MAXPOTW];

    for (i = 0; i < MAXPOTW; i++)
	tablica[i] = 0;
    Istoty->aktualny = Istoty->poczatek;
    for (i = 0; i < Istoty->ile; i++) {
	Istoty->aktualny = Istoty->aktualny->nast;
	tablica[i] = Istoty->aktualny;
    }
    *ile = 0;
    memcpy(&out[*ile], &tmp, sizeof(int));
    (*ile) += sizeof(int);
    i = 0;
    if (Istoty->ile < 2) {
	return;
    }
/* Ustawiamy wskaznik na gracza */
    Istoty->aktualny = Istoty->poczatek->nast;
    while (i < (Istoty->ile - 1)) {
	Istoty->aktualny = Istoty->aktualny->nast;
	rekord.x = Istoty->aktualny->x;
	rekord.y = Istoty->aktualny->y;
	rekord.kolor = Istoty->aktualny->kolor;
	strcpy(rekord.nazwa, Istoty->aktualny->nazwa);
	strcpy(rekord.nazwa_dop, Istoty->aktualny->nazwa_dop);
	rekord.ID = Istoty->aktualny->ID;
	rekord.flagi = Istoty->aktualny->flagi;
	rekord.typ = Istoty->aktualny->typ;
	rekord.trasa = Istoty->aktualny->trasa;
	rekord.akcja = Istoty->aktualny->akcja;
	rekord.anatomia = Istoty->aktualny->anatomia;
	rekord.szybkosc = Istoty->aktualny->szybkosc;
	rekord.hp = Istoty->aktualny->hp;
	rekord.pp = Istoty->aktualny->pp;
	rekord.hp_max = Istoty->aktualny->hp_max;
	rekord.pp_max = Istoty->aktualny->pp_max;
	rekord.hp_tur = Istoty->aktualny->hp_tur;
	rekord.pp_tur = Istoty->aktualny->pp_tur;
	rekord.hp_l = Istoty->aktualny->hp_l;
	rekord.pp_l = Istoty->aktualny->pp_l;
	rekord.psych = Istoty->aktualny->psych;
	rekord.przyt = Istoty->aktualny->przyt;
	rekord.psych_max = Istoty->aktualny->psych_max;
	rekord.przyt_max = Istoty->aktualny->przyt_max;
	rekord.psych_tur = Istoty->aktualny->psych_tur;
	rekord.przyt_tur = Istoty->aktualny->przyt_tur;
	rekord.pozycja = Istoty->aktualny->pozycja;
	rekord.psych_l = Istoty->aktualny->psych_l;
	rekord.przyt_l = Istoty->aktualny->przyt_l;
	rekord.pancerz_nat = Istoty->aktualny->pancerz_nat;
	rekord.au = Istoty->aktualny->au;
	rekord.plec = Istoty->aktualny->plec;
	rekord.cel_ataku =
	    szukaj_w_tablicy_wsk_pot(tablica, Istoty->aktualny->cel_ataku);
	rekord.istota = szukaj_w_tablicy_wsk_pot(tablica, Istoty->aktualny->istota);
/*XXX	rekord.przedmiot =  */
        if (rekord.akcja & (SPRZEDAJE|CZEKA_NA_SKLEPIKARZA)) rekord.akcja = NIC_NIE_ROBI;
	for (j = 0; j < ILOSC_UMIEJETNOSCI; j++) {
	    rekord.umiejetnosci[j] = Istoty->aktualny->umiejetnosci[j];
	    rekord.umiejetnosci_male[j] =
		Istoty->aktualny->umiejetnosci_male[j];
	    rekord.umiejetnosci_teor[j] =
		Istoty->aktualny->umiejetnosci_teor[j];
	    rekord.umiejetnosci_teor_male[j] =
		Istoty->aktualny->umiejetnosci_teor_male[j];
	}
	for (j = 0; j < ILOSC_WSPOLCZYNNIKOW; j++)
	    rekord.wspolczynniki[j] = Istoty->aktualny->wspolczynniki[j];
	memcpy(&out[*ile], &rekord, sizeof(struct istota_IO));
	(*ile) += sizeof(struct istota_IO);
	zapisz_przedmioty(&out[*ile], &dl_tmp, &Istoty->aktualny->plecak);
	(*ile) += dl_tmp;
	for (tmp = 0; tmp < MAXMEKW; tmp++)
	    if (Istoty->aktualny->anatomia.miejsce[tmp]) {
		zapisz_przedmioty(&out[*ile], &dl_tmp,
				  &Istoty->aktualny->ekw.miejsce[tmp]);
		(*ile) += dl_tmp;
	    }

	i++;
    }
}

/*--------------------------------A dotd */

void wczytaj_potwory_kr(struct _plik *in, struct istoty *Istoty)
{
    int i, l = 0;
    struct istota_IO_krotka rekord;
    sread(in, &i, sizeof(int));
    while (Istoty->ile < i + 1) {
	sread(in, &rekord, sizeof(struct istota_IO_krotka));
	dodaj_postac(rekord.x, rekord.y, rekord.ID, 0, Poziom.poziom,
		     Istoty);
	zrob_ekwipunek(Istoty->aktualny, Poziom.poziom);
	zrob_postac(Istoty->aktualny);
	Istoty->aktualny->trasa = rekord.trasa;
	Istoty->aktualny->akcja = rekord.akcja;
	trasa.a[rekord.trasa] = rekord.akt_trasa;
	if (rekord.akt_trasa != -1) {
	    trasa.m[rekord.trasa][rekord.akt_trasa] = rekord.tr_start;
	}
	/* ewentualne przypisanie do strefy */
	if (str_ist[l] != -1)
	    strefa[str_ist[l]].Istota = Istoty->aktualny;
	l++;
    }

}

void zapisz_potwory_kr(char *out, long int *ile, struct istoty *Istoty)
{
    int i, tmp = Istoty->ile - 1;
    struct istota_IO_krotka rekord;
    *ile = 0;
    memcpy(&out[*ile], &tmp, sizeof(int));
    (*ile) += sizeof(int);
    i = 0;
    if (Istoty->ile < 2) {
	return;
    }
/* Ustawiamy wskaznik na gracza */
    Istoty->aktualny = Istoty->poczatek->nast;
    while (i < (Istoty->ile - 1)) {
	Istoty->aktualny = Istoty->aktualny->nast;
	rekord.x = Istoty->aktualny->x;
	rekord.y = Istoty->aktualny->y;
	rekord.ID = Istoty->aktualny->ID;
	rekord.trasa = Istoty->aktualny->trasa;
	rekord.akcja = Istoty->aktualny->akcja;
	memcpy(&out[*ile], &rekord, sizeof(struct istota_IO_krotka));
	(*ile) += sizeof(struct istota_IO_krotka);
	i++;
    }
}

void wczytaj_schematy_anatomii(struct _plik *in)
{
    int i, ile;
    sread(in, &ile, sizeof(int));
    for (i = 0; i < ile; i++) {
	sread(in, &sch_anat[i], sizeof(struct schemat_anatomii));
    }
}

/* Zostawia na licie jeno gracza */
void wyczysc_liste_potworow(struct istoty *Istoty)
{
    if (Istoty->ile < 2) {
	return;
    }
    Istoty->aktualny = Istoty->poczatek->nast->nast;
    while (Istoty->aktualny != Istoty->koniec) {
	usun_postac(Istoty);
	Istoty->aktualny = Istoty->poczatek->nast->nast;
    }
    Istoty->ile = 1;
    Istoty->aktualny = Istoty->poczatek->nast;
    Istoty->maxszybkosc = Istoty->aktualny->szybkosc;
}

/* Wszystkie postaci na poziomie o ID obieraj sobie Cel za cel */
void zmien_cel_ataku(int ID, struct istota *Cel, struct poziom *Poziom)
{
    wsk_istota back = Poziom->Istoty.aktualny;
    for (Poziom->Istoty.aktualny = Poziom->Istoty.poczatek->nast;
	 Poziom->Istoty.aktualny != Poziom->Istoty.koniec;
	 Poziom->Istoty.aktualny = Poziom->Istoty.aktualny->nast)
	if (Poziom->Istoty.aktualny->ID == ID)
	    Poziom->Istoty.aktualny->cel_ataku = Cel;
    Poziom->Istoty.aktualny = back;
}

/* Zwraca 1, jeeli align jest dostatecznie rny */
short int rozny_align(struct istota *A, struct istota *B)
{
    if ((abs(A->align - B->align) > 150) && (B->flagi & FLAGA_GRACZA))
	return 1;
    if ((abs(A->align - B->align) > 75) && (B->flagi & FLAGA_GRACZA)
	&& (A->flagi & FLAGA_WROGOSCI))
	return 1;
    if (abs(A->align - B->align) > 750)
	return 1;
    return 0;
}

int czy_jest_glodny(struct istota *Potwor)
{
    int tr_i = Potwor->trasa, wsp;
    wsp = (Potwor->energia) * 100 / Potwor->energia_max;
    if (wsp <= GLODNY) {
	if (jedz(Potwor)) {
	    return 0;
	} else {		/* Zorganizuj jedzenie */
	    /* Czy t posta obowizuje jaka trasa */
	    if (tr_i != -1) {
		if (trasa.a[tr_i] != TRASA_JEDZENIE_ZE_SKLEPU) {	/* Ju prbujemy znale co do jedzenia */
		    trasa.a[tr_i] = TRASA_JEDZENIE_ZE_SKLEPU;	/* Ustawienie aktualnej trasy na 0 */
		    Potwor->wykonana = 0;
		}
	    }
	}
    }

    if (wsp <= B_GLODNY) {	/* To chyba nie wymaga komentarza */
	Potwor->cel_ataku = NULL;
    }
    return 1;
}

void obsluga_dnia_i_nocy(struct istota *Potwor)
{
    int tr_i = Potwor->trasa;
    if (dzien) {
	if (Potwor->akcja == SPI) {
	    Potwor->akcja = NIC_NIE_ROBI;
	    if (tr_i != -1) {
		if (trasa.a[tr_i] == -1) {	/* Nic konkretnego nie robimy */
		    trasa.a[tr_i] = TRASA_PO_PRZEBUDZENIU;	/* Ustawienie aktualnej trasy na 1 */
		}
	    }

	}
    } else {
	if (Potwor->akcja != SPI) {
	    Potwor->akcja = NIC_NIE_ROBI;
	    if (tr_i != -1) {
		if (trasa.a[tr_i] == -1) {	/* Nic konkretnego nie robimy */
		    trasa.a[tr_i] = TRASA_PO_ZMROKU;	/* Ustawienie aktualnej trasy na 2 */
		}
	    }

	}
    }

}

int
obsluga_tras(struct istota *Potwor, int *dx, int *dy, int *idz,
	     char *do_wykonania)
{
    int tr_i = Potwor->trasa;
    int p_trasa = trasa.a[tr_i];
    char tmp;
    if (tr_i != -1) {
	if (p_trasa != -1) {	/* Jak jest jaka aktualna trasa */
	    *do_wykonania = tmp = trasa.c[tr_i][p_trasa][trasa.m[tr_i][p_trasa]];	/* aktualny znak aktualnej trasy */
	    switch (tmp) {
	    case 'N':
		*dy = -1;
		return 1;;
		break;
	    case 'E':
		*dx = 1;
		return 1;;
		break;
	    case 'S':
		*dy = 1;
		return 1;;
		break;
	    case 'W':
		*dx = -1;
		return 1;;
		break;
	    case 'K':
#ifdef DEBUG
		dodaj_napis("Kupujemy ...  ");
#endif
		if (!Potwor->wykonana) {
		    kup(Potwor,
			strefa[numer_strefy
			       (SKLEP, Potwor->x, Potwor->y)].Istota);
		    Potwor->akcja = CZEKA_NA_SKLEPIKARZA;
#ifdef DEBUG
		dodaj_napis("Czekamy na sklepikarza...  ");
#endif
		    Potwor->wykonana = 1;
		}
		return 1;;
		break;
	    case 'O':
#ifdef DEBUG
		dodaj_napis("Otwieramy ...  ");
#endif
		otworz(Potwor);
		return 1;;
		break;
	    case 'Z':
#ifdef DEBUG
		dodaj_napis("Zamykamy ...  ");
#endif
		zamknij(Potwor);
		return 1;;
		break;
            case '':
		{ 
			struct delta D = szukaj_wolnego_lozka(&Poziom, Potwor->x, Potwor->y);
#ifdef DEBUG
		dodaj_napis("Szukamy ka... ");
#endif
		Potwor->ost_x_celu = D.x;
		Potwor->ost_y_celu = D.y;
		    *idz = 1;
                return 0;
		}	
	    default:
		/* miejsca na mapie */
		{
		    int m = szukaj_miejsca(*do_wykonania);
		    Potwor->ost_x_celu = miejsce[m].x;
		    Potwor->ost_y_celu = miejsce[m].y;
#ifdef MAGIC_TAXIS
		    if (p_trasa == TRASA_PO_PRZEBUDZENIU ||
                        p_trasa == TRASA_PO_ZMROKU       ||
                        p_trasa == TRASA_JEDZENIE_ZE_SKLEPU)
                       {
                        przejedz_magiczna_taksowka(Potwor, &Poziom);
                       } else
#endif /* MAGIC_TAXIS */
		    *idz = 1;
		}
	    }
	}
    }
    return 0;
}

void obsluga_wrogosci(struct istota *Potwor, struct poziom *Poziom)
{
    wsk_istota tmp;
    if ((Potwor->flagi & FLAGA_WROGOSCI) && (Potwor->cel_ataku == NULL)) {
	if (!policzona_widocznosc) {
	    policzona_widocznosc = 1;
	    widocznosc(Poziom, Potwor);
	}
	tmp = Poziom->Istoty.aktualny;
	if (szukaj_postaci_widocznej(&Poziom->Istoty, Potwor, 1) ==
	    ZNALAZL) {
	    if (rozny_align(Potwor, Poziom->Istoty.aktualny)) {
		Potwor->cel_ataku = Poziom->Istoty.aktualny;
	    } else {
		int juz = 0;
		while (szukaj_postaci_widocznej(&Poziom->Istoty, Potwor, 0)
		       != NIE_ZNALAZL && !juz) {
		    if (rozny_align(Poziom->Istoty.aktualny, Potwor)) {
			Potwor->cel_ataku = Poziom->Istoty.aktualny;
			juz = 1;
		    }
		}
	    }
#ifdef DEBUG
        if (Potwor->cel_ataku != NULL)
	if (Potwor->cel_ataku->y > 10000)            {
	dodaj_napis("Cel ataku poza plansz! :)");
                }
#endif
	}
	Poziom->Istoty.aktualny = tmp;
    }
}

/*
void
wymijaj_przeszkode(struct poziom *Poziom, struct istota *Potwor,
		   int *dx, int *dy)
{
#define c_m_w(dx,dy) czy_mozna_wejsc(Poziom, Potwor->x + dx, Potwor->y + dy, Potwor)
#define _odl(dx,dy) odl(Potwor->ost_x_celu-Potwor->x - dx, Potwor->ost_y_celu-Potwor->y - dy)
    int a, b, c = 0;
    int kier = 3 * (*dx + 1) + (*dy + 1);
    int poprz =
	3 * (Potwor->ost_x - Potwor->x + 1) + (Potwor->ost_y - Potwor->y +
					       1);
    int tab[] =
	{ 0, 3, 6, 7, 8, 5, 2, 1, 0, 3, 6, 7, 8, 5, 2, 1, 0, 3, 6, 7, 8, 5,
	2, 1
    };
    int tab2[] =
	{ 8 + 0, 8 + 7, 8 + 6, 8 + 1, -1, 8 + 5, 8 + 2, 8 + 3, 8 + 4 };
    int strona = 0, tmp = tab2[kier] - tab2[poprz], koniec = 0;
    if (abs(tmp) < 4) {
	if (tmp > 0)
	    strona = 1;
    } else {
	if (tmp > 0)
	    strona = 1;
    }
    while (!koniec) {
	c++;
	a = c_m_w((tab[tab2[kier] - c]) / 3 - 1,
		  (tab[tab2[kier] - c]) % 3 - 1);
	b = c_m_w((tab[tab2[kier] + c]) / 3 - 1,
		  (tab[tab2[kier] + c]) % 3 - 1);
	koniec = (a | b);
	if (a && b) {
	    if (strona) {
		if (_odl
		    ((tab[tab2[kier] + c]) / 3 - 1,
		     (tab[tab2[kier] + c]) % 3 - 1) <=
		    _odl((tab[tab2[kier]] - c) / 3 - 1,
			 (tab[tab2[kier] - c]) % 3 - 1)) {
		    *dx = (tab[tab2[kier] + c]) / 3 - 1;
		    *dy = (tab[tab2[kier] + c]) % 3 - 1;
		} else {
		    *dx = (tab[tab2[kier] - c]) / 3 - 1;
		    *dy = (tab[tab2[kier] - c]) % 3 - 1;
		}
	    } else {
		if (_odl
		    ((tab[tab2[kier] - c]) / 3 - 1,
		     (tab[tab2[kier] - c]) % 3 - 1) <=
		    _odl((tab[tab2[kier] + c]) / 3 - 1,
			 (tab[tab2[kier] + c]) % 3 - 1)) {
		    *dx = (tab[tab2[kier] - c]) / 3 - 1;
		    *dy = (tab[tab2[kier] - c]) % 3 - 1;
		} else {
		    *dx = (tab[tab2[kier] + c]) / 3 - 1;
		    *dy = (tab[tab2[kier] + c]) % 3 - 1;
		}
	    }
	}
	if (a) {
	    *dx = (tab[tab2[kier] - c]) / 3 - 1;
	    *dy = (tab[tab2[kier] - c]) % 3 - 1;
	}
	if (b) {
	    *dx = (tab[tab2[kier] + c]) / 3 - 1;
	    *dy = (tab[tab2[kier] + c]) % 3 - 1;
	}
    }
    return;
}*/

typedef struct punkt *wsk_punkt;

/* XXX Troch brzydka, powinna by symetryczna */
int kolejnosc_ruchow[8][8] = {
	{0,1,3,2,6,5,7,8},
	{1,2,0,5,3,8,6,7},
	{2,5,1,8,0,7,3,6},
	{3,0,6,1,7,2,8,5},
	{5,2,8,1,7,0,6,3},
	{6,3,7,0,8,1,5,2},
	{7,6,8,3,5,0,2,1},
	{8,5,7,2,6,1,3,0}};

struct punkt {
    int x, y;
    int kier;
    int przejsc;
    wsk_punkt nast;
};

struct lista_punktow {
    wsk_punkt aktualny;
    wsk_punkt poczatek;
    wsk_punkt koniec;
    int ile;
};

void wyczysc_liste_punktow(struct lista_punktow *lista)
{
    wsk_punkt tmp;
    if (!lista->ile)
	return;
    for (lista->aktualny = lista->poczatek; lista->aktualny != NULL;
	 lista->aktualny = tmp) {
	tmp = lista->aktualny->nast;
	my_free(lista->aktualny);
    }
    lista->ile = 0;
}

void
dodaj_do_listy_punktow(struct lista_punktow *lista, int x, int y, int kier,
		       int przejsc)
{
    if (lista->ile) {
	wsk_punkt tmp = lista->aktualny->nast;
	lista->aktualny->nast = my_malloc(sizeof(struct punkt));
	lista->aktualny = lista->aktualny->nast;
	lista->aktualny->nast = tmp;
	lista->ile++;
    } else {
	lista->koniec = lista->poczatek = lista->aktualny =
	    my_malloc(sizeof(struct punkt));
	lista->aktualny->nast = NULL;
	lista->ile = 1;
    }
    lista->aktualny->x = x;
    lista->aktualny->y = y;
    lista->aktualny->kier = kier;
    lista->aktualny->przejsc = przejsc;
}

int kierunek(int sx, int sy, int kx, int ky)
{
    int cx = kx - sx, cy = ky - sy, admx = abs(cx), admy = abs(cy), ax, ay;
    int x, y;
    /* Zastosowalem algorytm rysowania odcinka Bresenhama (Majcher) 
       Niewiele to teraz ma z odcinkiem (Andrzej) */
    if (cx >= 0)
	ax = 1;
    else
	ax = -1;
    if (cy >= 0)
	ay = 1;
    else
	ay = -1;
    if (admx >= admy) {
	if (2 * admy - admx < 0) {
	    x = ax;
	    y = 0;
	} else {
	    x = ax;
	    y = ay;
	}
    } else {
	if (2 * admx - admy < 0) {
	    y = ay;
	    x = 0;
	} else {
	    y = ay;
	    x = ax;
	}

    }
    return 3 * (x + 1) + y + 1;
}

int ile_przejsc(struct istota *Potwor, struct poziom *Poziom, int x, int y)
{
    int wynik = 1;
    wynik += (Poziom->pole[x][y] == DRZWI_ZAMKNIETE);
    wynik += 50 * (zajete[x][y] == 'X');
    wynik += 10 * (teren[Poziom->pole[x][y]].flagi & TER_WODA);
    return wynik;
}

int
wezel(struct lista_punktow *lista, wsk_punkt punkt,
      struct poziom *Poziom, struct istota *Potwor,
      int odwiedzone[MAXX][MAXY], int cx, int cy)
{
    int l;
    int pierwszy = kierunek(Potwor->x, Potwor->y, cx, cy);
    punkt->przejsc--;
    if (!punkt->przejsc) { /* Ju teraz moemy przej dalej */
            for (l = 0; l<8; l++) {
	    int kier = kolejnosc_ruchow[pierwszy][l], i = (kier/3) - 1, j = (kier%3) - 1;
		if (punkt->x + i >= 0 && punkt->x + i < Poziom->maxx &&
		    punkt->y + i >= 0 && punkt->y + i < Poziom->maxy) {
		    if (i != 0 || j != 0) {
			if (punkt->x + i == cx && punkt->y + j == cy)	/* udao si */
			    return punkt->kier;
			if (!odwiedzone[punkt->x + i][punkt->y + j])
			    if (mozna_wejsc
				(Poziom, punkt->x + i, punkt->y + j,
				 Potwor)) {
				dodaj_do_listy_punktow(lista, punkt->x + i,
						       punkt->y + j,
						       punkt->kier,
						       ile_przejsc(Potwor,
								   Poziom,
								   punkt->
								   x + i,
								   punkt->
								   y + j));
			    }
			odwiedzone[punkt->x + i][punkt->y + j] = 1;
		    }
		}
}
    } else { /* Jeszcze nie moemy przej tego pola, dekrementujemy licznik */
	dodaj_do_listy_punktow(lista, punkt->x, punkt->y, punkt->kier,
			       punkt->przejsc);
    }
    return -1;
}

void
idz_do_punktu(struct istota *Potwor, struct poziom *Poziom, int *dx,
	      int *dy, int ustawiony_c, int cx, int cy)
{
    int sx, sy;
    struct lista_punktow lista[2];
    int odwiedzone[MAXX][MAXY];
    int krok = 1, wynik = -1;
    int pierwszy = kierunek(Potwor->x, Potwor->y, cx, cy);
/*    int pierwszy = kierunek(Potwor->x, Potwor->y, cx, cy), i = (pierwszy/3) - 1, j = (pierwszy%3) -1; */
    int l;
    for (sx = 0; sx < Poziom->maxx; sx++)
	for (sy = 0; sy < Poziom->maxy; sy++)
	    odwiedzone[sx][sy] = 0;
    lista[0].ile = lista[1].ile = 0;
    /* Idziemy do wyznaczonego punktu 
     * (aby ew. obi komu mord
     *   (ale tylko ew., bo waciwe sprawdzenie jest pniej)) */
    /* Jeeli cx i cy nie s ustawione jeszcze */
    if (!ustawiony_c) {
	cx = Potwor->ost_x_celu;
	cy = Potwor->ost_y_celu;
    }
    odwiedzone[Potwor->x][Potwor->y] = 1;
/* Inicjalizacja */
/*    for (i = -1; i <= 1; i++)
	for (j = -1; j <= 1; j++) { */
            for (l = 0; l<8; l++) {
	    int kier = kolejnosc_ruchow[pierwszy][l], i = (kier/3) - 1, j = (kier%3) - 1;
	    if (i != 0 || j != 0) {
		if (Potwor->x + i == cx && Potwor->y + j == cy) {
		    wynik = kier;
		} else {
		    if (!odwiedzone[Potwor->x + i][Potwor->y + j]
			&& mozna_wejsc(Poziom, Potwor->x + i,
				       Potwor->y + j, Potwor)) {
			dodaj_do_listy_punktow(&lista[0], Potwor->x + i,
					       Potwor->y + j, kier,
					       ile_przejsc(Potwor, Poziom,
							   Potwor->x + i,
							   Potwor->y + j));
		    }
		}
	    }
	    odwiedzone[Potwor->x + i][Potwor->y + j] = 1;
	}
    while (wynik == -1) {
	wyczysc_liste_punktow(&lista[krok % 2]);
	if (lista[(krok + 1) % 2].ile) {
	    for (lista[(krok + 1) % 2].aktualny =
		 lista[(krok + 1) % 2].poczatek;
		 lista[(krok + 1) % 2].aktualny != NULL &&
		 wynik == -1;
		 lista[(krok + 1) % 2].aktualny =
		 lista[(krok + 1) % 2].aktualny->nast)
		wynik = wezel(&lista[krok % 2],
			      lista[(krok + 1) %
				    2].aktualny, Poziom, Potwor,
			      odwiedzone, cx, cy);
	}
	if (!lista[krok % 2].ile && wynik == -1)
	    wynik = kierunek(Potwor->x, Potwor->y, cx, cy);
	krok++;
    }
    if (wynik != -1) {
	*dx = (wynik / 3) - 1;
	*dy = (wynik % 3) - 1;
	return;
    }
    if (wynik < 0 || wynik > 9)
#ifdef DEBUG
	dodaj_napis("Szukanie drogi nie powiodo si... ");
#endif

    if (!czy_mozna_wejsc(Poziom, Potwor->x + *dx, Potwor->y + *dy, Potwor)) {
#ifdef DEBUG
	dodaj_napis("Szukanie drogi nie powiodo si... ");
#endif
	*dx = losowaoddo(-1, 1);
	*dy = losowaoddo(-1, 1);
    }
}

void
gon_wroga(struct istota *Potwor, struct poziom *Poziom,
	  int *ustawiony_c, int *idz, int *cx, int *cy)
{
    if (Potwor->cel_ataku != NULL) {
	if (!policzona_widocznosc) {
	    policzona_widocznosc = 1;
	    widocznosc(Poziom, Potwor);
	}
	if (Poziom->
	    widoczne_potwor[Potwor->cel_ataku->x][Potwor->cel_ataku->y]) {
	    Potwor->ost_x_celu = Potwor->cel_ataku->x;
	    Potwor->ost_y_celu = Potwor->cel_ataku->y;
	    *cx = Potwor->cel_ataku->x;
	    *cy = Potwor->cel_ataku->y;
	    *ustawiony_c = 1;
	    *idz = 1;
	} else { /* Nie wida. Moe sycha? ;) */
            int cax = Potwor->cel_ataku->x, cay = Potwor->cel_ataku->y,
                px  = Potwor->x,            py  = Potwor->y;
            /* XXX Bardzo arbitralnie przyjte :) */
            if (odl (px-cax, py-cay) < losowa100()) { /* Usyszelimy */
	    Potwor->ost_x_celu = cax;
	    Potwor->ost_y_celu = cay;
	    *cx = cax;
	    *cy = cay;
	    *ustawiony_c = 1;
	    *idz = 1;     
                 }
             }
    }
}

int obsluga_straznika(struct istota *Potwor)
{
    int tr_i = Potwor->trasa;
    if (Potwor->akcja == PATROLUJE) {
	if (tr_i != -1) {
	    if (trasa.a[tr_i] != 0) {
		trasa.a[tr_i] = 3;	/* Ustawienie aktualnej trasy na 3 */
		Potwor->wykonana = 0;
	    }
	}
    }
    return 0;
}

int
obsluga_sklepikarza(struct istota *Potwor, struct poziom *Poziom,
		    int *idz, int *ustawiony_c, int *dx, int *dy,
		    int *cx, int *cy)
{
    /* Sklepikarz ...  */
    if (Potwor->flagi & SKLEPIKARZ && !*ustawiony_c) {	/* Jak si kogo goni to mona si zapomnie */
	switch (Potwor->akcja) {
	case SPRZEDAJE:
	    {
		if (strefa[numer_strefy_naleznej(Potwor)].licznik) {
		    /* Kto nie zapaci */
		    if (pole(Poziom, Potwor->x, Potwor->y) !=
			DRZWI_OTWARTE) {
			struct delta Delta;
			Delta =
			    szukaj_pola(Poziom, DRZWI_OTWARTE, Potwor->x,
					Potwor->y);
			*dx = Delta.x;
			*dy = Delta.y;
			if (*dx == -3) {
			    *dx = 0;
			    *dy = 0;
			}
			*ustawiony_c = 1;
			*idz = 0;
		    } else {
			/* Sied na tym, no ...  */
			*dx = 0;
			*dy = 0;
			*ustawiony_c = 1;
			*idz = 0;
		    }

		} else {
		    /* XXX Czy mona z tego zrezygnowa? */
/*		    if (!policzona_widocznosc) {
			policzona_widocznosc = 1;
			widocznosc(Poziom, Potwor);
		    } */
		    /* Wszystko jest zapacone */
		    if ((pole(Poziom, Potwor->x, Potwor->y) ==
			 DRZWI_OTWARTE)
			&&
			(czy_mozna_wejsc
			 (Poziom, Potwor->x + 1, Potwor->y + 1, Potwor))) {
			/* XXX To jeszcze jako. Zawsze schodzimy na 
			 * to samo miejsce */
			struct delta Delta;
			Delta =
			    szukaj_strefy(numer_strefy_naleznej(Potwor),
					  Potwor->x, Potwor->y);
			*dx = Delta.x;
			*dy = Delta.y;
			if (*dx == -3) {
			    *dx = 0;
			    *dy = 0;
			}
			*ustawiony_c = 1;
			*idz = 0;
		    } else {
			/* Sied na tym, no ...  */
			*dx = 0;
			*dy = 0;
			*ustawiony_c = 1;
			*idz = 0;
		    }
		}
	    }
	    break;
	case IDZIE_PO_TOWAR:
	    {
		Potwor->ost_x_celu = Potwor->przedmiot->x;
		Potwor->ost_y_celu = Potwor->przedmiot->y;
		*cx = Potwor->przedmiot->x;
		*cy = Potwor->przedmiot->y;
		*ustawiony_c = 1;
		*idz = 1;
		if (*cx==Potwor->x && *cy==Potwor->y) {	/* Ju jestemy */
		    /* Podnosimy */
		    if (szukaj_tego(Potwor->przedmiot, &Poziom->Przedmioty)
			== ZNALAZL) {
			podnies_przedmioty(&Poziom->Przedmioty, Potwor, 1	/* ? */
			    );
		    }
		    /* Wracamy ...  */
		    Potwor->akcja = WRACA_Z_TOWAREM;
		    return 1;
		}
	    }
	    break;
	case WRACA_Z_TOWAREM:
	    {
		Potwor->ost_x_celu = Potwor->istota->x;
		Potwor->ost_y_celu = Potwor->istota->y;
		*cx = Potwor->istota->x;
		*cy = Potwor->istota->y;
		*ustawiony_c = 1;
		*idz = 1;
		if (abs(*cx - Potwor->x) < 2 && abs(*cy - Potwor->y) < 2) {	/* Ju jestemy */
		    /* Sprzedajemy */
		    sprzedaj(Potwor->istota, Potwor, Potwor->przedmiot);
		    Potwor->akcja = SPRZEDAJE;
		    return 1;
		}
	    }

	}
    }
    return 0;
}

void sprawdz_czy_doszedl(struct istota *Potwor, char do_wykonania)
{
    int tr_i = Potwor->trasa;
    /* czy doszlimy (ale nie byo to celem trasy) */
    if (Potwor->ost_x_celu == Potwor->x
	&& Potwor->ost_y_celu == Potwor->y && tr_i == -1) {
	Potwor->ost_x_celu = -1;
	Potwor->ost_y_celu = -1;
    }
    /* Czy zrobilimy aktualny punkt trasy */
    if (tr_i != -1) {
	switch (do_wykonania) {
	case '!':
	    break;
	case 'N':
	case 'E':
	case 'W':
	case 'S':
	case 'O':
	case 'Z':
	    trasa.m[tr_i][trasa.a[tr_i]]++;	/* przejcie do nastpnego punktu trasy */
	    Potwor->wykonana = 0;
	    break;
        case '':
	if (Poziom.pole[Potwor->x][Potwor->y] == LOZKO) {
#ifdef DEBUG
		dodaj_napis("Kadziemy si...  ");
#endif
           trasa.m[tr_i][trasa.a[tr_i]]++;                 
	    Potwor->wykonana = 0;
}
         break;
	case 'K':
	    if (Potwor->akcja == NIC_NIE_ROBI) {
#ifdef DEBUG
		dodaj_napis("Kupilimy ...  ");
#endif
		trasa.m[tr_i][trasa.a[tr_i]]++;	/* jak wyej */
		Potwor->wykonana = 0;
	    }
	    break;
	default:
	    if (Potwor->ost_x_celu == Potwor->x
		&& Potwor->ost_y_celu == Potwor->y) {
#ifdef DEBUG
		dodaj_napis("Doszlimy ...  ");
#endif
		trasa.m[tr_i][trasa.a[tr_i]]++;	/* jak wyej */
		Potwor->wykonana = 0;
	    }
	    break;
	}
	/* Skoczylimy tras */
	if (trasa.m[tr_i][trasa.a[tr_i]] >=
	    strlen(trasa.c[tr_i][trasa.a[tr_i]])) {
	    trasa.m[tr_i][trasa.a[tr_i]] = 0;
	    switch (trasa.a[tr_i]) {
	    case 1:
		if (Potwor->flagi & SKLEPIKARZ)
		    Potwor->akcja = SPRZEDAJE;
		break;
	    case 2:
		Potwor->akcja = SPI;
		break;
	    }
	    trasa.a[tr_i] = -1;
	    Potwor->wykonana = 0;
	}
    }
}

/* Tu ma by AI potworw, a na razie co jest, kady widzi ...  */
void ruch_potwora(struct istota *Potwor, struct poziom *Poziom)
{
    int dx = 0, dy = 0;		/* przesunicie */
    int ustawiony_c = 0, idz = 0, cx = 0, cy = 0;	/* c[xy] to wsprzdne celu */
    char do_wykonania = '!';	/* Znak z trasy */
    int panika = ((Potwor->psych * 100) / Potwor->psych_max <= PANIKA);
    wsk_istota tmp = Poziom->Istoty.aktualny;

    policzona_widocznosc = 0;
    if (panika) {
	dx = losowa(3) - 2;
	dy = losowa(3) - 2;
	goto wykonaj_ruch;
    }
    if (!czy_jest_glodny(Potwor)) {
	return;
    }

    obsluga_dnia_i_nocy(Potwor);

    /* Akcje */
    switch (Potwor->akcja) {
    case SPI:
    case STOI:
    case PILNUJE:
	goto koncz;
    }

    obsluga_straznika(Potwor);

    if (obsluga_tras(Potwor, &dx, &dy, &idz, &do_wykonania)) {
	goto wykonaj_ruch;
    }

    /* Dowdca onierzy ...  (XXX: to powinno by obsugiwane przez flagi) */
    if (Potwor->ID == PST_DCA_ZOLNIERZY)
	if (Potwor->cel_ataku != NULL) {
	    zmien_cel_ataku(3, Potwor->cel_ataku, Poziom);
	}

    /* Idziemy */
    if (!(Potwor->flagi & FLAGA_NIERUCHAWOSCI))
	/* nie ruszajmy grzybkw, niech sobie rosn ...  */
    {
	dx = losowa(3) - 2;
	dy = losowa(3) - 2;

	/* Rzucamy si na nieznajomych, jeeli mamy ustawion flag wrogoci */
	obsluga_wrogosci(Potwor, Poziom);

	/* Gonimy wroga */
	gon_wroga(Potwor, Poziom, &ustawiony_c, &idz, &cx, &cy);

	if (obsluga_sklepikarza
	    (Potwor, Poziom, &idz, &ustawiony_c, &dx, &dy, &cx, &cy)) {
	    goto koncz;
	}
#ifdef DEBUG
	if (Potwor->x < 0 || Potwor->y < 0) {
	    dodaj_napis("CZOWIEK POZA BURT! ");
	    pobierz_klawisz();
	}
#endif
	if (idz)
	    idz_do_punktu(Potwor, Poziom, &dx, &dy, ustawiony_c, cx, cy);

    }

  wykonaj_ruch:
    /* Sprawdzamy, czy nie obijamy mordy niewinnym dzieciom */
    if (!panika)
	if (dx || dy)
	    if (szukaj_postaci
		(Potwor->x + dx, Potwor->y + dy,
		 &Poziom->Istoty) == ZNALAZL) {
		if ((Potwor->flagi & FLAGA_POKOJOWOSCI)
		    || !(rozny_align(Potwor, Poziom->Istoty.aktualny))) {
		    if (Potwor->cel_ataku != Poziom->Istoty.aktualny) {
			goto koncz;
		    }
		}
	    }

/* Waciwy ruch */
    przesun_postac(Potwor, Poziom, dx, dy);

/* Sprawdzamy, co te osignlimy */
    sprawdz_czy_doszedl(Potwor, do_wykonania);

  koncz:
    if (policzona_widocznosc) {
	wyczysc_widocznosc(Potwor);
	policzona_widocznosc = 0;
    }
    Poziom->Istoty.aktualny = tmp;
}

/* Usuwa potwora z listy */
void zabij_potwora(struct istoty *Istoty, struct poziom *Poziom)
{
    if (Istoty->aktualny->plecak.ile)
	Istoty->aktualny->plecak.aktualny =
	    Istoty->aktualny->plecak.poczatek->nast;
    upusc_ekwipunek(Istoty->aktualny, &Poziom->Przedmioty);
    while (Istoty->aktualny->plecak.ile) {
	Istoty->aktualny->plecak.aktualny =
	    Istoty->aktualny->plecak.poczatek->nast;
	poloz_przedmioty(&Poziom->Przedmioty, Istoty->aktualny,
			 Istoty->aktualny->plecak.aktualny->ilosc);
    }
    if (Istoty->aktualny->au)
	dodaj_ladnie(Istoty->aktualny->x, Istoty->aktualny->y,
		     Istoty->aktualny->au, PRZ_ZLOTO,
		     przedmiotyID.ID[PRZ_ZLOTO].flagi, 1,
		     &Poziom->Przedmioty);
    if (!(Istoty->aktualny->flagi & FLAGA_GRACZA))
	usun_postac(Istoty);
}

void
dajcie_mu_spokoj_on_nie_zyje(struct poziom *Poziom, struct istota *trup, struct istota *atakujacy)
{
    int widzi1, widzi2;
    wsk_istota tmp;
    char tmp2[50];
    strcpy(tmp2, trup->nazwa);
    tmp2[0] = toupper(tmp2[0]);
    /* Oprawcy daj mu spokj */
    widzi2 = Poziom->widoczne_gracz[trup->x][trup->y];
    tmp = Poziom->Istoty.aktualny;
    for (Poziom->Istoty.aktualny = Poziom->Istoty.poczatek->nast;
	 Poziom->Istoty.aktualny != Poziom->Istoty.koniec;
	 Poziom->Istoty.aktualny = Poziom->Istoty.aktualny->nast) {
	widzi1 =
	    Poziom->widoczne_gracz[Poziom->Istoty.aktualny->x][Poziom->
							       Istoty.
							       aktualny->
							       y];
	if (Poziom->Istoty.aktualny->cel_ataku == trup) {
	    Poziom->Istoty.aktualny->cel_ataku = NULL;
	    Poziom->Istoty.aktualny->ost_x_celu = -1;
	    zabito_potwora(trup->ID, Poziom->Istoty.aktualny);
	    dodaj_exp(Poziom->Istoty.aktualny, potworyID.ID[trup->ID].exp);
/* 	    strcpy(zabojca, Poziom->Istoty.aktualny->nazwa); */
	}
    }
    if (trup->flagi & FLAGA_GRACZA) {
        if (atakujacy != NULL) { /* Nieustawiony powd mierci */
	strcat(powod_smierci, _("Zabi go "));
	strcat(powod_smierci, atakujacy->nazwa);
	strcat(powod_smierci, " ");
      }
    } else {
	if (widzi1 || widzi2) {
	    dodaj_napis(tmp2);
	    dodaj_napis(_(" nie yje. "));
	}
    }
    Poziom->Istoty.aktualny = tmp;
}

char *nazwa_klasy(int nr_klasy)
{
    switch (nr_klasy) {
    case WOJOWNIK:
	return _("wojownik");
    case CZARODZIEJ:
	return _("czarodziej");
    case BARBARZYNCA:
	return _("barbarzyca");
    default:
	return _("nieznanej klasy");
    }
}
char *nazwa_rasy(int nr_rasy)
{
    switch (nr_rasy) {
    case CZLOWIEK:
	return _("czowiek");
    case KRASNOLUD:
	return _("krasnolud");
    case WYSOKI_ELF:
	return _("wysoki elf");
    case CZARNY_ELF:
	return _("czarny elf");
    case ORK:
	return _("ork");
    case KOBOLD:
	return _("kobold");
    case TROLL:
	return _("troll");
    default:
	return _("nieznanej rasy");
    }
}
char *nazwa_plci(int nr_plci)
{
    switch (nr_plci) {
    case KOBIETA:
	return _("K");
    case MEZCZYZNA:
	return _("M");
    case OBOJNAK:
	return _("O");
    default:
	return _("nieznanej pci");
    }
}

char *nazwa_miejsca(char *buf, int miejsce)
{
    switch (miejsce) {
    case GLOWAS ... GLOWAK:
	return _("gow");
	break;
    case SZYJAS ... SZYJAK:
	return _("szyj");
	break;
    case KORPUSS ... KORPUSK:
	return _("tuw");
	break;
    case REKAS ... REKAK:
	return _("rk");
	break;
    case NOGAS ... NOGAK:
	return _("nog");
	break;
    default:
	return _("tajemnicz cz ciaa");
	break;
    }
}

void
odpadnij(struct istota *ktorej_odpadlo, struct przedmioty *Gdzie,
	 int miejsce_odpadniete)
{
    char tmp[100];
    int gracz = (ktorej_odpadlo->flagi & FLAGA_GRACZA);
    int widzi =
	Poziom.widoczne_gracz[ktorej_odpadlo->x][ktorej_odpadlo->y];

    if (ktorej_odpadlo->ekw.miejsce[miejsce_odpadniete].ile)
	ktorej_odpadlo->ekw.miejsce[miejsce_odpadniete].aktualny =
	    ktorej_odpadlo->ekw.miejsce[miejsce_odpadniete].poczatek->nast;
    while (ktorej_odpadlo->ekw.miejsce[miejsce_odpadniete].ile)
	upusc_przedmiot(Gdzie,
			&ktorej_odpadlo->ekw.miejsce[miejsce_odpadniete],
			ktorej_odpadlo->x, ktorej_odpadlo->y);
    if (widzi) {
	char buf[100], nazwa[100];
	strcpy(nazwa, ktorej_odpadlo->nazwa);
	nazwa[0] = toupper(nazwa[0]);
	if (gracz) {
	    sprintf(tmp, _("Stracie %s. "),
		    nazwa_miejsca(buf, miejsce_odpadniete));
	} else {
	    sprintf(tmp, _("%s straci %s. "), nazwa,
		    nazwa_miejsca(buf, miejsce_odpadniete));
	};
	dodaj_napis(tmp);
    }
    zmien_przyt(ktorej_odpadlo, -10);
    ktorej_odpadlo->anatomia.suma -=
	ktorej_odpadlo->anatomia.miejsce[miejsce_odpadniete];
    ktorej_odpadlo->anatomia.miejsce[miejsce_odpadniete] = 0;
    /* Tu s efekty pozbawienia czci ciaa */
    switch (miejsce_odpadniete) {
	/* Trzeba sprawdzi, czy jeszcze jakie gowy zostay ...  */
    case GLOWAS ... GLOWAK:
	ktorej_odpadlo->flagi |= FLAGA_SMIERCI;
	break;
    case SZYJAS ... SZYJAK:
	odpadnij(ktorej_odpadlo, Gdzie,
		 GLOWAS + (miejsce_odpadniete - SZYJAS));
	break;
    case KORPUSS ... KORPUSK:
	ktorej_odpadlo->flagi |= FLAGA_SMIERCI;
	break;
    case NOGAS ... NOGAK:
	ktorej_odpadlo->anatomia.dozwolone_pozycje &=
	    ~(POZ_STOI | POZ_KUCA);
	ktorej_odpadlo->pozycja = POZ_LEZY;
	if (widzi) {
	    if (gracz) {
		dodaj_napis(_("Upade. "));
	    } else {
		dodaj_napis(_("Upad. "));
	    }
	}
	break;
    }
}
