
/* poziom.c */
#include "poziom.h"

#ifndef min
#define min(x,y) ((x) < (y) ? (x) : (y))
#endif
#ifndef max
#define max(x,y) ((x) > (y) ? (x) : (y))
#endif

WINDOW *wPoziom;
struct poziom Poziom;

void init_terenow()
{
    ustaw_plik(&Plik, "TERE0F");
    laduj_tereny(&Plik);
}

void laduj_tereny(struct _plik *plik)
{
    sread(plik, &teren, MAXTEREN * sizeof(struct _teren));
}

void laduj_poziom(struct _plik *plik, struct poziom *Poziom)
{
    int x, y;
/*	XXX Na razie nie mona z tego korzysta
        sread(plik, &Poziom->maxx, sizeof(Poziom->maxx));
	sread(plik, &Poziom->maxy, sizeof(Poziom->maxy));
	sread(plik, &Poziom->poczx, sizeof(Poziom->poczx));
	sread(plik, &Poziom->poczy, sizeof(Poziom->poczy));
	sread(plik, &Poziom->poziom, sizeof(Poziom->poziom)); */
    Poziom->maxx = sgetc(plik);
    Poziom->maxy = sgetc(plik);
    Poziom->poczx = sgetc(plik);
    Poziom->poczy = sgetc(plik);
    Poziom->poziom = sgetc(plik);
    Poziom->Istoty.maxszybkosc = -1;

    for (y = 0; y < Poziom->maxy; y++) {
	for (x = 0; x < Poziom->maxx; x++) {
	    sread(plik, &Poziom->pole[x][y], sizeof(int));
	    Poziom->znane[x][y] = 0;
            zajete[x][y]= '.';
	}
    }
}

void zapisz_poziom(char *out, long int *ile, struct poziom *Poziom)
{
    int x, y;
    /* XXX Uwaga taka sama jak przy adowaniu */
    out[0] = Poziom->maxx;
    out[1] = Poziom->maxy;
    out[2] = Poziom->poczx;
    out[3] = Poziom->poczy;
    out[4] = Poziom->poziom;
    *ile = 5;
    for (y = 0; y < Poziom->maxy; y++) {
	for (x = 0; x < Poziom->maxx; x++) {
	    memcpy(&out[*ile], &Poziom->pole[x][y], sizeof(unsigned int));
	    (*ile) += sizeof(unsigned int);
	}
    }
}

void zapisz_znane(char *out, long int *ile, struct poziom *Poziom)
{
    memcpy(out, &Poziom->znane, MAXX * MAXY * (sizeof(short int)));
    *ile = MAXX * MAXY * (sizeof(short int));
}

void wczytaj_znane(struct _plik *plik, struct poziom *Poziom)
{
    sread(plik, &Poziom->znane, MAXX * MAXY * (sizeof(short int)));
}

void zmien_aktualny_poziom(struct poziom *Poziom, struct delta delta)
{
    char nazwa[7], *temp;
    temp = my_malloc(MAXTAB * sizeof(char));
    strcpy(nazwa, Poziom->nazwa);
/* Najpierw zapiszmy dane do tmpfile'a */

/* Poziom jako taki */
    zapisz_poziom(temp, &wielkosc_ostatniej_tablicy, Poziom);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */ 
/* Potwory */
    nazwa[5] = '3';
    zapisz_potwory(temp, &wielkosc_ostatniej_tablicy, &Poziom->Istoty);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
/* Przedmioty */
    nazwa[5] = '2';
    zapisz_przedmioty(temp, &wielkosc_ostatniej_tablicy,
		      &Poziom->Przedmioty);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
/* Znane pola poziomu */
    nazwa[5] = '9';
    zapisz_znane(temp, &wielkosc_ostatniej_tablicy, Poziom);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
/* Strefy */
    nazwa[5] = 'A';
    zapisz_strefy(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
/* Puapki */
    nazwa[5] = 'E';
    zapisz_pulapki(temp, &wielkosc_ostatniej_tablicy);
    dodaj_do_pliku(temp, nazwa, &Pliktmp);
    fflush(Pliktmp.strumykz);
    /* gzflush(Pliktmp.strumykz, Z_FULL_FLUSH); */
/* no i koniec */
    nazwa[5] = '1';
    wclear(wPoziom);
    my_free(temp);
/* Teraz wadujmy poziom */
    if (delta.x > 1) {
	if (delta.x == 2) {
	    swiat.z--;
	    /* Wyrwnanie pozycji gracza... */
	    Poziom->Istoty.poczatek->nast->x +=
		swiat.pole[swiat.x][swiat.y][swiat.z].dx;
	    Poziom->Istoty.poczatek->nast->y +=
		swiat.pole[swiat.x][swiat.y][swiat.z].dy;
	} else {
	    /* Wyrwnanie pozycji gracza... */
	    Poziom->Istoty.poczatek->nast->x -=
		swiat.pole[swiat.x][swiat.y][swiat.z].dx;
	    Poziom->Istoty.poczatek->nast->y -=
		swiat.pole[swiat.x][swiat.y][swiat.z].dy;
	    swiat.z++;
	}
    } else {
	swiat.x += delta.x;
	swiat.y += delta.y;
	if (swiat.x < 0) {
	    swiat.x = SWX - 1;
	}
	if (swiat.x > SWX - 1) {
	    swiat.x = 0;
	}
	if (swiat.y < 0) {
	    swiat.y = SWY - 1;
	}
	if (swiat.y > SWY - 1) {
	    swiat.y = 0;
	}
    }
    strcpy(nazwa, swiat.pole[swiat.x][swiat.y][swiat.z].nazwa);
    nazwa[5] = '1';
    nazwa[6] = '\0';

    Pliktmp.strumyk = fopen(sciezka_do_tmpliku, "rb");
    wyczysc_liste_potworow(&Poziom->Istoty);
    wyczysc_liste_przedmiotow(&Poziom->Przedmioty);
    wyczysc_cala_widocznosc(Poziom->Istoty.poczatek->nast);
    wyczysc_strefy();
    wyczysc_miejsca();
    wyczysc_trasy();
    wyczysc_pulapki();
    if (swiat.pole[swiat.x][swiat.y][swiat.z].wygenerowane) {
	/* Trasy i miejsca charakterystyczne, nie widz powodu, eby miay by w tempfile'u */
	nazwa[5] = 'C';
	if (ustaw_plik(&Plik, nazwa)) {
	    laduj_miejsca(&Plik);
	}
	nazwa[5] = 'D';
	if (ustaw_plik(&Plik, nazwa)) {
	    laduj_trasy(&Plik);
	}
	nazwa[5] = '1';
	/* A dotd... */
	if (ustaw_plik(&Pliktmp, nazwa)) {	/* Jest w tmpfile'u */
	    laduj_poziom(&Pliktmp, Poziom);
	    policz_czestosci(Poziom->poziom, &przedmiotyID);
	    /* Strefy musz by adowane _przed_ potworami i przedmiotami */
	    nazwa[5] = 'A';
	    ustaw_plik(&Pliktmp, nazwa);
	    wczytaj_strefy(&Pliktmp);
	    nazwa[5] = '3';
	    ustaw_plik(&Pliktmp, nazwa);
	    wczytaj_potwory(&Pliktmp, &Poziom->Istoty);
	    nazwa[5] = '2';
	    ustaw_plik(&Pliktmp, nazwa);
	    wczytaj_przedmioty(&Pliktmp, &Poziom->Przedmioty);
	    nazwa[5] = '9';
	    ustaw_plik(&Pliktmp, nazwa);
	    wczytaj_znane(&Pliktmp, Poziom);
	    nazwa[5] = 'E';
	    ustaw_plik(&Pliktmp, nazwa);
	    laduj_pulapki(&Pliktmp);
	} else {		/* Jest w lib.data */

	    ustaw_plik(&Plik, nazwa);
	    laduj_poziom(&Plik, Poziom);
	    policz_czestosci(Poziom->poziom, &przedmiotyID);
	    /* Strefy _przed_ potworami */
	    nazwa[5] = 'A';
	    if (ustaw_plik(&Plik, nazwa))
		wczytaj_strefy(&Plik);
	    nazwa[5] = '7';
	    if (ustaw_plik(&Plik, nazwa))
		wczytaj_potwory_kr(&Plik, &Poziom->Istoty);
	    nazwa[5] = 'H';
	    if (ustaw_plik(&Plik, nazwa))
		wczytaj_przedmioty_kr(&Plik, &Poziom->Przedmioty);
	    nazwa[5] = 'E';
	    if (ustaw_plik(&Plik, nazwa))
		laduj_pulapki(&Plik);
	}
    } else {
	Poziom->poziom = swiat.pole[swiat.x][swiat.y][swiat.z].poziom;
	policz_czestosci(Poziom->poziom, &przedmiotyID);
	generuj(Poziom, swiat.x, swiat.y, swiat.z);
    }
    nazwa[5] = '1';
    strcpy(Poziom->nazwa, nazwa);
    fclose(Pliktmp.strumyk);
    swiat.pole[swiat.x][swiat.y][swiat.z].wygenerowane = 1;
}

void rysuj_poziom(struct poziom *Poziom)
{
    int x, y;
    char znak;
    znak = '?';
    wmove(wPoziom, 0, 0);
    if (dzien) {
	for (y = Poziom->sy; y <= Poziom->ky; y++) {
	    wmove(wPoziom, y - Poziom->sy, 0);
	    for (x = Poziom->sx; x <= Poziom->kx; x++)
		if (x < Poziom->maxx && x >= 0 && y < Poziom->maxy
		    && y >= 0) {
		    if (Poziom->znane[x][y]) {
			zmien_kolor(teren[Poziom->pole[x][y]].kolor,
				    wPoziom);
			waddch(wPoziom, teren[Poziom->pole[x][y]].znak);
		    } else
			waddch(wPoziom, ' ');
		}
	}
    } else {			/* Noc */

	for (y = Poziom->sy; y <= Poziom->ky; y++) {
	    wmove(wPoziom, y - Poziom->sy, 0);
	    for (x = Poziom->sx; x <= Poziom->kx; x++)
		if (x < Poziom->maxx && x >= 0 && y < Poziom->maxy
		    && y >= 0) {
		    if ((Poziom->znane[x][y]
			 && teren[Poziom->pole[x][y]].flagi &
			 TER_WIDAC_W_CIEMNOSCI)
			|| Poziom->widoczne_gracz[x][y]) {
			zmien_kolor(teren[Poziom->pole[x][y]].kolor,
				    wPoziom);
			znak = teren[Poziom->pole[x][y]].znak;
		    } else {
			znak = ' ';
		    }
		    waddch(wPoziom, znak);
		}

	}
    }
}

/* Zamienia jedno pole poziomu na jakie inne 
 * (np. drzwi zamknite na otwarte) */
void zmien_poziom(struct poziom *Poziom, int x, int y, int jak)
{
    Poziom->pole[x][y] = jak;
}

/* Zwraca pole(x,y) */
int pole(struct poziom *Poziom, int x, int y)
{
    return Poziom->pole[x][y];
}

struct delta szukaj_pola(struct poziom *Poziom, int jakiego, int x, int y)
{
    struct delta D;
    int i, j;
    D.x = -3;
    D.y = -3;
    for (i = -1; i < 2; i++)
	for (j = -1; j < 2; j++)
	    if (Poziom->pole[x + i][y + j] == jakiego) {
		D.x = i;
		D.y = j;
	    }
    return D;
}

/* Czyni pole widocznym przez Postac */
void
poznaj_pole(struct poziom *Poziom, int x, int y, struct istota *Postac)
{
    if (x >= 0 && x < Poziom->maxx && y >= 0 && y < Poziom->maxy) {
	if (Postac->flagi & FLAGA_GRACZA) {
	    Poziom->znane[x][y] = TRUE;
	    Poziom->widoczne_gracz[x][y] = TRUE;
	} else {
	    Poziom->widoczne_potwor[x][y] = TRUE;
	}
    }

}

/* Postac poznaje swoje najblisze otoczenie */
void poznaj_otoczenie(struct poziom *Poziom, struct istota *Postac)
{
    int i, j, x, y;
    x = Postac->x;
    y = Postac->y;
    for (i = -1; i < 2; i++)
	for (j = -1; j < 2; j++)
	    if (x + i >= 0 && x + i < Poziom->maxx && y + j >= 0
		&& y + j < Poziom->maxy) {
		if (Postac->flagi & FLAGA_GRACZA) {
		    Poziom->widoczne_gracz[x + i][y + j] = TRUE;
		    Poziom->znane[x + i][y + j] = TRUE;
		} else {
		    Poziom->widoczne_potwor[x + i][y + j] = TRUE;
		}
	    }
}

void otworz_drzwi(struct poziom *Poziom, int x, int y)
{
    Poziom->pole[x][y] = DRZWI_OTWARTE;
}

void zamknij_drzwi(struct poziom *Poziom, int x, int y)
{
    Poziom->pole[x][y] = DRZWI_ZAMKNIETE;
}

/* Ujawnia cay poziom */
void poznaj_caly(struct poziom *Poziom)
{
    int x, y;
    for (x = 0; x < Poziom->maxx; x++)
	for (y = 0; y < Poziom->maxy; y++)
	    Poziom->znane[x][y] = TRUE;
}

/* zwraca 1 jesli mozna zobaczyc dalej... */
int sprawdz_widocznosc(struct poziom *Poziom, int x, int y)
{
    int wynik;
    wynik = 1;
    switch (Poziom->pole[x][y]) {
    case MUR:
    case DRZWI_ZAMKNIETE:
    case DRZWI_ZAMKNIETE_NA_KLUCZ:
    case DRZEWO:
	wynik = 0;
	break;
    }
    if (x < 0 || x >= Poziom->maxx || y < 0 || y >= Poziom->maxy) {
	wynik = 0;
    }
    return wynik;
}

/* Poznaje pola lece na linii (x1,y1)-(x2,y2) */
void
poznaj_linie(struct poziom *Poziom, struct istota *Postac, int x1, int y1,
	     int x2, int y2)
{
    int dx, dy, d, x, y, d1, d2, sx, sy, koniec;
    koniec = 0;
    dx = abs(x2 - x1);
    dy = abs(y2 - y1);
    if (x2 >= x1)
	sx = 1;
    else
	sx = -1;
    if (y2 >= y1)
	sy = 1;
    else
	sy = -1;
    x = x1;
    y = y1;
    if (dx >= dy) {
	d = 2 * dy - dx;
	d1 = 2 * dy;
	d2 = 2 * (dy - dx);
	poznaj_pole(Poziom, x, y, Postac);
	koniec = !sprawdz_widocznosc(Poziom, x, y);
	while (x != x2 && !koniec) {
	    if (d < 0) {
		d += d1;
		x += sx;
	    } else {
		x += sx;
		y += sy;
		d += d2;
	    }
	    poznaj_pole(Poziom, x, y, Postac);

	    koniec = !sprawdz_widocznosc(Poziom, x, y);
	}
    } else {
	d = 2 * dx - dy;
	d1 = 2 * dx;
	d2 = 2 * (dx - dy);
	poznaj_pole(Poziom, x, y, Postac);
	koniec = !sprawdz_widocznosc(Poziom, x, y);
	while (y != y2 && !koniec) {
	    if (d < 0) {
		d += d1;
		y += sy;
	    } else {
		x += sx;
		y += sy;
		d += d2;
	    }
	    poznaj_pole(Poziom, x, y, Postac);
	    koniec = !sprawdz_widocznosc(Poziom, x, y);
	}
    }
}

/* wykonuje poznaj_linie na kole O(x,y),r=ile
 * Wersja o zwikszonej szybkoci kosztem dokadnoci */
void poznaj2(struct poziom *Poziom, struct istota *Postac)
{
    int x, y, ile, x_, y_, z, granica;
    Poziom->ostatnio_liczona_widocznosc = Postac;
    x = Postac->x;
    y = Postac->y;
    ile = Postac->zasieg_widzenia;
/*  for (x_ = -ile; x_ <= ile; x_++)
   {
   granica = rint (sqrt (ile * ile - x_ * x_));
   for (y_ = -granica; y_ <= granica; y_++)
   {
   poznaj_linie (Poziom, Postac, x, y, x + x_, y + y_);
   }
   } */
    y_ = 0;
    for (x_ = -ile; x_ <= ile; x_++) {
	granica = rint(sqrt(ile * ile - x_ * x_));
	poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y - granica);
	poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y + granica);
	if (y_ - 1 > granica)
	    for (z = granica + 1; z < y_; z++) {
		poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y - z);
		poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y + z);
	    }
	if (y_ + 1 < granica)
	    for (z = granica - 1; z > y_; z--) {
		poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y - z);
		poznaj_linie(Poziom, Postac, x, y, x + rint(x_), y + z);

	    }
	y_ = granica;
    }

}

void poznaj(struct poziom *Poziom, struct istota *Postac)
{
    unsigned long rays[256];
    short x, y, i, f, t, bl, yc = Postac->y, xc = Postac->x;
    long pow;
    int wsp_widz = Postac->zasieg_widzenia * 400;
    if (!(Postac->flagi & FLAGA_GRACZA)) {
	poznaj2(Poziom, Postac);
	return;
    }
    for (i = 0; i < 256; i++)
	rays[i] = 0;

    for (y = yc; y < Poziom->maxy; y++) {
	for (x = xc; x < Poziom->maxx; x++) {
	    pow = 20000;
	    bl = 1;
	    bl = teren[Poziom->pole[x][y]].los_bl;
	    f = lut[x - xc][y - yc][0];
	    t = lut[x - xc][y - yc][1];
	    for (i = f; i <= t; i++) {
		if (pow > rays[i])
		    pow = rays[i];
		rays[i] += bl;
	    }
	    if (min(pow, 20000) < wsp_widz) {
		poznaj_pole(Poziom, x, y, Postac);
	    }
	}
    }

    for (i = 0; i < 256; i++)
	rays[i] = 0;
    for (y = yc; y >= 0; y--) {
	for (x = xc; x < Poziom->maxx; x++) {
	    pow = 20000;
	    bl = 1;
	    bl = teren[Poziom->pole[x][y]].los_bl;
	    /* wspczynnik blokady linii wzroku */

	    f = lut[x - xc][yc - y][0];
	    t = lut[x - xc][yc - y][1];
	    for (i = f; i <= t; i++) {
		if (pow > rays[i])
		    pow = rays[i];
		rays[i] += bl;
	    }
	    if (min(pow, 20000) < wsp_widz) {
		poznaj_pole(Poziom, x, y, Postac);
	    }
	}
    }

    for (i = 0; i < 256; i++)
	rays[i] = 0;
    for (y = yc; y >= 0; y--) {
	for (x = xc; x >= 0; x--) {
	    pow = 20000;
	    bl = 1;
/*        if ((map[x][y] & tf_below) == 0)
            bl=terrain[map[x][y] & terrain_mask ].block;*/
	    bl = teren[Poziom->pole[x][y]].los_bl;
	    f = lut[xc - x][yc - y][0];
	    t = lut[xc - x][yc - y][1];
	    for (i = f; i <= t; i++) {
		if (pow > rays[i])
		    pow = rays[i];
		rays[i] += bl;
	    }
	    if (min(pow, 20000) < wsp_widz) {
		poznaj_pole(Poziom, x, y, Postac);
	    }
	}
    }

    for (i = 0; i < 256; i++)
	rays[i] = 0;
    for (y = yc; y < Poziom->maxy; y++) {
	for (x = xc; x >= 0; x--) {
	    pow = 20000;
	    bl = 1;
/*        if ((map[x][y] & tf_below) == 0)
            bl=terrain[map[x][y] & terrain_mask ].block; */
	    bl = teren[Poziom->pole[x][y]].los_bl;
	    f = lut[xc - x][y - yc][0];
	    t = lut[xc - x][y - yc][1];
	    for (i = f; i <= t; i++) {
		if (pow > rays[i])
		    pow = rays[i];
		rays[i] += bl;
	    }
	    if (min(pow, 20000) < wsp_widz) {
		poznaj_pole(Poziom, x, y, Postac);
	    }
	}
    }
}

void init_fov()
{
    short a, d, x, y, lx, ly, dx, dy, los_lines = 256;
    double s, c, an;

    for (x = 0; x < MAXX; x++)
	for (y = 0; y < MAXY; y++) {
	    lut[x][y][0] = 255;
	    lut[x][y][1] = 0;
	}

    for (a = 0; a < los_lines; a++) {
	an = (((float) a) * M_PI) / (los_lines * 2);
	s = sin(an) / 4;
	c = cos(an) / 4;
	lx = ly = 0;
	d = 0;
	do {
	    x = (short) floor(s * d);
	    y = (short) floor(c * d);

	    dx = (x - lx);
	    dy = (y - ly);
	    if ((x < MAXX) && (y < MAXY)) {
		lut[x][y][0] = min(lut[x][y][0], a);
		lut[x][y][1] = max(lut[x][y][1], a);
	    }
	    d++;
	}
	while ((x < MAXX) && (y < MAXY));
    }

/*  { int ile=0;

  for(y=0; y<64; y++)
    for(x=0; x<64; x++)
     ile+=(lut[x][y][1]-lut[x][y][0]); */

}

short int
czy_mozna_wygenerowac(struct poziom *Poziom, int x, int y,
		      struct istota *Postac)
{
    if (!czy_mozna_wejsc(Poziom, x, y, Postac)) {
	return 0;
    }
    switch (Poziom->pole[x][y]) {
    case DRZWI_ZAMKNIETE:
    case ZEJSCIE:
    case WEJSCIE:
	return 0;
    }
    return !(Poziom->widoczne_gracz[x][y]);
}

/* Zwraca jeden, jeeli mona wej na pole (x,y) i nikt tam nie stoi */
short int
czy_mozna_wejsc(struct poziom *Poziom, int x, int y, struct istota *Postac)
{
    wsk_istota back = Poziom->Istoty.aktualny;
    int bx = Postac->x, by = Postac->y;
    if (Postac->cel_ataku)
	if (Postac->cel_ataku->x == x && Postac->cel_ataku->y == y) {
	    return 1;
	}
    Postac->x = -1;
    Postac->y = -1;
    if (!mozna_wejsc(Poziom, x, y, Postac)) {
	Poziom->Istoty.aktualny = back;
	Postac->x = bx;
	Postac->y = by;
	return 0;
    }
    if ((szukaj_postaci(x, y, &Poziom->Istoty) == ZNALAZL)
	&& (Poziom->Istoty.aktualny != Postac->cel_ataku)) {
	Poziom->Istoty.aktualny = back;
	Postac->x = bx;
	Postac->y = by;
	return 0;
    }
    Poziom->Istoty.aktualny = back;
    Postac->x = bx;
    Postac->y = by;
    return 1;
}

/* Zwraca jeden, jeeli mona wej (bez powanych konsekwencji) na pole(x,y) */
short int
mozna_wejsc(struct poziom *Poziom, int x, int y, struct istota *Postac)
{
    short int wynik = teren[Poziom->pole[x][y]].flagi & TER_MOZNA_WEJSC;
    if (Poziom->pole[x][y] == DRZWI_ZAMKNIETE
	&& (Postac->flagi & OBSLUGA_DRZWI))
	wynik = 1;
    if (teren[Poziom->pole[x][y]].flagi & TER_WODA && Postac->umiejetnosci[UM_PLYWANIE]) wynik = 1;
    return wynik;
}

void opisz_kratke(struct poziom *Pz, int x, int y)
{
    switch (pole(Pz, x, y)) {
    case TRAWA:
	dodaj_napis(_("Trawa. "));
	break;
    case MUR:
	dodaj_napis(_("Mur. "));
	break;
    case KIBEL:
	dodaj_napis(_("Kibel. "));
	break;
    case DRZWI_ZAMKNIETE:
    case DRZWI_ZAMKNIETE_NA_KLUCZ:
	dodaj_napis(_("Zamknite drzwi. "));
	break;
    case WODA:
	dodaj_napis(_("Woda. "));
	break;
    case DROGA:
	dodaj_napis(_("Droga. "));
	break;
    case DRZEWO:
	dodaj_napis(_("Drzewo. "));
	break;
    case OLTARZ:
	dodaj_napis(_("Otarz. "));
	break;
    case ZEJSCIE:
	dodaj_napis(_("Zejscie na d. "));
	break;
    case LOZKO:
	dodaj_napis(_("ko. "));
        break;
    case WEJSCIE:
	dodaj_napis(_("Wejcie na gr. "));
	break;
    }
#ifdef DEBUG
 {
  char tmp[10];
  sprintf(tmp, "(%d,%d) ", x, y);
  dodaj_napis(tmp);
 }
#endif
}

/* Rysuje wszystkie postaci z listy */
void rysuj_postacie(struct poziom *Poziom)
{
    wsk_istota na_chwilke;
    na_chwilke = Poziom->Istoty.aktualny;
    for (Poziom->Istoty.aktualny = Poziom->Istoty.poczatek->nast;
	 Poziom->Istoty.aktualny != Poziom->Istoty.koniec;
	 Poziom->Istoty.aktualny = Poziom->Istoty.aktualny->nast)
	rysuj_postac(Poziom->Istoty.aktualny, Poziom);
    Poziom->Istoty.aktualny = na_chwilke;
}

/* Rusza wszystkie postaci z listy */
void rusz_postacie(struct poziom *Poziom)
{

    for (Poziom->Istoty.aktualny = Poziom->Istoty.poczatek->nast;
	 (Poziom->Istoty.aktualny != Poziom->Istoty.koniec)
	 && (!(Poziom->Istoty.poczatek->nast->flagi & FLAGA_SMIERCI));
	 Poziom->Istoty.aktualny = Poziom->Istoty.aktualny->nast) {
	ruch_postaci(Poziom->Istoty.aktualny, Poziom);
	if ((Poziom->Istoty.aktualny->flagi & FLAGA_SMIERCI)
	    && !(Poziom->Istoty.aktualny->flagi & FLAGA_GRACZA)) {
	    zabij_potwora(&Poziom->Istoty, Poziom);
	}
    }
}

void dodaj_potwory(struct poziom *Poziom, int ile, int poziom_t)
{
    int prob, flagi = 0;

    while (ile > 0) {
	int potw_x = losowa(Poziom->maxx) - 1,
	    potw_y = losowa(Poziom->maxy) - 1, ID = -1, i;
	long int k = losowa(poziom_d[poziom_t]);

	for (i = 0; (i < potworyID.ile && ID == -1); i++) {
	    if (potworyID.ID[i].poziom <= poziom_t) {
		k -= potworyID.ID[i].czestosc;
		if (k <= 0) {
		    ID = i;
		}
	    }
	}

	prob = 10000;
	if (losowa100() < 30)
	    flagi = FLAGA_WROGOSCI;
	dodaj_postac(potw_x, potw_y, ID, flagi, Poziom->poziom,
		     &Poziom->Istoty);
	zrob_ekwipunek(Poziom->Istoty.aktualny, Poziom->poziom);
	zrob_postac(Poziom->Istoty.aktualny);
	while ((!czy_mozna_wygenerowac
		(Poziom, potw_x, potw_y, Poziom->Istoty.aktualny)) && prob)
	{
	    potw_x = losowa(Poziom->maxx) - 1;
	    potw_y = losowa(Poziom->maxy) - 1;
	    Poziom->Istoty.aktualny->x = potw_x;
	    Poziom->Istoty.aktualny->y = potw_y;
	    prob--;
	}
	if (!prob) {
#ifdef DEBUG
	    dodaj_napis(_("Nie mog umieci potwora na poziomie. "));
#endif
	    usun_postac(&Poziom->Istoty);
	}
	ile--;
    }

}

void linia(struct poziom *Poziom, int x1, int y1, int x2, int y2)
{
    int mx = x2 - x1, my = y2 - y1;
    int tmp;
    if (!mx && !my)
	return;
    if (mx) {
	if (mx > 0) {
	    for (tmp = x1; tmp <= x2; tmp++)
		Poziom->pole[tmp][y1] = PODLOGA;
	} else {
	    for (tmp = x2; tmp <= x1; tmp++)
		Poziom->pole[tmp][y1] = PODLOGA;
	}
    } else {
	if (my > 0) {
	    for (tmp = y1; tmp <= y2; tmp++)
		Poziom->pole[x1][tmp] = PODLOGA;
	} else {
	    for (tmp = y2; tmp <= y1; tmp++)
		Poziom->pole[x1][tmp] = PODLOGA;
	}
    }
}

void dodaj_przedmioty(struct poziom *Poziom, int ile, int poziom_t)
{
    int prob;
    while (ile > 0) {
	int przx = 0, przy = 0, ID = -1, ok = 0;
	ID = szukaj_przedmiotu_z_poziomu(poziom_t);
	if (ID == -1)
	    goto nastepny;
	prob = 10000;
	while (!ok) {
	    przx = losowa(Poziom->maxx) - 1;
	    przy = losowa(Poziom->maxy) - 1;
	    switch (Poziom->pole[przx][przy]) {
	    case TRAWA:
	    case DROGA:
	    case PODLOGA:
		ok = !(Poziom->widoczne_gracz[przx][przy]);
		break;
	    }
	    if (!ok) {
		prob--;
	    }
	}

	if (!prob) {
#ifdef DEBUG
	    dodaj_napis(_("Nie mog umieci przedmiotu na poziomie. "));
#endif
	} else {
	    int ile_p = losowaoddo(przedmiotyID.ID[ID].ile_min,
				   przedmiotyID.ID[ID].ile_max);
	    if (ID == PRZ_ZLOTO) {
		ile_p = losowa(100 * Poziom->poziom);
	    }
	    dodaj_ladnie(przx, przy, ile_p, ID, przedmiotyID.ID[ID].flagi,
			 -1, &Poziom->Przedmioty);
	}
      nastepny:
	ile--;
    }
}

/* Zmienne potrzebne do generowania podziemi */
short int wejscie;
short int zejscie;
int schx, schy;
int ile_pok;
int ile_pol;

/* Sprawdzenie rnych rzeczy w sprawie stawiania korytarza */
short int
mozna_postawic_korytarz(struct poziom *Poziom, int sx, int sy, int kier)
{
    int tx, ty;
    /* Czy przypadkiem nie wyjdzie poza ekran */
    if (sx < 2 || sy < 2 || sx >= Poziom->maxx - 3
	|| sy >= Poziom->maxy - 3) {
	return 0;
    }
    /* Czy obok nie ma korytarza */
    switch (kier) {
    case 1:			/* N */
	for (tx = -1; tx < 2; /*tx++ */ tx += 2)
	    for (ty = -1; ty < 1; ty++)
		if (Poziom->pole[sx + tx][sy + ty] != MUR)
		    return 0;
	break;
    case 2:			/* E */
	for (tx = 0; tx < 2; tx++)
	    for (ty = -1; ty < 2; /*ty++ */ ty += 2)
		if (Poziom->pole[sx + tx][sy + ty] != MUR)
		    return 0;
	break;
    case 3:			/* S */
	for (tx = -1; tx < 2; /*tx++ */ tx += 2)
	    for (ty = 0; ty < 2; ty++)
		if (Poziom->pole[sx + tx][sy + ty] != MUR)
		    return 0;
	break;
    case 4:			/* W */
	for (tx = -1; tx < 1; tx++)
	    for (ty = -1; ty < 2; /*ty++ */ ty += 2)
		if (Poziom->pole[sx + tx][sy + ty] != MUR)
		    return 0;
	break;
    }
    return 1;
}

short int pokoj(struct poziom *Poziom, int sx, int sy, int kx, int ky)
{
    int tmpx, tmpy, wyjscia, ostatni = 0, chociaz_jeden_pokoj = 0, proba =
	0, tmp;
    /* Pierwszy pokj, z wejciem do podziemi */
    if (wejscie) {
	wejscie = 0;
	ostatni = 1;
	/* Dostalimy wszystkie wsprzdne */
	for (tmpx = sx; tmpx <= kx; tmpx++)
	    for (tmpy = sy; tmpy <= ky; tmpy++) {
		Poziom->pole[tmpx][tmpy] = PODLOGA;
		ile_pol++;
	    }
	/* Wejcie */
	Poziom->pole[schx][schy] = WEJSCIE;
    } else {			/* Jakikolwiek nastpny pokj */

	int dx = kx - sx,
	    dy = ky - sy, tsx = 0, tsy = 0, tkx = 0, tky = 0, ok = 0;
	proba = 0;
	while (!ok) {
	    if (dx == 1) {
		tsx = kx;
		tkx = kx + losowa(10);
		tsy = ky - losowa(5);
		tky = ky + losowa(5);
	    }
	    if (dx == -1) {
		tsx = kx - losowa(10);
		tkx = kx;
		tsy = ky - losowa(5);
		tky = ky + losowa(5);
	    }
	    if (dy == 1) {
		tsy = ky;
		tky = ky + losowa(10);
		tsx = kx - losowa(5);
		tkx = kx + losowa(5);
	    }
	    if (dy == -1) {
		tsy = ky - losowa(10);
		tky = ky;
		tsx = kx - losowa(5);
		tkx = kx + losowa(5);
	    }
	    if (tsx < 1)
		tsx = 1;
	    if (tsy < 1)
		tsy = 1;
	    if (tkx >= Poziom->maxx - 1)
		tkx = Poziom->maxx - 2;
	    if (tky >= Poziom->maxy - 1)
		tky = Poziom->maxy - 2;
	    ok = 1;
/* Testy */
/* Czy nie za may pokj */
	    if ((tkx - tsx) < 4)
		ok = 0;
	    if ((tky - tsy) < 4)
		ok = 0;
/* Czy teren jest wolny */
	    for (tmpx = tsx - 1; tmpx <= tkx + 1; tmpx++)
		for (tmpy = tsy - 1; tmpy <= tky + 1; tmpy++)
		    ok = ok * ((Poziom->pole[tmpx][tmpy] == MUR)
			       || (tmpx == sx && tmpy == sy));
	    proba++;
	    if (!ok && proba > MAXPROB) {	/* Moe by nieadnie */
		return 0;
	    }
	}
	sx = tsx;
	kx = tkx;
	sy = tsy;
	ky = tky;
	for (tmpx = sx; tmpx <= kx; tmpx++)
	    for (tmpy = sy; tmpy <= ky; tmpy++)
		Poziom->pole[tmpx][tmpy] = PODLOGA;
	if ((tmp = losowa(1000) < 1000 * ile_pok / 5) && !zejscie) {	/* Tu zrobimy zejcie niej */
	    zejscie = 1;
	    Poziom->pole[losowaoddo(sx, kx)][losowaoddo(sy, ky)] = ZEJSCIE;
	}
    }
    /* Wyjcia z pokoju */
    ile_pok++;
    wyjscia = losowaoddo(1, MAXDRZWI);
    proba = 0;
    while (wyjscia) {
	int zrobione_wyjscie = 0;
	int krsx = 0, krsy = 0, krk = 0;
	wyjscia--;
	while (!zrobione_wyjscie) {
	    proba++;
	    switch (losowa(4)) {
	    case 1:		/* N */
		krsx = losowaoddo(sx + 1, kx - 1);
		krsy = sy - 1;
		krk = 1;
		break;
	    case 2:		/* E */
		krsx = kx + 1;
		krsy = losowaoddo(sy + 1, ky - 1);
		krk = 2;
		break;
	    case 3:		/* S */
		krsx = losowaoddo(sx + 1, kx - 1);
		krsy = ky + 1;
		krk = 3;
		break;
	    case 4:		/* W */
		krsx = sx - 1;
		krsy = losowaoddo(sy + 1, ky - 1);
		krk = 4;
		break;
	    default:
		dodaj_napis("Kurcze, losowa(4) nie dziaa jak naley");
		break;
	    }
	    if (mozna_postawic_korytarz(Poziom, krsx, krsy, krk)) {
		chociaz_jeden_pokoj +=
		    korytarz(Poziom, krsx, krsy, krk, 1);
		zrobione_wyjscie = 1;
	    }
	    if (proba > MAXPROB) {
		wyjscia = 0;
		zrobione_wyjscie = 1;
	    }
	}
	if (!chociaz_jeden_pokoj && ostatni) {
	    wyjscia++;
	}
    }
    if (ostatni && !zejscie) {
	int ok = 0;
	while (!ok) {
	    tmpx = losowaoddo(sx, kx);
	    tmpy = losowaoddo(sy, ky);
	    ok = (Poziom->pole[tmpx][tmpy] == PODLOGA);
	}
	Poziom->pole[tmpx][tmpy] = ZEJSCIE;
    }
    return 1;
}

char wyjscie()
{
    int i = losowa(100);
/*  Wykomentowane do czasu zrobienia obsugi zamknitych drzwi
	if (i < 5)
	{ return DRZWI_ZAMKNIETE_NA_KLUCZ;}
*/
    if (i < 20) {
	return DRZWI_OTWARTE;
    }
    return DRZWI_ZAMKNIETE;
}

short int
mozna_postawic_pole(struct poziom *Poziom, int x, int y, int kierunek)
{
    short int wynik = 1;

#define mur_(x,y) (Poziom->pole[x][y]==MUR)
    /* Czy si mieci na poziomie */
    wynik *= (x > 0 && x < Poziom->maxx - 1 && y > 0
	      && y < Poziom->maxy - 1);
    if (!wynik) {
	return wynik;
    }
/*    if (kierunek==2 || kierunek==4) {
	int dy = (kierunek == 2) - (kierunek == 4);
	wynik *= (Poziom->pole[x][y + dy] != MUR) ||
	    (Poziom->pole[x - 1][y + dy] == MUR
	     && Poziom->pole[x + 1][y + dy] == MUR);
    } else {
	int dx = (kierunek == 3) - (kierunek == 1);
	wynik *= (Poziom->pole[x + dx][y] != MUR)
	    || (Poziom->pole[x][y - 1] == MUR
		&& Poziom->pole[x][y + 1] == MUR);
    } */
    wynik = mur_(x, y);
    switch (kierunek) {
    case 1:
	wynik *= mur_(x - 1, y) * mur_(x + 1, y);
	wynik *=
	    !(mur_(x, y - 1)) + mur_(x - 1, y - 1) * mur_(x + 1, y - 1);
	break;
    case 2:
	wynik *= mur_(x, y - 1) * mur_(x, y + 1);
	wynik *=
	    !(mur_(x + 1, y)) + mur_(x + 1, y - 1) * mur_(x + 1, y + 1);
	break;
    case 3:
	wynik *= mur_(x - 1, y) * mur_(x + 1, y);
	wynik *=
	    !(mur_(x, y + 1)) + mur_(x - 1, y + 1) * mur_(x + 1, y + 1);
	break;
    case 4:
	wynik *= mur_(x, y - 1) * mur_(x, y + 1);
	wynik *=
	    !(mur_(x - 1, y)) + mur_(x - 1, y - 1) * mur_(x - 1, y + 1);
	break;
    default:
	return 0;
    }
    return wynik;
}

int
korytarz(struct poziom *Poziom, int sx, int sy, int kierunek, int drzwi)
{
    int wynik = 0;
    int tmpx = sx, tmpy = sy, poczn = losowaoddo(4, 7), n = poczn, dx =
	0, dy = 0, koniec = 0;
    /* Umieszczenie wyjcia na pocztku korytarza */
    if (drzwi) {
	Poziom->pole[sx][sy] = wyjscie();
    }
    /* Przygotowanie zmiennych */
    switch (kierunek) {
    case 1:			/* N */
	dx = 0;
	dy = -1;
	break;
    case 2:			/* E */
	dx = 1;
	dy = 0;
	break;
    case 3:			/* S */
	dx = 0;
	dy = 1;
	break;
    case 4:			/* W */
	dx = -1;
	dy = 0;
	break;
    default:
	dodaj_napis("Zy parametr kierunek podany do korytarz()...");
	break;
    }
    /* Waciwe kopanie */
    while (!koniec) {
	tmpx += dx;
	tmpy += dy;
	n--;
	if (!mozna_postawic_pole(Poziom, tmpx, tmpy, kierunek)
	    || (poczn - n > 3 && losowa(100) > 90)) {
	    /* Skrcanie... */
	    int ndx, ndy;
	    int kier = 1 + kierunek % 2 + 2 * (losowaoddo(0, 1));
	    tmpx -= dx;
	    tmpy -= dy;
	    switch (kier) {
	    case 1:		/* N */
		ndx = 0;
		ndy = -1;
		break;
	    case 2:		/* E */
		ndx = 1;
		ndy = 0;
		break;
	    case 3:		/* S */
		ndx = 0;
		ndy = 1;
		break;
	    case 4:		/* W */
		ndx = -1;
		ndy = 0;
		break;
	    }
	    if (mozna_postawic_pole(Poziom, tmpx + ndx, tmpy + ndy, kier)) {
		wynik += korytarz(Poziom, tmpx + ndx, tmpy + ndy, kier, 0);
		Poziom->pole[tmpx + ndx][tmpy + ndy] = PODLOGA;
		ile_pol++;
	    } else {
		if (kier < 3) {
		    kier += 2;
		} else {
		    kier -= 2;
		}
		switch (kier) {
		case 1:	/* N */
		    ndx = 0;
		    ndy = -1;
		    break;
		case 2:	/* E */
		    ndx = 1;
		    ndy = 0;
		    break;
		case 3:	/* S */
		    ndx = 0;
		    ndy = 1;
		    break;
		case 4:	/* W */
		    ndx = -1;
		    ndy = 0;
		    break;
		}
		if (mozna_postawic_pole
		    (Poziom, tmpx + ndx, tmpy + ndy, kier)) {
		    wynik +=
			korytarz(Poziom, tmpx + ndx, tmpy + ndy, kier, 0);
		    Poziom->pole[tmpx + ndx][tmpy + ndy] = PODLOGA;
		    ile_pol++;
		}
	    }
	    koniec = 1;
	} else {
	    if (Poziom->pole[tmpx][tmpy] != MUR) {	/* Doszlimy do czego */
		koniec = 1;
		wynik = 1;
		break;
	    }

	    Poziom->pole[tmpx][tmpy] = PODLOGA;
	    ile_pol++;
	    if (n == 0) {	/* Koczy si korytarz, stawiamy pokj */
		if (tmpx > 4 && tmpy > 4 && tmpx < Poziom->maxx - 5
		    && tmpy < Poziom->maxy - 5)
		    if (pokoj(Poziom, tmpx, tmpy, tmpx + dx, tmpy + dy)) {
			Poziom->pole[tmpx][tmpy] = wyjscie();
			koniec = 1;
			wynik = 1;
		    }
	    }
	}
    }
    return wynik;
}

/* Rysuje lini (x1,y1)-(x2,y2) w kolorze kolor */
void
rysuj_linie(struct poziom *Poziom, int kolor, int x1, int y1, int x2,
	    int y2)
{
    int dx, dy, d, x, y, d1, d2, sx, sy, koniec;
    koniec = 0;
    dx = abs(x2 - x1);
    dy = abs(y2 - y1);
    if (x2 >= x1)
	sx = 1;
    else
	sx = -1;
    if (y2 >= y1)
	sy = 1;
    else
	sy = -1;
    x = x1;
    y = y1;
    if (dx >= dy) {
	d = 2 * dy - dx;
	d1 = 2 * dy;
	d2 = 2 * (dy - dx);
	Poziom->pole[x][y] = kolor;
	while (x != x2 && !koniec) {
	    if (d < 0) {
		d += d1;
		x += sx;
	    } else {
		x += sx;
		y += sy;
		d += d2;
	    }
	    Poziom->pole[x][y] = kolor;
	}
    } else {
	d = 2 * dx - dy;
	d1 = 2 * dx;
	d2 = 2 * (dx - dy);
	Poziom->pole[x][y] = kolor;
	while (y != y2 && !koniec) {
	    if (d < 0) {
		d += d1;
		y += sy;
	    } else {
		x += sx;
		y += sy;
		d += d2;
	    }
	    Poziom->pole[x][y] = kolor;
	}
    }
}
void generuj_tlo_ze_skladnikami(struct poziom *Poziom, int typ)
{
    int tmpx, tmpy, tmp;
    char tlo, skl1 = TRAWA, skl2, skl3, skl4;	/* Czyli co na to i jakie skadniki na to */
    int i1 = 0, i2 = 0, i3 = 0, i4 = 0;	/* I ile */
    int metoda = -1;		/* 0 - "troch tego, szczypt tamtego" 
				   1 - jaskinia */
    switch (typ) {
    case P_LAS:
	metoda = 0;
	tlo = TRAWA;
	skl1 = DRZEWO;
	i1 = 0.7 * (Poziom->maxx) * (Poziom->maxy);	/* 70% drzew */
/*XXX*/	dodaj_postac(losowa(Poziom->maxx), losowa(Poziom->maxy), PST_NIEDZWIEDZ, 0,
		     Poziom->poziom, &Poziom->Istoty);
	break;
    case P_POLA:
	metoda = 0;
	tlo = TRAWA;
	break;
    case P_WODA:
	metoda = 0;
	tlo = WODA;
	break;
    case P_SKALA:
	metoda = 0;
	tlo = MUR;
	break;
    case P_OST_JASKINIA:
    case P_JASKINIA:
	metoda = 1;
	tlo = MUR;
	break;
    default:
	metoda = 0;
	tlo = TRAWA;
	break;
    }
    /* To */
    if (metoda == 0 || metoda == 1) {
	for (tmpx = 0; tmpx < Poziom->maxx; tmpx++)
	    for (tmpy = 0; tmpy < Poziom->maxy; tmpy++) {
		Poziom->pole[tmpx][tmpy] = tlo;
		Poziom->znane[tmpx][tmpy] = 0;
                zajete[tmpx][tmpy] = '.';
	    }
    }
    /* Skadniki... */
    if (metoda == 0) {
	for (tmp = 0; tmp < i1; tmp++) {
	    tmpx = losowaoddo(0, Poziom->maxx - 1);
	    tmpy = losowaoddo(0, Poziom->maxy - 1);
	    Poziom->pole[tmpx][tmpy] = skl1;
	}
	for (tmp = 0; tmp < i2; tmp++) {
	    tmpx = losowaoddo(0, Poziom->maxx - 1);
	    tmpy = losowaoddo(0, Poziom->maxy - 1);
	    Poziom->pole[tmpx][tmpy] = skl2;
	}
	for (tmp = 0; tmp < i3; tmp++) {
	    tmpx = losowaoddo(0, Poziom->maxx - 1);
	    tmpy = losowaoddo(0, Poziom->maxy - 1);
	    Poziom->pole[tmpx][tmpy] = skl3;
	}
	for (tmp = 0; tmp < i4; tmp++) {
	    tmpx = losowaoddo(0, Poziom->maxx - 1);
	    tmpy = losowaoddo(0, Poziom->maxy - 1);
	    Poziom->pole[tmpx][tmpy] = skl4;
	}
    }
}

void generuj_podziemia(struct poziom *Poziom, int typ)
{
    int poksx, poksy, pokkx, pokky, razy = 0;
    if (typ != P_JASKINIA && typ != P_OST_JASKINIA) {
	return;
    }
    schx = Poziom->Istoty.poczatek->nast->x;
    schy = Poziom->Istoty.poczatek->nast->y;
    poksx = schx - losowa(8);
    if (poksx < 2)
	poksx = 2;
    poksy = schy - losowa(8);
    if (poksy < 2)
	poksy = 2;
    pokkx = schx + losowa(8);
    if (pokkx > Poziom->maxx - 2)
	pokkx = Poziom->maxx - 2;
    pokky = schy + losowa(8);
    if (pokky > Poziom->maxy - 2)
	pokky = Poziom->maxy - 2;
    do {
	wejscie = 1;
	if (typ == P_JASKINIA) {
	    zejscie = 0;
	} else {
	    zejscie = 1;
	}
	ile_pok = 0;
	if (razy) {
	    generuj_tlo_ze_skladnikami(Poziom, typ);
#ifdef DEBUG
	    dodaj_napis("Jeszcze raz... ");
#endif
	}
	razy++;
	ile_pol = 0;
	pokoj(Poziom, poksx, poksy, pokkx, pokky);
#ifdef DEBUG
	fprintf(stderr, "ile_pol: %d\n", ile_pol);
#endif
    }
    while (ile_pol < (Poziom->maxx * Poziom->maxy * 0.2));	//  (0);
}

void generuj_drogi(struct poziom *Poziom, int drogi)
{
    {
	int srx = Poziom->maxx / 2, sry = Poziom->maxy / 2;
	int kx = Poziom->maxx - 1, ky = Poziom->maxy - 1;
	if (drogi & 1) {	/* N */
	    rysuj_linie(Poziom, DROGA, srx, sry, srx, 0);
	}
	if (drogi & 2) {	/* W */
	    rysuj_linie(Poziom, DROGA, srx, sry, 0, sry);
	}
	if (drogi & 4) {	/* E */
	    rysuj_linie(Poziom, DROGA, srx, sry, kx, sry);
	}
	if (drogi & 8) {	/* S */
	    rysuj_linie(Poziom, DROGA, srx, sry, srx, ky);
	}

    }
}

void generuj(struct poziom *Poziom, int x, int y, int z)
{
    Poziom->maxx = swiat.pole[x][y][z].maxx;
    Poziom->maxy = swiat.pole[x][y][z].maxy;
    /* To */
    generuj_tlo_ze_skladnikami(Poziom, swiat.pole[x][y][z].typ);
    /* Jaskinie */
    generuj_podziemia(Poziom, swiat.pole[x][y][z].typ);
    /* Potwory */
    if (swiat.pole[x][y][z].flagi & GENEROWANE_POTWORY) {
	int ile_potw = losowaoddo(ile_pol / 20, ile_pol / 10);
	dodaj_potwory(Poziom, ile_potw, Poziom->poziom);
    }
    if (swiat.pole[x][y][z].flagi & GENEROWANE_PRZEDMIOTY)
	/* Przedmioty */
    {
	int ile_przedm = losowaoddo(10, 30);
	dodaj_przedmioty(Poziom, ile_przedm, Poziom->poziom);
    }
    /* No i puapki (na razie moe nie...) */
    {
	/* int ile_pulapek = losowaoddo (5*Poziom->poziom, 10*Poziom->poziom);
	   dodaj_pulapki (ile_pulapek); */
    }
    generuj_drogi(Poziom, swiat.pole[x][y][z].droga);
    return;
}


void tick_na_poziomie()
{
    int x = swiat.x, y = swiat.y, z = swiat.z;
    if (swiat.pole[x][y][z].flagi & PRZYBYWAJA_POTWORY) {
	if (!
	    ((++swiat.pole[x][y][z].gen_potw_l) %
	     swiat.pole[x][y][z].gen_potw_tur)) {
#ifdef DEBUG
	    dodaj_napis("Dodaj potwory... ");
#endif
	    swiat.pole[x][y][z].gen_potw_l = 0;
	    dodaj_potwory(&Poziom, losowa(3), Poziom.poziom);
	}
    }
}

int gr_zamknij(struct istota *Postac, struct poziom *Poziom)
{
    int koncz_runde = 1;
    char key;
    struct delta Delta;
    dodaj_napis(_("Gdzie? [1-9] "));
    key = pobierz_klawisz();
    pobierz_kierunek(key, &Delta);
    if ((Delta.x == NIE_KIERUNEK) || (Delta.x == 0 && Delta.y == 0))
	dodaj_napis(_("To chyba nie ten klawisz! "));
    else if (szukaj_postaci
	     (Postac->x + Delta.x,
	      Postac->y + Delta.y, &Poziom->Istoty) == ZNALAZL) {
	dodaj_napis(_("Nie moesz zamkn. "));

    } else {
	Poziom->Istoty.aktualny = Poziom->Istoty.poczatek->nast;
	switch (pole(Poziom, Postac->x + Delta.x, Postac->y + Delta.y)) {
	case DRZWI_ZAMKNIETE_NA_KLUCZ:
	    dodaj_napis(_("Te drzwi s juz zamkniete. "));
	    koncz_runde = 0;
	    break;
	case DRZWI_OTWARTE:
	    zamknij_drzwi(Poziom, Postac->x + Delta.x,
			  Postac->y + Delta.y);
	    dodaj_napis(_("Zamkne drzwi. "));
	    widocznosc(Poziom, Postac);
	    break;
	case DRZWI_ZAMKNIETE:
	    dodaj_napis(_("Te drzwi s juz zamkniete. "));
	    koncz_runde = 0;
	    break;
	default:
	    dodaj_napis(_("To nie s drzwi. "));
	    koncz_runde = 0;
	}
    }
    return koncz_runde;
}

int gr_otworz(struct istota *Postac, struct poziom *Poziom)
{
    int koncz_runde = 1;
    char key;
    struct delta Delta;
    dodaj_napis(_("Gdzie? [1-9] "));
    key = pobierz_klawisz();
    pobierz_kierunek(key, &Delta);
    if (Delta.x == NIE_KIERUNEK) {
	dodaj_napis(_("To chyba nie ten klawisz! "));
	koncz_runde = 0;
    } else
	switch (pole(Poziom, Postac->x + Delta.x, Postac->y + Delta.y)) {
	case DRZWI_OTWARTE:
	    dodaj_napis(_("Te drzwi s juz otwarte. "));
	    koncz_runde = 0;
	    break;
	case DRZWI_ZAMKNIETE_NA_KLUCZ:
	    dodaj_napis(_("Te drzwi s zamknite na klucz. "));
	    break;
	case DRZWI_ZAMKNIETE:
	    otworz_drzwi(Poziom, Postac->x + Delta.x, Postac->y + Delta.y);
	    dodaj_napis(_("Otworzye drzwi. "));
	    widocznosc(Poziom, Postac);
	    break;
	default:
	    dodaj_napis(_("To nie s drzwi. "));
	    koncz_runde = 0;
	}
    return koncz_runde;
}

struct delta szukaj_wolnego_lozka(struct poziom * Poz, int sx, int sy)
{
 struct delta wynik;
 int x = sx, y = sy, l, m,n;
 wynik.x=x; wynik.y=y;
 if (Poz->pole[x][y] == LOZKO) return wynik;
 for (l=1; l <= /* XXX */ 20; l++)
  for (m = 0; m<2; m++)
   for (n = 1; n<=l; n++)
     {
       int d = (l%2);
       if (!d) d--;
    if (m)  /* Poziomo */
     {
      x += d;
     } else { /* Pionowo */
      y += d;
     }
   if (Poz->pole[x][y] == LOZKO && zajete[x][y] == '.')
          {
            wynik.x=x; wynik.y=y;
#ifdef DEBUG
fprintf(stderr, "ko: %d, %d\n", x, y);
#endif
            return wynik;
            }
    }
#ifdef DEBUG
dodaj_napis("Nie znalazem wyrka. ");
#endif
 return wynik;
}
