/* poziom.h */
#ifndef poziom_h
#define poziom_h

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "structpoziom.h"
#include "ekran_dod.h"
#include "potwor.h"
#include "postac.h"
#include "structprzedmiotyID.h"
#include "io.h"
#include "swiat.h"
#include "czas.h"
#include "strefy.h"
#include "trasy.h"
#include "pulapki.h"
#include "rozne.h"


void tick_na_poziomie();

void laduj_poziom(struct _plik *plik, struct poziom *Poziom);

void zapisz_poziom(char *out, long int *ile, struct poziom *Poziom);

void init_terenow();

void init_fov();

void laduj_tereny(struct _plik *plik);

void zapisz_znane(char *out, long int *ile, struct poziom *Poziom);
void wczytaj_znane(struct _plik *plik, struct poziom *Poziom);
void rysuj_poziom(struct poziom *Poziom);

void rysuj_postacie(struct poziom *Poziom);

void rusz_postacie(struct poziom *Poziom);

/* Zmienia w pole[x][y] danego poziomy na warto "jak" */
void zmien_poziom(struct poziom *Poziom, int x, int y, int jak);

/* Zmiana wyswietlanego poziomu:
 * przedmioty, potwory, itp.
 * delta moe przyjmowa (oprcz normalnych wartoci (dx,dy)):
 * 2,0 : d
 * 3,0 : gra
 */
void zmien_aktualny_poziom(struct poziom *Poziom, struct delta delta);

/* Zwraca pole[x][y] */
int pole(struct poziom *Poziom, int x, int y);

void poznaj_pole(struct poziom *Poziom, int x, int y,
		 struct istota *Postac);

int sprawdz_widocznosc(struct poziom *Poziom, int x, int y);

/* Poznaje najblisze otoczenie Postaci */
void poznaj_otoczenie(struct poziom *Poziom, struct istota *Postac);

void otworz_drzwi(struct poziom *Poziom, int x, int y);

void zamknij_drzwi(struct poziom *Poziom, int x, int y);

void poznaj_caly(struct poziom *Poziom);

void poznaj_linie(struct poziom *Poziom, struct istota *Postac, int x1,
		  int y1, int x2, int y2);

void poznaj(struct poziom *Poziom, struct istota *Postac);

/* Wrapper do mozna_wejsc (uwzgldnia zamknite drzwi oraz wejcia i zejcia) */
short int czy_mozna_wygenerowac(struct poziom *Poziom, int x, int y,
				struct istota *Postac);

/* Wrapper do mozna_wejsc, uwzgldniajcy te, czy pole to nie jest zajte przez * jak istot */
short int czy_mozna_wejsc(struct poziom *Poziom, int x, int y,
			  struct istota *Postac);

/* Zwraca 1, jeeli mona wej na pole[x][y] */
short int mozna_wejsc(struct poziom *Poziom, int x, int y,
		      struct istota *Postac);

/* Podaje dx i dy szukanego pola wzgldem (x,y) (albo -3,-3, jeeli nie znajdzie) */
struct delta szukaj_pola(struct poziom *Poziom, int jakiego, int x, int y);

/* Opisuje pole poziomu */
void opisz_kratke(struct poziom *Pz, int x, int y);

/* Dodaje ile potworw o poziom_t poziomie trudnoci */
void dodaj_potwory(struct poziom *Poziom, int ile, int poziom_t);

/* Dodaje ile przedmiotw o poziom_t poziomie trudnoci */
void dodaj_przedmioty(struct poziom *Poziom, int ile, int poziom_t);

/* Generuje poziom o parametrach opisanych w swiat.pole[x][y] */
void generuj(struct poziom *Poziom, int x, int y, int z);

int korytarz(struct poziom *Poziom, int sx, int sy, int kierunek,
	     int drzwi);
int gr_zamknij(struct istota *Postac, struct poziom *Poziom);
int gr_otworz(struct istota *Postac, struct poziom *Poziom);
struct delta szukaj_wolnego_lozka(struct poziom * Poz, int sx, int sy);
#endif
