/* strefy.h
 *
 * Strefy znajdujce si na poziomie, np. sklepy */

#ifndef STREFY_H
#define STREFY_H
#include "config.h"
#include "structpoziom.h"
#include "structpostac.h"
#include "io.h"
#ifndef fake_h
#include "przedmioty.h"
#endif

#include "strefyconst.h"

struct _strefa {
    int typ;			/* np. SKLEP */
    int podtyp;			/* np. typ sklepu */
    int sx, sy, kx, ky;		/* Wsprzdne rogw prostokta */
    wsk_istota Istota;		/* Istota zwizana ze stref (np. sklepikarz) */
    int licznik;		/* Do wykorzystania zalenie od typu strefy 
				   (np. w SKLEPie ilo przedmiotw, za ktre nie zapacono) */
    int numer;			/* np. indeks w tablicy sklepw */
} strefa[MAX_STREF];

int str_ist[MAXPOTW];		/* Tablica czce kolejne potwory (nie liczc gracza!) z odpowiednimi strefami (-1 - nie dotyczy) */

struct strefa_IO {
    int typ;
    int podtyp;
    int sx, sy, kx, ky;
    int Istota;
    int licznik;
    int pierwszy_raz;
};

struct _sklep {
    int numer_strefy;		/* Numer strefy ktr jest sklep */
    int ile_towarow;
    wskaznik_przedmiot towar[MAXTOWAR];
} sklep[MAXSKLEP];

int ile_sklepow;

/* Zwraca numery stref, w ktrych znajduje si dany wsprzdnymi punkt */
int *strefy(int x, int y, int *wynik);

void wyczysc_strefy();

short int czy_jest_w_strefie(int typ, int x, int y);

/* Zwraca numer strefy danego typu w ktrej znajduje si punkt (x,y) */
int numer_strefy(int typ, int x, int y);

/* Zwraca numer strefy, z ktr zwizana jest "do_kogo" */
int numer_strefy_naleznej(wsk_istota do_kogo);

struct delta szukaj_strefy(int numer_strefy, int x, int y);

void wczytaj_strefy(struct _plik *in);
void zapisz_strefy(char *out, long int *ile);

int numer_w_sklepie(int numer_sklepu, wskaznik_przedmiot Towar);

void init_strefy(int i);
#endif
