/*  EDYTOR POZIOMW */
#define NOCOMP
#include <strings.h>
#include <math.h>

#include "config.h"
#include "fake.h"
#include "przedmioty.h"
#include "rozne.h"
#include "poziom.h"
#include "postac.h"
#include "io.h"
FILE *in, *out;

int koniec;
int kolor;
int pisak;
int old;
int blok, blokx, bloky, los, gest;
struct istota kursor;

void _init_()
{
    initscr();
    pisak = 0;
    przerysuj = 1;
    blok = 0;
    los = 0;
    old = 0;
    gest = 50;
    wGora = newwin(1, COLS, 0, 0);
    wPoziom = newwin(LINES - 1, COLS, 1, 0);
    scrollok(wGora, 0);
    scrollok(wPoziom, 0);
    cbreak();
    noecho();
    keypad(stdscr, TRUE);
    intrflush(stdscr, FALSE);
    nonl();
    if (has_colors()) {
	start_color();
    }
    init_pair(1, COLOR_GREEN, COLOR_BLACK);
    init_pair(2, COLOR_BLUE, COLOR_BLACK);
    init_pair(3, COLOR_YELLOW, COLOR_BLACK);
    init_pair(4, COLOR_WHITE, COLOR_BLACK);

    kursor.x = 1;
    kursor.y = 1;
    kursor.zasieg_widzenia = 5;
    if (old) {
	laduj_poziom_old(in, &Poziom);
    } else {
	laduj_poziom(in, &Poziom);
    }
    Poziom.sx = Poziom.sy = 0;
    if (Poziom.maxx > 78) {
	Poziom.kx = 79;
    } else {
	Poziom.kx = Poziom.maxx;
    }
    if (Poziom.maxy > 21) {
	Poziom.ky = 22;
    } else {
	Poziom.ky = Poziom.maxy;
    }
}

void rysuj_kursor(struct istota Istota, struct poziom *Poziom)
{
    wmove(wPoziom, Istota.y - Poziom->sy, Istota.x - Poziom->sx);

}

void
przesun_postac(struct istota *Postac, struct poziom *Poziom, int dx,
	       int dy)
{
    int doc_x, doc_y;
    doc_x = Postac->x + dx;
    doc_y = Postac->y + dy;
    if ((doc_x >= 0) && (doc_y >= 0))
	if ((doc_x < (Poziom->maxx)) && (doc_y < (Poziom->maxy))) {
	    Postac->x += dx;
	    Postac->y += dy;	//to patrzy, czy trzeba przesun:

	    if ((Poziom->sx > 0)
		&& ((Postac->x - Poziom->sx) <
		    (Postac->zasieg_widzenia + 4))) {
		Poziom->sx = Poziom->sx - 1;
		Poziom->kx = Poziom->kx - 1;
	    }
	    if ((Poziom->kx < Poziom->maxx - 1)
		&& ((Poziom->kx - Postac->x) <
		    (Postac->zasieg_widzenia + 4))) {
		Poziom->sx = Poziom->sx + 1;
		Poziom->kx = Poziom->kx + 1;
	    }
	    if ((Poziom->sy > 0)
		&& ((Postac->y - Poziom->sy) <
		    (Postac->zasieg_widzenia + 4))) {
		Poziom->sy = Poziom->sy - 1;
		Poziom->ky = Poziom->ky - 1;
	    }
	    if ((Poziom->ky < Poziom->maxy - 1)
		&& ((Poziom->ky - Postac->y) <
		    (Postac->zasieg_widzenia + 4))) {
		Poziom->sy = Poziom->sy + 1;
		Poziom->ky = Poziom->ky + 1;
	    }

	}
}

void ruch_kursora(struct istota *Postac, struct poziom *Poziom)
{
    int key;
    key = getch();
    switch (key) {
    case 'q':
	koniec = 1;
	break;
    case 'P':
	if (!blok)
	    pisak = !pisak;
	break;
    case 'L':
	los = !los;
	break;
    case ']':
	gest++;
	break;
    case '[':
	gest--;
	break;
    case 'B':
	if (!blok) {
	    pisak = 0;
	    blokx = Postac->x;
	    bloky = Postac->y;
	    blok = 1;
	} else {
	    int tmpx, tmpy, sx, kx, sy, ky;
	    if (blokx < Postac->x) {
		sx = blokx;
		kx = Postac->x;
	    } else {
		sx = Postac->x;
		kx = blokx;
	    }
	    if (bloky < Postac->y) {
		sy = bloky;
		ky = Postac->y;
	    } else {
		sy = Postac->y;
		ky = bloky;
	    }
	    for (tmpx = sx; tmpx <= kx; tmpx++)
		for (tmpy = sy; tmpy <= ky; tmpy++) {
		    if (los) {
			if (losowa(100) <= gest)
			    Poziom->pole[tmpx][tmpy] = kolor;
		    } else {
			Poziom->pole[tmpx][tmpy] = kolor;
		    }
		}
	    blok = 0;
	}
	break;
    case '7':
	przesun_postac(Postac, Poziom, -1, -1);
	break;
    case '8':
	przesun_postac(Postac, Poziom, 0, -1);
	break;
    case '9':
	przesun_postac(Postac, Poziom, 1, -1);
	break;
    case '4':
	przesun_postac(Postac, Poziom, -1, 0);
	break;
    case '6':
	przesun_postac(Postac, Poziom, 1, 0);
	break;
    case '1':
	przesun_postac(Postac, Poziom, -1, 1);
	break;
    case '2':
	przesun_postac(Postac, Poziom, 0, 1);
	break;
    case '3':
	przesun_postac(Postac, Poziom, 1, 1);
	break;
    case 13:
	break;
    default:
	// Poziom->pole[Postac->x-1][Postac->y-1]=key;
	kolor = tlumacz_char_na_int(key);
    }

//  Poziom->pole[(Postac->x)-1][(Postac->y)-1]=kolor;
}

int main(int argc, char *argv[])
{
/*  int x, y; */
    char wejscie[50], wyjscie[50];
    if (argc > 1) {
	strcpy(wejscie, argv[1]);
    } else {
	strcpy(wejscie, LIBDIR "/in");
    }
    if (argc > 2) {
	strcpy(wyjscie, argv[2]);
    } else {
	strcpy(wyjscie, LIBDIR "/out");
    }
    if (argc > 3) {
	old = 1;
    }
    if ((in = fopen(wejscie, "rb")) == NULL) {
	printf(_("Nie mog otworzy pliku wejciowego!\n"));
	exit(1);
    }
    out = fopen(wyjscie, "wb");
    _init_();
    poznaj_caly(&Poziom);
    koniec = 0;
    kolor = '.';
    while (!koniec) {
	rysuj_poziom(&Poziom);
	rysuj_kursor(kursor, &Poziom);
	wclear(wGora);
	zmien_kolor(K_BIALY, wGora);
	wprintw(wGora, "x: %d y: %d ", kursor.x, kursor.y);
	if (pisak)
	    wprintw(wGora, "#");
	if (los)
	    wprintw(wGora, "L(%d) ", gest);
	if (blok)
	    wprintw(wGora, "B ");
	else
	    wprintw(wGora, "  ");
	wprintw(wGora, "(");
	wyswietl_kratke(kolor);
	zmien_kolor(K_BIALY, wGora);
	wprintw(wGora, ")");
	wrefresh(wGora);
	if (przerysuj) {
	    wrefresh(wPoziom);
	    przerysuj = 0;
	}
	ruch_kursora(&kursor, &Poziom);
	if (pisak)
	    zmien_poziom(&Poziom, kursor.x, kursor.y, kolor);
	przerysuj = 1;
    }
    clear();
    refresh();
    endwin();
    zapisz_poziom(out, &Poziom);
    return 0;
}
