/* join.c
 * czy pliki z danymi w jeden lib.data */
#define NOCOMP
#include "io.h"
#include "fake.h"
#include <zlib.h>

FILE *data;
FILE *plik;
struct __tablica Tablica;
char dupka[MAXTAB], dup_compr[MAXTAB];


void dodaj(char *nazwa_pliku, char *sygnaturka)
{
    long int ile, ile_compr, blad;
    if ((plik = fopen(nazwa_pliku, "rb")) == NULL) {
	fprintf(stderr, _("\nNie mog otworzy %s.\n"), nazwa_pliku);
	exit(1);
    }
    rewind(plik);
    ile = 0;
    do {
	dupka[ile] = fgetc(plik);
	ile++;
    }
    while (!feof(plik));
    blad = compress(dup_compr, &ile_compr, dupka, ile);
    if (blad != Z_OK) {
	fprintf(stderr, _("Bd przy kompresji %s (%ld)!\n"), sygnaturka,
		blad);
	exit(1);
    }
    Tablica.wielkosc_comp = ile_compr;
    Tablica.wielkosc = ile;
    strcpy(Tablica.ID, sygnaturka);
    Tablica.offset = ftell(data) + sizeof(Tablica);
    fwrite(&Tablica, sizeof(Tablica), 1, data);
    fwrite(dup_compr, ile_compr, 1, data);
    fclose(plik);
}

int main()
{
    int ile_dupkowate = 0;
/* XXX _Potrzebne_ s dwa bufory, bo inaczej nie mona uy parser_string w jednej linijce */
    char buf1[1000], buf2[1000];
    if ((data = fopen("./lib.data", "wb")) == NULL) {
	fprintf(stderr, _("\nNie mog otworzy ./lib.data\n"));
	exit(1);
    }
    fwrite(&ile_dupkowate, sizeof (int), 1, data);	
    if (!init_parser("./lib/pliki")) {
	fprintf(stderr, _("\nNie mog otworzy ./lib/pliki.\n"));
	exit(1);
    }
    while (!ustaw_kawalek("{", "}")) {
	dodaj(parser_string(buf1, "Pl:", 1, ""),
	      parser_string(buf2, "Syg:", 1, ""));
	printf(".");
	ile_dupkowate++;
    }
    printf("\n");
    fseek(data, 0, SEEK_SET);
    fwrite(&ile_dupkowate, sizeof (int), 1, data);	
    fclose(data);
    return 0;
}
